//MainForm
#include "AsmForm.h"

#include "..\PictureToAsm\PictureToAsmForm.h"
#include "AsmFormParams.h"
extern PictureToAsm* PictureToAsmForm;

AsmForm::AsmForm(HWND Owner,int Resource){
	//CreateSpecial("ASSEMBLER",50,50,205,450,1);
	clist=NULL;
	CreateDialogBox(Owner,Resource);
	STX=50;
	STY=50;
	WID=205;
	HEI=450;
	
//user code here	
	u="";
	loaded=0;
	SuccessMsgEnabled=1;
	Success=0;
	Memo1=NULL;
	FailedLineNum=0;
	//ObjFileGenerated=0;
	beforePeriph=1;
	fgenHEX=0;
	fgenOBJ=0;
	multipages=0;
}

AsmForm::~AsmForm(){
//user code here

    //DestroyForm();
}

//Build up form
void AsmForm::BuildForm(HWND hwnd,HINSTANCE hInst){	
	CreateGrElem( Label,  Label1 );
	CreateGrElem( Memo,   Memo1 );
	CreateGrElem( Button, Button1 );
	CreateGrElem( Button, Button2 );
	CreateGrElem( Button, Button3 );
	
	if(Memo1)Memo1->ReadOnly(true);
	OpenDialog1=new TOpenDialog(hwnd);
	
	Success=0;
	if(clist){
		if(Memo1)Memo1->LoadText(clist);
	}
}

//Destroy form
void AsmForm::DestroyForm(){
    delete Label1  ;
	delete Memo1;
	Memo1=NULL;
	delete Button1;
	delete Button2;
	delete Button3;
	delete OpenDialog1;
	loaded=0;
}

void AsmForm::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
	REGCALLBK(Button3) Button3Click();

}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
//OPEN
void  AsmForm::Button1Click()
{
	OpenDialog1->Filter="ASSEMBLY source file (*.asm)\0*.ASM";
	if(OpenDialog1->Execute()){
		INPUTfile=OpenDialog1->FileName;
		DESTfile=ExtractFilePath(INPUTfile);
		AnsiString fname=ExtractFileName(INPUTfile);
		fname=ChangeFileExt(fname,"BIN");
		DESTfile=DESTfile+fname;
		OBJfile=ChangeFileExt(DESTfile,"OBJ");
		if(Memo1){
			Memo1->Lines->Clear();
			Memo1->Lines->LoadFromFile(INPUTfile);
		}
		loaded=1;
		
		if(clist){
			clist->Clear();
			clist->LoadFromFile(INPUTfile);
		}
	}

}
//---------------------------------------------------------------------------

//ASSEMBLE
void  AsmForm::Button2Click()
{
	Button1->Enabled=false;
	Button2->Enabled=false;
	Assemble();
	Button1->Enabled=true;
	Button2->Enabled=true;
}

//ASSEMBLE
void  AsmForm::Assemble()
{
	//ObjFileGenerated=0;
	if(!loaded){
		ShowMessage("Nothing is loaded !");
		return;
	}
	
	unsigned int x,y,w;
	AnsiString s,z,label,label2;
	int pos;

	/*
	if(!clist){
		clist=new(TStringList);
		clist->LoadFromFile(INPUTfile);
	}
	*/
	
	multipages=0;

	//PREPROCESSOR for CALL, and subroutines
	clist->Insert((long)0,"");
	int proc;
	int van,labelnum=0,labelnum2=0;
	for(x=0;x<clist->Count;x++){
		s=clist->Strings[x];
		pos=s.AnsiPos("CALL");
		if(pos==1){
			s.Delete(1,5);
			proc=0;
			van=0;
			for(y=0;y<clist->Count;y++){
				z=clist->Strings[y];
				pos=z.AnsiPos("#PROC");
				if(pos==1){
					z.Delete(1,6);
					if(!z.AnsiCompare(s) ){
						if(proc){
							ShowMessage(u+"ERROR: subroutine defined more than once: "+z);ErrorMsg("ERROR");
							return;
						}
						proc=1;van=1;
						clist->Insert(x,"  "); if(y>=x)y++;
						clist->Strings[x]=u+"JMP PROC_"+z;
						label2.Sprintf("label_call_%d",labelnum2++);
						clist->Strings[x+1]=label2+":";
					}
				}
				pos=z.AnsiPos("#END");
				if(pos==1){
					if(proc){
						proc=0;
						break;
					}
				}
				if(proc){
					pos=z.AnsiPos("RET");
					if(pos==1){
						label.Sprintf("label_ret_%d",labelnum);
						labelnum++;
						clist->Strings[y]=label+": JMP 0x0000";
						clist->Insert(x,u+"STA ["+label+"+3]"); if(y>=x)y++;
						clist->Insert(x,u+"MVI A,[HIGH "+label2+"]"); if(y>=x)y++;
						clist->Insert(x,u+"STA ["+label+"+2]"); if(y>=x)y++;
						clist->Insert(x,u+"MVI A,[LOW "+label2+"]"); if(y>=x)y++;
					}else{
						pos=z.AnsiPos("label_ret_");
						if(pos==1){
							pos=z.AnsiPos(" ");
							label=z.SubString(1,pos-2);
							clist->Insert(x,u+"STA ["+label+"+3]"); if(y>=x)y++;
							clist->Insert(x,u+"MVI A,[HIGH "+label2+"]"); if(y>=x)y++;
							clist->Insert(x,u+"STA ["+label+"+2]"); if(y>=x)y++;
							clist->Insert(x,u+"MVI A,[LOW "+label2+"]"); if(y>=x)y++;
						}
					}
				}
			}
			for(y=0;y<clist->Count;y++){
				z=clist->Strings[y];			
				pos=z.AnsiPos("_label_ret_");
				if(pos==1){
					z.Delete(1,1);
                	clist->Strings[y]=z;
				}
			}
			if(!van){
				ShowMessage(u+"ERROR: CALL subroutine does not exist: "+s);ErrorMsg("ERROR");
				return;
			}
			if(proc){
				ShowMessage(u+"ERROR: '#PROC' has no '#END' pair: "+s);ErrorMsg("ERROR");
				return;
			}
			x=0;
		}
	}

	for(x=0;x<clist->Count;x++){
		s=clist->Strings[x];
		pos=s.AnsiPos("#PROC");
		if(pos==1){
			s.Delete(1,6);
			clist->Strings[x]=u+"PROC_"+s+":";
		}
		pos=s.AnsiPos("#END");
		if(pos==1){
			clist->Strings[x]="";
		}
		pos=s.AnsiPos("RET");
		if(pos==1){
			ShowMessage("ERROR: RET without #PROC");ErrorMsg("ERROR");
			return;
		}
	}

	labelnum=0;
	//PREPROCESSOR for INC,DEC,INX,DCX,CMP,CPI,CMPX,CPIX
	for(x=0;x<clist->Count;x++){
		s=clist->Strings[x];
		if( (pos=s.AnsiPos("INC")) ==1){
			switch(s[5] ){
				case 'B':	z="B";
					break;
				case 'C':	z="C";
					break;
				case 'D':	z="D";
					break;
				case 'E':	z="E";
					break;
				case 'H':	z="H";
					break;
				case 'L':	z="L";
					break;
				default:
					ShowMessage("ERROR (preprocessor): invalid INC");ErrorMsg("ERROR");
					return;
					break;
			}
			clist->Strings[x]=u+"MOV "+z+",A";
			clist->Insert(x,u+"ADD "+z);
			clist->Insert(x,"MVI A,0x01");

			x=0;continue;
		}
		if( (pos=s.AnsiPos("DEC")) ==1){
			switch(s[5] ){
				case 'B':	z="B";
					break;
				case 'C':	z="C";
					break;
				case 'D':	z="D";
					break;
				case 'E':	z="E";
					break;
				case 'H':	z="H";
					break;
				case 'L':	z="L";
					break;
				default:
					ShowMessage("ERROR (preprocessor): invalid DEC");ErrorMsg("ERROR");
					return;
					break;
			}
			clist->Strings[x]=u+"MOV "+z+",A";
			clist->Insert(x,u+"SUB "+z);
			clist->Insert(x,u+"MVI "+z+",0x01");
			clist->Insert(x,u+"MOV A,"+z);			

			x=0;continue;
		}
		if( (pos=s.AnsiPos("INX")) ==1){
			s.Delete(1,4);
			if(!s.AnsiCompare("BC")){
				clist->Strings[x]="MOV B,A";
				clist->Insert(x,"ADC B");
				clist->Insert(x,"MVI A,0x00");
				clist->Insert(x,"MOV C,A");
				clist->Insert(x,"ADD C");
				clist->Insert(x,"MVI A,0x01");
			}else if(!s.AnsiCompare("DE")){
				clist->Strings[x]="MOV D,A";
				clist->Insert(x,"ADC D");
				clist->Insert(x,"MVI A,0x00");
				clist->Insert(x,"MOV E,A");
				clist->Insert(x,"ADD E");
				clist->Insert(x,"MVI A,0x01");
			}else if(!s.AnsiCompare("HL")){
				clist->Strings[x]="MOV H,A";
				clist->Insert(x,"ADC H");
				clist->Insert(x,"MVI A,0x00");
				clist->Insert(x,"MOV L,A");
				clist->Insert(x,"ADD L");
				clist->Insert(x,"MVI A,0x01");
			}else{
				ShowMessage("ERROR (preprocessor): invalid INX");ErrorMsg("ERROR");
				return;
			}
			x=0;continue;
		}
		if( (pos=s.AnsiPos("DCX")) ==1){
			s.Delete(1,4);
			if(!s.AnsiCompare("BC")){
				clist->Strings[x]="MOV B,A";
				clist->Insert(x,"SBB B");
				clist->Insert(x,"MVI B,0x00");
				clist->Insert(x,"MOV A,B");
				clist->Insert(x,"MOV C,A");
				clist->Insert(x,"SUB C");
				clist->Insert(x,"MVI C,0x01");
				clist->Insert(x,"MOV A,C");
			}else if(!s.AnsiCompare("DE")){
				clist->Strings[x]="MOV D,A";
				clist->Insert(x,"SBB D");
				clist->Insert(x,"MVI D,0x00");
				clist->Insert(x,"MOV A,D");
				clist->Insert(x,"MOV E,A");
				clist->Insert(x,"SUB E");
				clist->Insert(x,"MVI E,0x01");
				clist->Insert(x,"MOV A,E");
			}else if(!s.AnsiCompare("HL")){
				clist->Strings[x]="MOV H,A";
				clist->Insert(x,"SBB H");
				clist->Insert(x,"MVI H,0x00");
				clist->Insert(x,"MOV A,H");
				clist->Insert(x,"MOV L,A");
				clist->Insert(x,"SUB L");
				clist->Insert(x,"MVI L,0x01");
				clist->Insert(x,"MOV A,L");
			}else{
				ShowMessage("ERROR (preprocessor): invalid DCX");ErrorMsg("ERROR");
				return;
			}
			x=0;continue;
		}
		if( (pos=s.AnsiPos("CMPX")) ==1){
			s.Delete(1,5);
			if(s[3]!=','){
				ShowMessage("ERROR (preprocessor): invalid CMPX");ErrorMsg("ERROR");
				return;
			}
			z=s.SubString(1,2);
			s.Delete(1,3);
			if( (z.AnsiCompare("BC"))&&(z.AnsiCompare("DE"))&&(z.AnsiCompare("HL")) ){
				ShowMessage("ERROR (preprocessor): invalid CMPX");ErrorMsg("ERROR");
				return;
			}
			if( (!s.AnsiCompare("BC"))||(!s.AnsiCompare("DE"))||(!s.AnsiCompare("HL")) ){
				w=1;
			}else if( (s.Length()==6)&&(s[1]=='0')&&(s[2]=='x') ){
				w=2;
			}else{
				ShowMessage("ERROR (preprocessor): invalid CMPX");ErrorMsg("ERROR");
				return;
			}
			label.Sprintf("cmplabel_%d",labelnum++);
			clist->Strings[x]=label+":";
			clist->Insert(x,u+"SUB "+z.SubString(2,1));
			if(w==1){
				clist->Insert(x,u+"MOV A,"+s.SubString(2,1));
			}else{
				clist->Insert(x,u+"MVI A,0x"+s.SubString(5,2));
			}
			clist->Insert(x,u+"JNZ "+label);
			clist->Insert(x,u+"SUB "+z.SubString(1,1));
			if(w==1){
				clist->Insert(x,u+"MOV A,"+s.SubString(1,1));
			}else{
				clist->Insert(x,u+"MVI A,0x"+s.SubString(3,2));
			}
			x=0;continue;
		}
		if( (pos=s.AnsiPos("CMP")) ==1){
			s.Delete(1,4);
			if(s[2]!=','){
				ShowMessage("ERROR (preprocessor): invalid CMP");ErrorMsg("ERROR");
				return;
			}
			z=s.SubString(1,1);
			s.Delete(1,2);
			clist->Strings[x]=u+"SUB "+z;
			if((z[1]!='A')&&(z[1]!='B')&&(z[1]!='C')&&(z[1]!='D')&&(z[1]!='E')&&(z[1]!='H')&&(z[1]!='L')){
				ShowMessage("ERROR (preprocessor): invalid CMP");ErrorMsg("ERROR");
				return;
			}
			if((s[1]=='A')||(s[1]=='B')||(s[1]=='C')||(s[1]=='D')||(s[1]=='E')||(s[1]=='H')||(s[1]=='L')){
				clist->Insert(x,u+"MOV A,"+s);
			}else{
				clist->Insert(x,u+"MVI A,"+s);
			}
			x=0;continue;
		}
		if( (pos=s.AnsiPos("SPHL")) ==1){
			clist->Strings[x]="STA [0xFFFE]";
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"STA [0xFFFF]");
			clist->Insert(x,"MOV A,L");
			x=0;continue;
		}
		if( (pos=s.AnsiPos("PUSH")) ==1){//PUSH B,C,D,E
			clist->Strings[x]="STA [0xFFFE]";
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"STA [0xFFFF]");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV H,A");	//X
			clist->Insert(x,"SBB H");
			clist->Insert(x,"MVI H,0x00");
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"SUB L");
			clist->Insert(x,"MVI L,0x01");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV M,E");

			clist->Insert(x,"MOV H,A");	//X
			clist->Insert(x,"SBB H");
			clist->Insert(x,"MVI H,0x00");
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"SUB L");
			clist->Insert(x,"MVI L,0x01");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV M,D");

			clist->Insert(x,"MOV H,A");	//X
			clist->Insert(x,"SBB H");
			clist->Insert(x,"MVI H,0x00");
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"SUB L");
			clist->Insert(x,"MVI L,0x01");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV M,C");

			clist->Insert(x,"MOV H,A");	//X
			clist->Insert(x,"SBB H");
			clist->Insert(x,"MVI H,0x00");
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"SUB L");
			clist->Insert(x,"MVI L,0x01");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV M,B");

			clist->Insert(x,"MOV H,A");
			clist->Insert(x,"LDA [0xFFFE]");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"LDA [0xFFFF]");

			x=0;continue;
		}
		if( (pos=s.AnsiPos("POP")) ==1){//POP B,C,D,E
			clist->Strings[x]="STA [0xFFFE]";
			clist->Insert(x,"MOV A,H");
			clist->Insert(x,"STA [0xFFFF]");
			clist->Insert(x,"MOV A,L");

			clist->Insert(x,"MOV B,M");

			clist->Insert(x,"MOV H,A");	//W
			clist->Insert(x,"ADC H");
			clist->Insert(x,"MVI A,0x00");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"ADD L");
			clist->Insert(x,"MVI A,0x01");

			clist->Insert(x,"MOV C,M");

			clist->Insert(x,"MOV H,A");	//W
			clist->Insert(x,"ADC H");
			clist->Insert(x,"MVI A,0x00");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"ADD L");
			clist->Insert(x,"MVI A,0x01");

			clist->Insert(x,"MOV D,M");

			clist->Insert(x,"MOV H,A");	//W
			clist->Insert(x,"ADC H");
			clist->Insert(x,"MVI A,0x00");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"ADD L");
			clist->Insert(x,"MVI A,0x01");

			clist->Insert(x,"MOV E,M");

			clist->Insert(x,"MOV H,A");	//W
			clist->Insert(x,"ADC H");
			clist->Insert(x,"MVI A,0x00");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"ADD L");
			clist->Insert(x,"MVI A,0x01");

			clist->Insert(x,"MOV H,A");
			clist->Insert(x,"LDA [0xFFFE]");
			clist->Insert(x,"MOV L,A");
			clist->Insert(x,"LDA [0xFFFF]");

			x=0;continue;
		}
		if( (pos=s.AnsiPos("GENOBJ")) ==1){//GENOBJ - enable generate OBJ
			fgenOBJ=1;
		}
		if( (pos=s.AnsiPos("MPAGES")) ==1){//MPAGES - enable use multipages over 64kB code
			multipages=1;
			clist->Strings[x]=";MPAGES";
		}
		
	}

	//PREPROCESSOR for DB "string"
	int sx;
	int cl;
	for(x=0;x<clist->Count;x++){
		s=clist->Strings[x];
		if( (pos=s.AnsiPos("DB")) ==1){
			for(sx=1;sx<s.Length();sx++){
				if(s[sx]=='"'){
					z=s.SubString(1,sx-1);
					sx++;
					while( (s[sx]!='"') && (sx<s.Length()) ){
						cl=s[sx];
						label.Sprintf("%d,",cl);
						z=z+label;
						sx++;
					}
					label=s.Delete(1,sx+1);
					s=z+label;
				}
			}

		clist->Strings[x]=s;

		}
	}

	//SAVE preprocessed ASM file to OBJ file
	if(fgenOBJ){
		clist->SaveToFile(OBJfile);
		//ObjFileGenerated=1;
	}
	if(Memo1&&SuccessMsgEnabled){
		Memo1->Clear();
		Memo1->LoadText(clist);
	}

	//COMPILING
	PC=0;
	PAG=0;
	PM.SetPage(0);
	//PM=new(unsigned char[MAXCODE]);
	//for(x=0;x<MAXLAB;x++)LAB[x]=NULL;
	//pLAB=0;
	LAB=new TStringLongIntList();
	if(multipages){
		JumpTab=new TStringLongIntList();
		DataRel=new TStringLongIntList();
	}else{
		JumpTab=NULL;
		DataRel=NULL;
	}
	error=0;

	//AsmPhase=0 - cimszmitsi ciklus
	//AsmPhase=1 - behelyettesitsi ciklus
	PClastpag=0;
	jmptabSt=0;jmptabEnd=0;
	for(AsmPhase=0;AsmPhase<2;AsmPhase++){
		PC=0;PAG=0;
		PM.SetPage(0);
		beforePeriph=1;
		fixpag=0;
		for(memoline=0;memoline<clist->Count;memoline++){
			s=clist->Strings[memoline];
			if(s.IsEmpty())continue;
			while( (!s.IsEmpty()) && ( (s[1]==' ')||(s[1]=='\t') ) )s.Delete(1,1);
			if(s.IsEmpty())continue;
			for(y=1;y<=s.Length();y++){
				if(s[y]==';'){
					s=s.SubString(1,y-1);
					break;
				}
			}
			for(y=1;y<=s.Length();y++){
				if(s[y]==':'){
					label=s.SubString(1,y-1);
					//PROCESS LABEL
					if(AsmPhase==0){
						LAB->Add(label,PAG,PC);
						/*
						LAB[pLAB]=new(labels);
						LAB[pLAB]->addr=PC;
						LAB[pLAB]->name=label;
						pLAB++;
						if(pLAB>=MAXLAB){
							ErrorMsg("ERROR: Label stack overflow, too much labels");
							return;
						}
						*/
					}
					//PROCESS remaining command part if exists
					s.Delete(1,y);
					while( !s.IsEmpty() && ( (s[1]==' ')||(s[1]=='\t') ) )s.Delete(1,1);
					break;
				}
			}

			while( !s.IsEmpty() &&  ((s[s.Length()]==' ')||(s[s.Length()]=='\t'))  )  s.Delete(s.Length(),1);
			if((!s.IsEmpty())&&(!error))AsmCode(s);
			if(error)break;

		}
		//check if label exists twice
		if(!AsmPhase){
			for(x=0;x<LAB->Count;x++)
				for(y=0;y<LAB->Count;y++){
					if(x!=y)
						if(!LAB->Strings[x].AnsiCompare(LAB->Strings[y] ) ){
							ShowMessage(u+"ERROR: label exist more than once: '"+LAB->Strings[x]+"'");
							memoline=0;
							ErrorMsg("ERROR");
							return;
						}
				}
		/*
			for(x=0;x<pLAB;x++)
				for(y=0;y<pLAB;y++){
					if(x!=y)
						if(!LAB[x]->name.AnsiCompare(LAB[y]->name ) ){
							ShowMessage(u+"ERROR: label exist more than once: '"+LAB[x]->name+"'");
							memoline=0;
							ErrorMsg("ERROR");
							return;
						}
				}
		*/
		}
	}

	//delete clist;
	//clist=NULL;


	//SAVE to binary and HEX file
	if(multipages)fgenHEX=0;
	if(!error){
		//save to BIN file
		FILE*f;
		f=fopen(DESTfile.c_str(),"wb");
		if(!multipages){
			PM.SetPage(0);
			if(PC>65536)PC=65536;
			for(x=0;x<PC;x++){
				fputc(PM[x],f);
			}
		}else{
			PM.SetPage(0);
			for(x=0;x<32768;x++){
				fputc(PM[x],f);
			}
			if(PAG==0){
				fputc(0,f);
			}else{
				for(y=1;y<=PAG;y++){
					PM.SetPage(y);
					for(x=0;x<((y==PAG)?PClastpag:32768);x++){
						fputc(PM[x],f);
					}
				}
			}
			
			int z;
			for(x=32768;x<65536;x++){
				fputc(PM[x],f);
			}
		}
		fclose(f);

		//save to HEX file
		if(fgenHEX){
			DESTfile=ChangeFileExt(DESTfile,"HEX");
			TStringList*hexlist=new(TStringList);
			for(x=0;x<PC;x++){
				s=To4dHEX(x);
				z=To2dHEX(PM[x]);
				hexlist->Add(s+": "+z);
			}
			hexlist->SaveToFile(DESTfile);
			delete hexlist;
		}

		//Show success message
		if(SuccessMsgEnabled)ShowMessage("SUCCESSFULLY ASSEMBLED");
		Success=1;
	}else ShowMessage("ERROR DURING ASSEMBLING");

	
	//for(x=0;x<MAXLAB;x++)if(LAB[x])delete LAB[x];

	delete LAB;
	delete JumpTab;
	delete DataRel;
	//delete[] PM;
}
//---------------------------------------------------------------------------


void  AsmForm::AsmCode(AnsiString code){

	AnsiString param="";
	int x;
	int reg;
	long addr;
	for(x=1;x<=code.Length();x++)if(code[x]==' '){
		param=code;
		param.Delete(1,x);
		code=code.SubString(1,x-1);
	}

	//if(PC>=MAXCODE-10){ ErrorMsg("ERROR: code buffer full");return; }

	if(!code.AnsiCompare("MOV")){
		if(param.Length()!=3)	{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		if(param[2]!=',')		{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		if(param[1]=='M'){
			PM[PC++]=0x30;
			if((reg=GetRegister(param[3]))==0xFF){
				ErrorMsg("");return;
			}
			PM[PC++]=reg;
		}else if(param[3]=='M'){
			PM[PC++]=0x22;
			if((reg=GetRegister(param[1]))==0xFF){
				ErrorMsg("");return;
			}
			PM[PC++]=reg<<4;
		}else{
			PM[PC++]=0x10;
			if((reg=GetRegister(param[1]))==0xFF){
				ErrorMsg("");return;
			}
			PM[PC]=reg<<4;
			if((reg=GetRegister(param[3]))==0xFF){
				ErrorMsg("");return;
			}
			PM[PC++]|=reg;
		}

	}else if(!code.AnsiCompare("MVI")){
		PM[PC++]=0x43;
		if(param[2]!=',')		{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		if((reg=GetRegister(param[1]))==0xFF){
			ErrorMsg("");return;
		}
		PM[PC++]=reg<<4;
		param.Delete(1,2);
		reg=GetImValue(param);
		reg&0xFF;
		PM[PC++]=reg;
	}else if(!code.AnsiCompare("LDA")){
		PM[PC++]=0x57;
		if(param[1]!='[')					{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		if(param[param.Length()]!=']')		{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		param.Delete(1,1);
		param.Delete(param.Length(),1 );
		addr=GetAddress(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("STA")){
		PM[PC++]=0x65;
		if(param[1]!='[')					{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		if(param[param.Length()]!=']')		{ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		param.Delete(1,1);
		param.Delete(param.Length(),1 );
		addr=GetAddress(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("ADD")){
		PM[PC++]=0x70;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=reg;
	}else if(!code.AnsiCompare("ADC")){
		PM[PC++]=0x70;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x10|reg;
	}else if(!code.AnsiCompare("SUB")){
		PM[PC++]=0x78;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x08|reg;
	}else if(!code.AnsiCompare("SBB")){
		PM[PC++]=0x78;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x10|reg;
	}else if(!code.AnsiCompare("AND")){
		PM[PC++]=0x70;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x20|reg;
	}else if(!code.AnsiCompare("OR")){
		PM[PC++]=0x70;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x40|reg;
	}else if(!code.AnsiCompare("XOR")){
		PM[PC++]=0x70;
		if(param.Length()!=1){ ErrorMsg(u+"SYNTAX ERROR:" +code);return; }
		reg=GetRegister(param[1]);
		PM[PC++]=0x60|reg;
	}else if(!code.AnsiCompare("CMA")){
		PM[PC++]=0x70;
		PM[PC++]=0x80;
	}else if(!code.AnsiCompare("RLA")){
		PM[PC++]=0x70;
		PM[PC++]=0xA0;
	}else if(!code.AnsiCompare("RRA")){
		PM[PC++]=0x70;
		PM[PC++]=0xC0;
	}else if(!code.AnsiCompare("STC")){
		PM[PC++]=0x82;
	}else if(!code.AnsiCompare("RTC")){
		PM[PC++]=0x92;
	}else if(!code.AnsiCompare("JMP")){
		PM[PC++]=0xA3;
		PM[PC++]=0x03;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JZ")){
		PM[PC++]=0xA3;
		PM[PC++]=0x01;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JNZ")){
		PM[PC++]=0xA3;
		PM[PC++]=0x02;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JC")){
		PM[PC++]=0xA3;
		PM[PC++]=0x04;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JNC")){
		PM[PC++]=0xA3;
		PM[PC++]=0x08;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JM")){
		PM[PC++]=0xA3;
		PM[PC++]=0x10;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("JP")){
		PM[PC++]=0xA3;
		PM[PC++]=0x20;
		addr=JumpLabel(param);
		PM[PC++]=addr&0xFF;
		PM[PC++]=(addr&0xFF00)>>8;
	}else if(!code.AnsiCompare("HLT")){
		PM[PC++]=0xB2;
	}else if(!code.AnsiCompare("NOP")){
		PM[PC++]=0x00;
	}else if(!code.AnsiCompare("ORG")){
		addr=GetImValue(param);
		if((addr<=PC)||(addr>=65535))		{ ErrorMsg(u+"ORG address invalid" +code);return; }
		if((addr>=PERIPHADDR)&&(addr<PERIPHADDR+PERIPHLEN)){
			ErrorMsg(u+"ORG address invalid, points to the PERIPH area" +code);return;
		}
		if(addr>=PERIPHADDR+PERIPHLEN)beforePeriph=0;
		//while(PC<addr)
		//	PM[PC++]=0;
		PC=addr;
	}else if(!code.AnsiCompare("REP")){
		addr=GetImValue(param);
		if(addr+PC>=65535)					{ ErrorMsg(u+"ORG address invalid" +code);return; }
		for(x=0;x<addr;x++)
			PM[PC++]=0;
	}else if(!code.AnsiCompare("DB")){
		param=param+",";
		int pos=1;
		AnsiString subN;
		while(!param.IsEmpty() ){
        	pos=1;
			while(param[pos]!=',')pos++;
			subN=param.SubString(1,pos-1);
			reg=GetImValue(subN);
			reg=reg&0xFF;
			PM[PC++]=reg;
			param.Delete(1,pos);
		}
	}else if(!code.AnsiCompare("ENSLEN")){
		//Ensure that the following LEN could be placed, if not->ERROR
		addr=GetImValue(param);
		
		if(multipages&&!fixpag){
			if(addr>=32700){
				ErrorMsg("ERROR in ENSLEN: Code is too big to place into memory");
				return;
			}
			if((PC+addr)>32760){
				PM[PC++]=0xA3;
				PM[PC++]=0x03;
				addr=JmpIsland(PAG+1,0);
				PM[PC++]=addr&0xFF;
				PM[PC++]=(addr>>8)&0xFF;
				PAG++;
				if(PAG>=32){
					ErrorMsg("ERROR: Code Overflow to 32th page");
					return;
				}
				PM.SetPage(PAG);
				PC=0;
			}
		}else{
			if(beforePeriph){
				if((PC+addr)>PERIPHADDR-10){
					if(addr>(STACKADDR-PERIPHADDR-PERIPHLEN-10)){
						ErrorMsg("ERROR in ENSLEN: Code is too big to place into memory");
						return;
					}
					for(;PC<PERIPHADDR+PERIPHLEN;PC++)
						PM[PC]=0;
					//Put: JMP 0xC020
					PM[PERIPHADDR-4]=0xA3;
					PM[PERIPHADDR-3]=0x03;
					PM[PERIPHADDR-2]=0x20;
					PM[PERIPHADDR-1]=0xC0;
					beforePeriph=0;
				}
			}else{
				if((PC+addr)>STACKADDR){
					sprintf(param.String,"%d",65536-PC);
					ErrorMsg(u+"ERROR in ENSLEN: Impossible to place into memory\nRemained memory: "+param+" byte");
					return;
				}
			}
		}
	}else if(!code.AnsiCompare("GENOBJ")){
		fgenOBJ=1;
	}else if(!code.AnsiCompare("GENHEX")){
		fgenHEX=1;
	}else if(!code.AnsiCompare("FIXPAG")){
		fixpag=1;	PClastpag=PC;	PC=32768;
	}else if(!code.AnsiCompare("RELOC")){
		
	}else if(!code.AnsiCompare("ACTPAG")){
		PM[PC++]=0x43;
		PM[PC++]=0x70;
		PM[PC++]=PAG;
	}else if(!code.AnsiCompare("LDLPG")){
		if(AsmPhase==1){
			PM[PC++]=0x43;PM[PC++]=0x70;
			reg=GetAddressPage(param);
			if(reg==-1){
				ErrorMsg("ERROR: invalid address: LDLPG");
				return;
			}
			PM[PC++]=reg;
		}else{
			PM[PC++]=0;PM[PC++]=0;PM[PC++]=0;
		}
	}else if(!code.AnsiCompare("JMPTAB")){
		if(AsmPhase==0){
			jmptabSt=PC;
			jmptabEnd=GetImValue(param);
		}
	}else{
    	ErrorMsg("Unknown mnemonic");
		return;
	}
	
	if(PC>STACKADDR){ 
		ErrorMsg("ERROR: Code reached STACK area");
		return; 
	}
	
	if(beforePeriph&&(PC>PERIPHADDR-10)){
		if(PC>PERIPHADDR-5){
			ErrorMsg("ERROR: Code is written to the Peripherial area");
			return;
		}
		for(;PC<PERIPHADDR+PERIPHLEN;PC++)
			PM[PC]=0;
		//Put: JMP 0xC020
		PM[PERIPHADDR-4]=0xA3;
		PM[PERIPHADDR-3]=0x03;
		PM[PERIPHADDR-2]=0x20;
		PM[PERIPHADDR-1]=0xC0;
		beforePeriph=0;
	}

	if(multipages&&!fixpag){
		if(PC>32760){
			PM[PC++]=0xA3;
			PM[PC++]=0x03;
			addr=JmpIsland(PAG+1,0);
			PM[PC++]=addr&0xFF;
			PM[PC++]=(addr>>8)&0xFF;
			PAG++;
			if(PAG>=32){
				ErrorMsg("ERROR: Code Overflow to 32th page");
				return;
			}
			PM.SetPage(PAG);
			PC=0;
		}
	}
}

// Create JUMP table
long AsmForm::JmpIsland(int Page,long Addr){
	if(AsmPhase==0)
		return 0;
	long res=jmptabSt;
	//MVI A,[Page]
	//STA [0xC007]
	//JMP Addr
	PM[jmptabSt++]=0x43;
	PM[jmptabSt++]=0x70;
	PM[jmptabSt++]=Page&0xFF;
	
	PM[jmptabSt++]=0x65;
	PM[jmptabSt++]=0x07;
	PM[jmptabSt++]=0xC0;
	
	PM[jmptabSt++]=0xA3;
	PM[jmptabSt++]=0x03;
	PM[jmptabSt++]=Addr&0xFF;
	PM[jmptabSt++]=(Addr>>8)&0xFF;
	
	if(jmptabSt>=jmptabEnd){
		ErrorMsg("ERROR: JUMP table overflow!");
		return 0;
	}
	
	return res;
}

long AsmForm::JumpLabel(AnsiString label){
	if(AsmPhase==0)
		return 0;
	if(!multipages){
		return GetAddress(label);
	}else{
		long LabAddr=GetAddress(label);
		if(LabAddr>=32768)return LabAddr;//fix lapon van a cm
		int  LabPage=GetAddressPage(label);
		if(LabPage==-1)return LabAddr;//label szm volt nem cimke
		if(LabPage==PAG)return LabAddr;//label ugyanazon a lapon van
		//label msik lapon van, JUMP island kell
		long IslAddr=JmpIsland(LabPage,LabAddr);
		return IslAddr;
	}
}

int  AsmForm::GetRegister(char reg){
	int res;
	switch(reg){
		case 'A':
			res= 0x07;
			break;
		case 'B':
			res= 0x00;
			break;
		case 'C':
			res= 0x01;
			break;
		case 'D':
			res= 0x02;
			break;
		case 'E':
			res= 0x03;
			break;
		case 'H':
			res= 0x04;
			break;
		case 'L':
			res= 0x05;
			break;
		default:
			res= 0xFF;
			break;
	}
	return (res);
}

int   AsmForm::GetAddressPage(AnsiString addr){
	if(addr.IsEmpty() ){
		ErrorMsg("Invalid format");return 0;
	}	
	if(AsmPhase==0)
		return 0;
	
	int x;	
	for(x=0;x<LAB->Count;x++){
		if(!addr.AnsiCompare(LAB->Strings[x])){
			return LAB->Ints[x];
		}
	}
	return -1;
}

long  AsmForm::GetAddress(AnsiString addr){
	if(addr.IsEmpty() ){
		ErrorMsg("Invalid format");return 0;
	}	
	if(AsmPhase==0)
		return 0;
	int x;
	long addon=0;
	int pos=addr.AnsiPos("+");
	if(pos){
		AnsiString num;
		num=addr;
		num.Delete(1,pos);
		addr=addr.SubString(1,pos-1);
		addon=GetImValue(num);
	}

	pos=addr.AnsiPos("-");
	if(pos){
		AnsiString num;
		num=addr;
		num.Delete(1,pos);
		addr=addr.SubString(1,pos-1);
		addon=GetImValue(num);
		addon=-addon;
	}

	for(x=0;x<LAB->Count;x++){
		if(!addr.AnsiCompare(LAB->Strings[x])){
			return LAB->Longs[x]+addon;
		}
	}
	return GetImValue(addr)+addon;

}

long  AsmForm::GetImValue(AnsiString value){
	int x;
	long N=0;
	int num=0,radix=1;
	if(value.IsEmpty() ){
		ErrorMsg("Invalid number format");return 0;
	}

	//LOW, HIGH address
	if(value[1]=='['){
		x=value.AnsiPos("[LOW ");
		if(x==1){
			value.Delete(1,5);
			value=value.SubString(1,value.Length()-1 );
			N=GetAddress(value);
			N=N&0xFF;
			return N;
		}
		x=value.AnsiPos("[HIGH ");
		if(x==1){
			value.Delete(1,6);
			value=value.SubString(1,value.Length()-1 );
			N=GetAddress(value);
			N=(N&0xFF00)>>8;
			return N;
		}
	}

	//Hexa
	if( ((value.Length()>=2)&&(value[1]=='0')&&(value[2]=='x'))||(value[value.Length() ]=='H')||(value[value.Length() ]=='h') ){
		if((value[1]=='0')&&(value[2]=='x'))value.Delete(1,2);
		if((value[value.Length() ]=='H')||(value[value.Length() ]=='h')){
			if(value.Length()<=1){
				ErrorMsg("Invalid number format");return 0;
			}
			value.Delete(value.Length(),1);
		}
		while(!value.IsEmpty()){
			switch(value[value.Length() ]){
				case '0': num=0;break;
				case '1': num=1;break;
				case '2': num=2;break;
				case '3': num=3;break;
				case '4': num=4;break;
				case '5': num=5;break;
				case '6': num=6;break;
				case '7': num=7;break;
				case '8': num=8;break;
				case '9': num=9;break;
				case 'A': num=10;break;
				case 'B': num=11;break;
				case 'C': num=12;break;
				case 'D': num=13;break;
				case 'E': num=14;break;
				case 'F': num=15;break;
				default: ErrorMsg("Invalid number format");return 0; break;
			}
			N+=num*radix; radix*=16;
			value.Delete(value.Length() ,1);
		}
		return N;

	}else{
	//DECIMAL
		while(!value.IsEmpty()){
			if( (value[value.Length()]<'0')|| (value[value.Length()]>'9') ){
				ErrorMsg("Invalid number format");return 0;
			}
			num=value[value.Length()]-'0';
			N+=num*radix; radix*=10;
			value.Delete(value.Length() ,1);
		}
		return N;
	}
}

//ERROR message
void  AsmForm::ErrorMsg(AnsiString msg){
	error=1;
	AnsiString s,n;
	int y;

	if(Memo1){
		Memo1->Clear();
		Memo1->LoadText(clist);
	}

	n.Sprintf("%d",memoline);
	s=u+"ASSEMBLER\n\nERROR occured:\nIn line: "+n+"\n'"+clist->Strings[memoline]+"'\n"+msg;
	ShowMessage(s);

	if(SuccessMsgEnabled){
		if(Memo1)Memo1->SelectLine(memoline);
	}
	FailedLineNum=memoline;
	Success=0;
}

//2 digit HEX
AnsiString  AsmForm::To2dHEX(int N){
	AnsiString res;
	N=N&0xFF;
	char str[3];
	str[0]=convHex((N&0xF0)>>4);
	str[1]=convHex(N&0xF);
	str[2]=0;
	res.Sprintf("%s",str);
	res=u+"0x"+res;
	return res;
}

//4 digit HEX
AnsiString  AsmForm::To4dHEX(int N){
	AnsiString res;
	N=N&0xFFFF;
	char str[5];
	str[0]=convHex((N&0xF000)>>12);
	str[1]=convHex((N&0xF00)>>8);
	str[2]=convHex((N&0xF0)>>4);
	str[3]=convHex(N&0xF);
	str[4]=0;
	res.Sprintf("%s",str);
	res=u+"0x"+res;	
	return res;
}


char  AsmForm::convHex(int x){
	switch(x){
		case 0: return '0';
		case 1: return '1';
		case 2: return '2';
		case 3: return '3';
		case 4: return '4';
		case 5: return '5';
		case 6: return '6';
		case 7: return '7';
		case 8: return '8';
		case 9: return '9';
		case 10: return 'A';
		case 11: return 'B';
		case 12: return 'C';
		case 13: return 'D';
		case 14: return 'E';
		case 15: return 'F';
	}
}
void  AsmForm::Button3Click()
{
	PictureToAsmForm->ShowModal();
}
//---------------------------------------------------------------------------

void  AsmForm::SpecifyAsmFile(AnsiString asmfname,TStringList*ASMcode){
	INPUTfile=asmfname;
	DESTfile=ExtractFilePath(INPUTfile);
	AnsiString fname=ExtractFileName(INPUTfile);
	fname=ChangeFileExt(fname,"BIN");
	DESTfile=DESTfile+fname;
	OBJfile=ChangeFileExt(DESTfile,"OBJ");	
	clist=ASMcode;
	loaded=1;
}
