//MainForm
#ifndef AsmFormH
#define AsmFormH

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\MemoClass.h"
#include "..\LabelClass.h"
#include "..\OpenFileClass.h"
#include "..\TStringLongIntList.h"

//#include "resource.h"

//#define MAXLAB 10000
//#define MAXCODE 100000
#define STACKADDR 0xFF90	//approx 110byte stackdefined
#define PERIPHADDR 0xC000	//Peripherial start address
#define PERIPHLEN 32		//32 peripherial

#define MAXPAGES 32
class CodeSegment{
	unsigned char ** code;
	unsigned char * base;
	int Page;
public:
	CodeSegment(){
		code= new unsigned char*[MAXPAGES];
		int x;
		Page=0;
		for(x=0;x<MAXPAGES;x++)code[x]=NULL;
		code[0]=new unsigned char[32768];
		base=new unsigned char[32768];
		for(x=0;x<32768;x++){
			code[0][x]=0;
			base[0]=0;
		}
	}
	~CodeSegment(){
		int x;
		delete[] base;
		for(x=0;x<MAXPAGES;x++)
			if(code[x])
				delete[] code[x];
	}
	void SetPage(int page){
		Page=page&0x1F;
		if(code[Page]==NULL){
			int x;
			code[Page]=new unsigned char[32768];
			for(x=0;x<32768;x++)
				code[Page][x]=0;
		}
	}
	int GetPage(){
		return Page;
	}
	unsigned char& operator[] (unsigned i){
		return (i&0x8000) ? base[i&0x7FFF] : code[Page][i];
	}
};


struct labels{
	long addr;
	AnsiString name;
};

class AsmForm : public FormClass{
public:
	AsmForm(HWND Owner,int Resource);
	~AsmForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);

	Label*  Label1;
	Memo*   Memo1;
	Button* Button1;
	Button* Button2;
	Button* Button3;
	TOpenDialog *OpenDialog1;
	
	//Callbacks
	void  Button1Click();
	void  Button2Click();
	void  Button3Click();

private:	// User declarations
	AnsiString INPUTfile;
	AnsiString DESTfile;
	AnsiString OBJfile;	
	int loaded;
	long PC;			//program counter
	int PAG;			//actual page 
	TStringLongIntList*LAB;		//labels
	TStringLongIntList*JumpTab;	//Jump table
	TStringLongIntList*DataRel;	//Relocable Data table
//	labels* LAB[MAXLAB];
//	int pLAB;
//	unsigned char* PM;	//Program memory
	CodeSegment PM;		//Program memory
	int memoline;
	int error;
	int AsmPhase;

	void  ErrorMsg(AnsiString msg);

	void  AsmCode(AnsiString code);

	int   GetRegister(char reg);
	long  GetAddress(AnsiString addr);
	int   GetAddressPage(AnsiString addr);
	long  GetImValue(AnsiString value);

	AnsiString  To2dHEX(int N);
	AnsiString  To4dHEX(int N);
	char  convHex(int x);
	TStringList* clist;
	
	AnsiString u;	//ures string operator+() hibainak kikuszobolesere
	
	int beforePeriph;//ASM assembling is before peripherial area

public:		// User declarations
	void  SpecifyAsmFile(AnsiString asmfname,TStringList*ASMcode);
	void  Assemble();

	char SuccessMsgEnabled;
	char Success;
	int FailedLineNum;
	//int ObjFileGenerated;
	
	//enable generate files:
	char fgenHEX;
	char fgenOBJ;
	
	//These variables for multipages
	char multipages;
	char fixpag;
	long PClastpag;
	long jmptabSt;
	long jmptabEnd;
	long JmpIsland(int Page,long Addr);
	long JumpLabel(AnsiString label);
};

#endif
