//SID emulator
#include "AudioHW.h"

//#define DEBUGLOG
//#define DEBUGFREEBLOCKS
//#define DEBUGSIDREGS

#ifdef DEBUGLOG
//LOGTEST
#include "..\TStringListClass.h"
static TStringList*LogList;
static int Logtime=0; 
#endif

AudioHW::AudioHW(){
	ac=new AudioClass();
	Sid=new SID();
	Sid->clock(1000);
	
#ifdef DEBUGLOG
	//LOGTEST
	LogList=new TStringList();
#endif
}

AudioHW::~AudioHW(){
	delete ac;
	delete Sid;
	
#ifdef DEBUGLOG
	//LOGTEST
	LogList->SaveToFile("AudioLog.txt");
	delete LogList;
#endif
}

void AudioHW::AudioTimer(){
	int c,d,w;
	
#ifdef DEBUGLOG
#ifdef DEBUGFREEBLOCKS
	//LOGTEST
	AnsiString str;
	sprintf(str.String,"START= %d",ac->FreeBlocksCnt());
	LogList->Add(str);
#endif
#endif
	
	//if(ac->FreeBlocksCnt()>=BLOCK_COUNT/2){
	if(ac->FreeBlocksCnt()>=16){
		for(c=0;c<16;c++){
			for(d=0;d<1024;d+=16){
				Sid->clock(25);
				w=Sid->output();
				buf[d]=w&0xFF;		//Stereo channel Left Low byte
				buf[d+1]=w>>8;		//Stereo channel Left High byte
				buf[d+2]=w&0xFF;	//Stereo channel Right Low byte
				buf[d+3]=w>>8;		//Stereo channel Right High byte
				Sid->clock(25);
				w=Sid->output();
				buf[d+4]=w&0xFF;	//Stereo channel Left Low byte
				buf[d+5]=w>>8;		//Stereo channel Left High byte
				buf[d+6]=w&0xFF;	//Stereo channel Right Low byte
				buf[d+7]=w>>8;		//Stereo channel Right High byte
				Sid->clock(25);
				w=Sid->output();
				buf[d+8]=w&0xFF;	//Stereo channel Left Low byte
				buf[d+9]=w>>8;		//Stereo channel Left High byte
				buf[d+10]=w&0xFF;	//Stereo channel Right Low byte
				buf[d+11]=w>>8;		//Stereo channel Right High byte
				Sid->clock(25);
				w=Sid->output();
				buf[d+12]=w&0xFF;	//Stereo channel Left Low byte
				buf[d+13]=w>>8;		//Stereo channel Left High byte
				buf[d+14]=w&0xFF;	//Stereo channel Right Low byte
				buf[d+15]=w>>8;		//Stereo channel Right High byte
			}
			ac->writeAudio(buf, 1024);	//Write data block to Windows multimedia driver
		}
		
		
#ifdef DEBUGLOG
#ifdef DEBUGFREEBLOCKS
		//LOGTEST
		sprintf(str.String,"END= %d",ac->FreeBlocksCnt());
		LogList->Add(str);
#endif
#endif

	}
}

void AudioHW::AudioReg(int addr, int data){
	if(addr<0)return;
	if(addr>0x1C)return;
	data=data&0xFF;
	Sid->write(addr,data);
#ifdef DEBUGLOG
#ifdef DEBUGSIDREGS
	AnsiString str;
	sprintf(str.String,"REG addr= 0x%X, data=0x%X",addr,data);
	LogList->Add(str);

#endif
#endif
}

void AudioHW::LogTime(){
#ifdef DEBUGLOG
	//LOGTEST
	AnsiString str;
	sprintf(str.String,"time= %d",Logtime++);
	LogList->Add(str);
#endif
}
