//MainForm
#ifndef MainFormH
#define MainFormH

#include "stdio.h"

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\EditClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\OpenFileClass.h"
#include "..\TGroupBox.h"
#include "..\MemoClass.h"
#include "..\LabelClass.h"
#include "..\TCheckBox.h"
#include "..\TimerClass.h"
#include "..\CanvasClass.h"
#include "..\OpenFileClass.h"
#include "..\TStringListClass.h"
//#include "..\ApplicationClass.h"

#include "resource.h"

#include "..\AudioHardware\AudioHW.h"

#define SCRX 156		//display resolution in X direction
#define SCRY 116		//display resolution in Y direction

#define TPORT1 0xC000    //dummy port just only for testing #1
#define TPORT2 0xC001    //dummy port just only for testing #2
#define IO_Xreg 0xC002    //video X register
#define IO_Yreg 0xC003    //video Y register
#define IO_Zreg 0xC004    //video Z register
#define IO_SID_DAT 0xC005    //SID data register
#define IO_SID_ADR 0xC006    //SID address register
#define PAGE_REG 0xC007        //code page register
#define IO_UART_KB 0xC008    //keyboard UART base address
#define IO_UART 0xC010        //communication UART base address
#define IO_IDE 0xC018        //IDE


#define DISASM PostMessage(hwnd,WM_USER,1,0);
#define OUTOFCODE PostMessage(hwnd,WM_USER,2,0);
#define REFRESHDUMP1 PostMessage(hwnd,WM_USER,3,0);
#define REFRESHDUMP2 PostMessage(hwnd,WM_USER,4,0);
#define REFRESHDUMP3 PostMessage(hwnd,WM_USER,5,0);
#define UNKNOWNCODE PostMessage(hwnd,WM_USER,6,0);
#define HALTED PostMessage(hwnd,WM_USER,7,0);


#define MAXPAGES 32
class CodeSegment{
	unsigned char ** code;
	unsigned char * base;
	int Page;
public:
	CodeSegment(){
		code= new unsigned char*[MAXPAGES];
		int x;
		Page=0;
		for(x=0;x<MAXPAGES;x++)code[x]=NULL;
		code[0]=new unsigned char[32768];
		base=new unsigned char[32768];
		for(x=0;x<32768;x++){
			code[0][x]=0;
			base[0]=0;
		}
	}
	~CodeSegment(){
		int x;
		delete[] base;
		for(x=0;x<MAXPAGES;x++)
			if(code[x])
				delete[] code[x];
	}
	void SetPage(int page){
		Page=page&0x1F;
		if(code[Page]==NULL){
			int x;
			code[Page]=new unsigned char[32768];
			for(x=0;x<32768;x++)
				code[Page][x]=0;
		}
	}
	int GetPage(){
		return Page;
	}
	unsigned char& operator[] (unsigned i){
		return (i&0x8000) ? base[i&0x7FFF] : code[Page][i];
	}
};

static volatile int run=0;
static volatile int intimer=0;
static volatile char SCdirty=1;
static volatile int SCcnt=0;

class MainForm : public FormClass{
public:
	MainForm();
	~MainForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);
	
	Label* Label1;
	Label* Label2;
	Label* Label3;
	Label* Label4;
	Label* Label5;
	Label* Label6;
	Label* Label7;
	Label* Label8;
	TGroupBox* GroupBox2;
	Label* Label12;
	Label* Label13;
	Label* Label14;
	Label* Label15;
	Label* Label16;
	Label* Label17;
	Label* Label18;
	Label* Label19;
	TGroupBox* GroupBox1;
	Label* Label9;
	Label* Label10;
	Label* Label11;
	Memo* Memo1;
	Memo* Memo2;
	Memo* Memo3;
	Memo* Memo4;
	Button* Button1;
	Button* Button2;
	Button* Button3;
	Button* Button4;
	EditBox* Edit1;
	EditBox* Edit2;
	EditBox* Edit3;
	TCheckBox* CheckBox1;
	EditBox* Edit4;
	EditBox* Edit5;
	EditBox* Edit6;
	EditBox* Edit7;
	Button* Button5;
	EditBox* Edit8;
	EditBox* Edit9;
	EditBox* Edit10;
	EditBox* Edit11;
	EditBox* Edit12;
	EditBox* Edit13;
	EditBox* Edit14;
	EditBox* Edit15;
	EditBox* Edit16;
	EditBox* Edit17;
	EditBox* Edit18;
	Button* Button6;
	Button* Button7;
	Button* Button8;
	Button* Button9;
	Button* Button10;
	Button* Button11;
	Button* Button12;
	Button* Button13;
	Button* Button14;
	Button* Button15;
	Button* Button16;
	Button* Button17;
	
	TimerClass* Timer1;
	CanvasClass* Canvas;
	TOpenDialog* OpenDialog1;
	
	void  FormCreate( );
	void  FormDestroy( );
	void  FormShow( );
	//void  Keyb( char &Key);
	void  Timer1Timer( );
	
	void  Button1Click( );
	void  Button2Click( );
	void  Button3Click( );
	void  Button5Click( );
	void  Button4Click( );
	void  Button8Click( );
	void  Button10Click( );
	void  Button9Click( );
	void  Button6Click( );
	void  Button7Click( );
	void  Button11Click( );
	void  Button12Click( );
	void  Button13Click( );
	void  Button14Click( );
	void  Button15Click( );
	void  Button16Click( );
	void  Button17Click( );
	
	void  CheckBox1Click( );
	
	void  OPEN1Click( );
	void  START1Click( );
	void  STOPClick( );
	void  EXIT1Click( );
	void  STEP2Click( );
	void  SETDump1Click( );
	void  SETDump2Click( );
	void  SETDump3Click( );
	void  ModifyRegisters1Click( );
	void  ModifyFlags1Click( );
	
	void OnPaint();
	void OnChar(char Key);
	void OnKeyDown(WPARAM w);
	void OnTimer(unsigned TimerID);
	void OnUserMessage(WPARAM wParam, LPARAM lParam);
	
private:	// User declarations
	//unsigned char* CODE;	//CODE memory
	CodeSegment CODE;	//CODE memory
	unsigned long PC;
	unsigned char A;
	unsigned char AccTMPreg;	//Akku atmeneti regiszter - only for CARRY side effect simu.
	unsigned char B;
	unsigned char C;
	unsigned char D;
	unsigned char E;
	unsigned char H;
	unsigned char L;
	unsigned char FlagZ;
	unsigned char FlagS;
	unsigned char FlagC;
	unsigned char Xreg;
	unsigned char Yreg;
	unsigned char Zreg;
	unsigned char KEYB[16];
	int KEYBpoi;
	unsigned char SID_ADDR;	//SID Address register
	unsigned char* UART;	//UART buffer
	int Puart;	
	int codesize;
	AnsiString BINfileName;
	void  DisAsm();
	AnsiString  RegDecode(int reg);
	AnsiString  HexDecode(int addr);
	AnsiString  HexAddr(int addr);
	AnsiString  Hex(int x);
	unsigned int Dump1st;
	unsigned int Dump2st;
	unsigned int Dump3st;
	long  GetHexValue(AnsiString value);
	void  RefreshAll();
	void  RefreshHighlight();	
	void  RefreshDump1();
	void  RefreshDump2();
	void  RefreshDump3();
	void  RefreshRegisters();
	void  RefreshScreen();	
	unsigned char screen[SCRX][SCRY];
	void  PlotScr(int x, int y, int color);
	void  Execute();
	unsigned char  GetReg(int reg);
	void  PutReg(int reg,unsigned char data);
	unsigned char  GetMemHL();
	void  PutMemHL(unsigned char data);
	void  IoPheripheral(long addr);
	void  UpdateScreen();

	HDC hdc;
	HDC memDC;		//Bitmaps for buffering
	HBITMAP memBM;

	void  LoadInputFile();
	
	AudioHW* SidAudio;
	
	AnsiString TitleStr;
	
	//int DelayTimer;
	
	//Scan code emulation
	void ScanCodeToBuf(char Key);
	void PushScan(char c1);
	void PushScan(char c1,char c2,char c3);
	void PushScan(char c1,char c2,char c3,char c4,char c5);
	char PopScan();
	
	//Set pages
	void SetPageMenu(int page);
};

#endif
