//MainForm
#ifndef BasicEmuH
#define BasicEmuH

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\EditClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\LabelClass.h"
#include "..\MemoClass.h"
#include "..\TCheckBox.h"
#include "..\TRadioButton.h"
#include "..\TimerClass.h"
#include "..\CanvasClass.h"
#include "..\TStringListClass.h"

#include "..\CompilerForm\CMDtypes.h"

#define SCRX 156		//display resolution in X direction
#define SCRY 116		//display resolution in Y direction

#include "..\AudioHardware\AudioHW.h"
	
//#include "resource.h"

static volatile int   TimerRun=0;
static volatile int   InTimer=0;
static volatile char KEY=0;
static volatile int run=0;
static volatile int WaitKeyState[2];
static volatile char SCdirty=0;

class BasicEmu : public FormClass{
public:
	BasicEmu(HWND Owner,int Resource);
	~BasicEmu();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);
	
	Label* Label1;
	Label* Label2;
	Label* Label3;
	Label* Label4;
	TRadioButton* RadioButton1;
	TRadioButton* RadioButton2;
	Button* Button1;
	Button* Button2;
	Button* Button3;
	Button* Button4;
	Button* Button5;
	Button* Button6;
	Button* Button7;
	Button* Button8;
	Memo* Memo1;
	Memo* Memo2;
	Memo* Memo3;
	EditBox* Edit1;
	TCheckBox* CheckBox1;
	TimerClass *Timer1;
	CanvasClass* Canvas;
	
	void  Button1Click();
	void  Button2Click();
	void  Button3Click();
	void  Button4Click();
	void  Button5Click();
	void  Button6Click();
	void  Button7Click();
	void  Button8Click();
	void  RadioButton1Click();
	void  RadioButton2Click();
	void  CheckBox1Click();
	void  FormShow();
	void  FormHide();
	void  Timer1Timer();
	void  Timer2Timer();
	void  OnTimer(unsigned TimerID);
	void  OnKeyDown(WPARAM w);
	void  OnChar(char Key);
	void  OnPaint();
	void  OnUserMessage(WPARAM wParam, LPARAM lParam);
	
private:	// User declarations
	int commandCNTR;
	AnsiString R1;//Command splitted parts
	AnsiString R2;
	AnsiString R3;
	AnsiString R4;
	AnsiString R5;
	AnsiString R6;
	command* CMD;
	int CMDnum;
	variable V[5000];
	int Vcnt;
	int GosubStack[100];
	int GosubStackPoi;

	int delaycnt;

	data_read* DATA;	//maximum 1000 DATA commands
	void  SplitBySpace(AnsiString cmd);
	void  SplitByComma(AnsiString cmd);
	AnsiString  GetFirstVariableName(AnsiString line);
	void  Plot(int X, int Y, int color);

	void  PutVariable(AnsiString name, int X, int Y, int value);
	int   GetVariable(AnsiString name, int X, int Y);
	AnsiString   SplitArrayVariableName(AnsiString name, AnsiString &X, AnsiString &Y);
	int   EvaluateExpression(AnsiString expr);
	int   EvaluateBooleanExpression(AnsiString expr);

	int   BracketRecursive(AnsiString expr);

	void  ProcessCommand(command* COMMAND);
	void  ErrorMSG(AnsiString msg);

	int   IsNumber(AnsiString str);
	void  WatchVar();

	unsigned int m_z;
	unsigned int m_w;
	void  RandSeed();
	int   RandomNumber(int randmax);

	//Graphics variables
	int SysColor;
	int GposX,GposY;
	int MaxColorDepth;	
	int MaxX,MaxY;
	int GRbuf[SCRX][SCRY];


	//Graphics Subroutines
	void  DrawTo(int x,int y);
	void  VerShiftGrLine(int line,char dir);
	void  HorShiftGrLine(int line,char dir);
	void  PutPattern(AnsiString name,int x,int y,int px,int py,command* COMMAND);
	void  PutPatMirVer(AnsiString name,int x,int y,int px,int py,command* COMMAND);
	void  PutPatTwist(AnsiString name,int x,int y,int px,int py,command* COMMAND);
	void  PutPatTwisMir(AnsiString name,int x,int y,int px,int py,command* COMMAND);
	void  DelPattern(int x,int y,int px,int py,command* COMMAND);
	void  GetPattern(AnsiString name,int x,int y,int px,int py);
	void  UpdateScr();	

	int  	KeybInput();
	int  	WaitKey();

	AnsiString u;
	TStringList* tlist;
	
	AudioHW* SidAudio;
	int DataReadLo(command* COMMAND);
	int DataReadHi(command* COMMAND);
	int DataReadReset(command* COMMAND);
	int SIDreg04;
	int SIDreg11;
	int SIDreg18;
	int SIDreg24;
	
	TStringList* PrintList;
	
public:		// User declarations
	TStringList* commands;
	int errorlinenum;
	int stepline;
	void  MakeCommandlist();
	void  DestroyCommandlist();		

};

#endif
