//MainForm
#include "MainForm.h"

#include "..\Assembler\AsmForm.h"
#include "..\BasicEmulator\BasicEmuForm.h"
#include "..\CompilerForm\CompilerForm.h"

extern CompilerForm*	CompilerFormWin;
extern AsmForm*			AsmFormWin;
extern BasicEmu*		BasicEmuWin;


MainForm::MainForm(){
	CreateSpecial("BASIC COMPILER AND EMULATOR",20,20,530,710,1);

//user code here	
	//SIDmusicalGenerator();
}

MainForm::~MainForm(){
//user code here

    DestroyForm();
}

//Build up form
void MainForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	AnsiString s(hwnd);
	Memo1=new Memo(hwnd,hInst,"",Memo1P);
	Button1=new Button(hwnd,hInst,"OPEN",Button1P);
	Edit1=new EditBox(hwnd,hInst,"",Edit1P);
	Edit1->ReadOnly(true);
	Button3=new Button(hwnd,hInst,"reload file",Button3P);
	GroupBox1=new TGroupBox(hwnd,hInst,"Machine",GroupBox1P);
	Button6=new Button(hwnd,hInst,"Assembler",Button6P);
	Button5=new Button(hwnd,hInst,"Machine Simulator",Button5P);
	GroupBox2=new TGroupBox(hwnd,hInst,"BASIC",GroupBox2P);
	Button4=new Button(hwnd,hInst,"BASIC Emulation",Button4P);
	Button2=new Button(hwnd,hInst,"BASIC Compiler",Button2P);
	Button8=new Button(hwnd,hInst,"Compile&&Load-F9",Button8P);
	Button7=new Button(hwnd,hInst,"Programmer",Button7P);
	CheckBox1=new TCheckBox(hwnd,hInst,"external",CheckBox1P);

	Memo1->SetDefFont();
	Button1->SetDefFont();
	Edit1->SetDefFont();
	Button3->SetDefFont();
	GroupBox1->SetDefFont();
	Button6->SetDefFont();
	Button5->SetDefFont();
	GroupBox2->SetDefFont();
	Button4->SetDefFont();
	Button2->SetDefFont();
	Button7->SetDefFont();
	Button8->SetDefFont();
	CheckBox1->SetDefFont();
	
	OpenDialog1=new TOpenDialog(hwnd);
	SaveDialog1=new TSaveDialog(hwnd);

	FormCreate();
	COMPILESUCCESS=0;
	ExternalFile=0;
	
	//Draw sytem ICON	
	CompileIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON2_COMPILE));
	if(!CompileIcon){
		ShowError("Loading Icon1 failed","ICON ERROR");
	}
	ErrorIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON3_ERROR));
	if(!ErrorIcon){
		ShowError("Loading Icon2 failed","ICON ERROR");
	}
	LoaderIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON4_LOAD));
	if(!LoaderIcon){
		ShowError("Loading Icon3 failed","ICON ERROR");
	}
	RunIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON5_RUN));
	if(!RunIcon){
		ShowError("Loading Icon4 failed","ICON ERROR");
	}
	SaveIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON6_SAVE));
	if(!SaveIcon){
		ShowError("Loading Icon5 failed","ICON ERROR");
	}
	SuccessIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON7_SUCCESS));
	if(!SuccessIcon){
		ShowError("Loading Icon6 failed","ICON ERROR");
	}
	WriteIcon=LoadIcon(hInst,MAKEINTRESOURCE(ICON1_WRITE));
	if(!WriteIcon){
		ShowError("Loading Icon7 failed","ICON ERROR");
	}
	DELETEICON=LoadIcon(hInst,MAKEINTRESOURCE(ICON8_DELETE));
	if(!DELETEICON){
		ShowError("Loading Icon8 failed","ICON ERROR");
	}
	
	SysIcon=WriteIcon;
}

//Destroy form
void MainForm::DestroyForm(){
	delete Memo1;
	delete Button1;
	delete Edit1;
	delete Button3;
	delete GroupBox1;
	delete Button6;
	delete Button5;
	delete GroupBox2;
	delete Button4;
	delete Button2;
	delete OpenDialog1;
	delete SaveDialog1;
	delete Button8;
	delete Button7;
	delete CheckBox1;
	FormDestroy();
}

void MainForm::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
	REGCALLBK(Button3) Button3Click();
	REGCALLBK(Button4) Button4Click();
	REGCALLBK(Button5) Button5Click();
	REGCALLBK(Button6) Button6Click();
	REGCALLBK(Button7) Button7Click();
	REGCALLBK(Button8) Button8Click();
	REGCALLBK(CheckBox1) CheckBox1Click();
	
	switch(command){			
		case IDM_OPEN_CTRL_O1:
			//Button1Click();
			Open1Click();
			break;
		case IDM_SAVE_CTRL_S1:
			Save1Click();
			break;
		case IDM_SAVE_CURRENT:
			SaveCurrent();
			break;
		case IDM_COMPILE1:
			//Button2Click();
			Compile1Click();
			break;
		case IDM_EMULATION1:
			//Button4Click();
			Emulation1Click();
			break;
		case IDM_MACHINE_SIMULATOR1:
			//Button5Click();
			MachineEmulator1Click();
			break;
		case IDM_ASSEMBLER1:
			//Button6Click();
			Assembler1Click();
			break;
		case IDM_SETUP1:
			Setup1Click();
			break;
		case IDM_ABOUT1:
			About1Click();
			break;
		case IDM_COMP_AND_DWNLD:
			DoAll();
			break;
		case IDM_PROGRAMMER:
			Programmer();
			break;
	}	
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
//---------------------------------------------------------------------------
void  MainForm::Button1Click()
{
//OPEN
	SetStateIcon(SaveIcon);
	AnsiString s,temp,ProgPort;
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";

	temp=Edit1->Text;
	if(!temp.IsEmpty() )OpenDialog1->FileName=Edit1->Text;

	TStringList* Inifile=new(TStringList);
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		if(Inifile->Count<2){
			ProgPort="ProgrammerPort=COM1";
		}else{
			ProgPort=Inifile->Strings[1];
		}
	}else{
		Inifile->Add("default.BASIC");
		Inifile->Add("ProgrammerPort=COM1");
		Inifile->SaveToFile(s);
	}
	Inifile->Clear();
	
	OpenDialog1->Filter="BASIC source file (*.basic)\0*.BASIC";
	if(OpenDialog1->Execute()){
		INPUTfile=OpenDialog1->FileName;
		INPUTfile=ChangeFileExt(INPUTfile,"BASIC");
		Edit1->Text=INPUTfile;
		Inifile->Add(INPUTfile);
		Inifile->Add(ProgPort);
		Inifile->SaveToFile(s);
		DESTfile=ExtractFilePath(INPUTfile);
		AnsiString fname=ExtractFileName(INPUTfile);
		fname=ChangeFileExt(fname,"BIN");
		DESTfile=DESTfile+fname;
		Memo1->LoadFromFile(INPUTfile);
		loaded=1;
		DelEmptyLines();
	}
	delete Inifile;
}
//---------------------------------------------------------------------------
void  MainForm::FormCreate()
{
	loaded=0;
	Memo1->Clear();
	Edit1->Text="";

	AnsiString s;
	TStringList* Inifile=new(TStringList);
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		INPUTfile=Inifile->Strings[0];
		if(FileExists(INPUTfile)){
			Edit1->Text=INPUTfile;
			DESTfile=ExtractFilePath(INPUTfile);
			AnsiString fname=ExtractFileName(INPUTfile);
			fname=ChangeFileExt(fname,"BIN");
			DESTfile=DESTfile+fname;
			Memo1->LoadFromFile(INPUTfile);
			DelEmptyLines();
			loaded=1;
		}else INPUTfile="";
	}else{
		INPUTfile="";
		Inifile->Add("default.BASIC");
		Inifile->Add("ProgrammerPort=COM1");
		Inifile->SaveToFile(s);
	}

	delete Inifile;
	InlineASM=NULL;
}
//---------------------------------------------------------------------------
void  MainForm::Button2Click()
{
//COMPILE
	COMPILESUCCESS=0;
	if(loaded){
		if(!Memo1->Count()){
			ShowMessage("ERROR: Empty source");
			return;
		}
    	DelEmptyLines();
		
		if(ExternalFile)
			Button3Click();//reload file: in case of using of an external editor
		else
			SaveCurrent();//save the editor: in case of editing in the edit box
		
		SetStateIcon(CompileIcon);
		SetDefaultFileGeneration();
		Compile();
		if(COMPILESUCCESS==1)
			SetStateIcon(SuccessIcon);
		if(COMPILESUCCESS==0)
			SetStateIcon(ErrorIcon);
	}else{
		ShowMessage("ERROR: No source file loaded");
	}
}
//---------------------------------------------------------------------------

void  MainForm::Compile(){
	AnsiString ASMfilename;
	CompilerFormWin->DESTfile=DESTfile;
	CompilerFormWin->commands=new(TStringList);

	int x;
	int count=Memo1->Count();
	for(x=0;x<count;x++ ){
		if(!Memo1->Strings[x].IsEmpty())
			CompilerFormWin->commands->Add(Memo1->Strings[x] );
	}
	if(!(CompilerFormWin->errorlinenum=PreprocessCommands(CompilerFormWin->commands))){
		CompilerFormWin->errorlinenum=-1;
		CompilerFormWin->MakeCommandlist();
	}
	if(CompilerFormWin->errorlinenum>=0){
		DisplayFailedLine(CompilerFormWin->commands, NULL, CompilerFormWin->errorlinenum, BASICerror);
		ShowMessage("ERROR OCCURED DURING BASIC COMPILATION");
		CompilerFormWin->DestroyCommandlist();
		delete CompilerFormWin->commands;
		if(InlineASM)delete InlineASM;
		InlineASM=NULL;
		return;
	}

	TStringList* ASMcodelist=new TStringList();
	CompilerFormWin->setASMsource(ASMcodelist);
	
	if(CompilerFormWin->ShowModal() == mrOk){
		if(CompilerFormWin->errorlinenum>=0){
			DisplayFailedLine(CompilerFormWin->commands, NULL, CompilerFormWin->errorlinenum, BASICerror);
			ShowMessage("ERROR OCCURED DURING BASIC COMPILATION");
			CompilerFormWin->DestroyCommandlist();
			delete CompilerFormWin->commands;
			if(InlineASM)delete InlineASM;
			InlineASM=NULL;
			delete ASMcodelist;
			ASMcodelist=NULL;
			return;
		}

		ASMfilename=INPUTfile;
		ASMfilename=ChangeFileExt(ASMfilename,"ASM");
		
		CompilerFormWin->DestroyCommandlist();
		
		InsertInlineASM(ASMcodelist);
		PostProcessAsmFile(ASMcodelist);
		
		if(CompilerFormWin->fgenASM){
			ASMcodelist->SaveToFile(ASMfilename);
		}
		
		AsmFormWin->SpecifyAsmFile(ASMfilename,ASMcodelist);
		AsmFormWin->SuccessMsgEnabled=0;
		AsmFormWin->fgenHEX=CompilerFormWin->fgenHEX;
		AsmFormWin->fgenOBJ=CompilerFormWin->fgenOBJ;
		AsmFormWin->Assemble();
		if(!AsmFormWin->Success){
			DisplayFailedLine(CompilerFormWin->commands, ASMcodelist, AsmFormWin->FailedLineNum, ASMerror);
			ShowMessage("ERROR OCCURED IN ASSEMBLING");
		}else{
			//In automated compilation we do not write out any message in case of success
			if(!CompilerFormWin->AutomatedMode)
				ShowMessage("SUCCESSFULLY COMPILED");
			COMPILESUCCESS=1;
		}
		delete CompilerFormWin->commands;
		CompilerFormWin->commands=NULL;
	}else{
		COMPILESUCCESS=2;
	}
	delete ASMcodelist;
	ASMcodelist=NULL;
	if(InlineASM)delete InlineASM;
	InlineASM=NULL;
}

void  MainForm::SetDefaultFileGeneration(){
	CompilerFormWin->fgenMASM=0;
	CompilerFormWin->fgenASM=0;
	CompilerFormWin->fgenHEX=0;
	CompilerFormWin->fgenOBJ=0;
	AsmFormWin->fgenHEX=0;
	AsmFormWin->fgenOBJ=0;
}

void  MainForm::Button4Click()
{
	if(!loaded){
		ShowMessage("ERROR: No source file loaded");
		return;
	}
	if(!Memo1->Count()){
		ShowMessage("ERROR: Empty source");
		return;
	}

//EMULATION
	SetStateIcon(RunIcon);
	BasicEmuWin->commands=new(TStringList);

	int x;
	DelEmptyLines();
	int count=Memo1->Count();
	for(x=0;x<count;x++ ){
		if(!Memo1->Strings[x].IsEmpty())
			BasicEmuWin->commands->Add(Memo1->Strings[x] );
	}
	if(!(BasicEmuWin->errorlinenum=PreprocessCommands(BasicEmuWin->commands))){
		run=0;
		BasicEmuWin->errorlinenum=-1;
		BasicEmuWin->MakeCommandlist();
	}
	if(BasicEmuWin->errorlinenum>=0){
		DisplayFailedLine(BasicEmuWin->commands, NULL, BasicEmuWin->errorlinenum, BASICerror);
		ShowMessage("ERROR OCCURED DURING EXECUTION");
		BasicEmuWin->DestroyCommandlist();
		delete BasicEmuWin->commands;
		BasicEmuWin->commands=NULL;
		if(InlineASM)delete InlineASM;
		InlineASM=NULL;		
		return;
	}

	BasicEmuWin->ShowModal();

	if(BasicEmuWin->errorlinenum>=0){
		DisplayFailedLine(BasicEmuWin->commands, NULL, BasicEmuWin->errorlinenum, BASICerror);
		ShowMessage("ERROR OCCURED DURING EXECUTION");
	}

	BasicEmuWin->DestroyCommandlist();
	delete BasicEmuWin->commands;
	if(InlineASM)delete InlineASM;
	InlineASM=NULL;	
}
//---------------------------------------------------------------------------

void  MainForm::Open1Click()
{
	Button1Click();	
}
//---------------------------------------------------------------------------


//SAVE
void  MainForm::Save1Click()
{
//SAVE
	SetStateIcon(SaveIcon);
	AnsiString s,t,ProgPort;
	s=ExtractFilePath(Application->ExeName)+"Compiler.ini";

	t=Edit1->Text;
	if(!t.IsEmpty() )SaveDialog1->FileName=Edit1->Text;

	TStringList* Inifile=new(TStringList);
	if(FileExists(s)){
		Inifile->LoadFromFile(s);
		if(Inifile->Count<2){
			ProgPort="ProgrammerPort=COM1";
		}else{
			ProgPort=Inifile->Strings[1];
		}
	}else{
		Inifile->Add("default.BASIC");
		Inifile->Add("ProgrammerPort=COM1");
		Inifile->SaveToFile(s);
	}
	Inifile->Clear();
	
	SaveDialog1->Filter="BASIC source file (*.basic)\0*.BASIC";
	if(SaveDialog1->Execute()){
		INPUTfile=SaveDialog1->FileName;
		INPUTfile=ChangeFileExt(INPUTfile,"BASIC");
		Edit1->Text=INPUTfile;
		Inifile->Add(INPUTfile);
		Inifile->Add(ProgPort);
		Inifile->SaveToFile(s);
		DESTfile=ExtractFilePath(INPUTfile);
		AnsiString fname=ExtractFileName(INPUTfile);
		fname=ChangeFileExt(fname,"BIN");
		DESTfile=DESTfile+fname;
		DelEmptyLines();
		Memo1->SaveToFile(INPUTfile);
		loaded=1;
	}
	delete Inifile;
}
//---------------------------------------------------------------------------

void  MainForm::SaveCurrent(){
	if(INPUTfile.IsEmpty()){
		Save1Click();
		return;
	}
	DelEmptyLines();
	Memo1->SaveToFile(INPUTfile);
	loaded=1;
	SetStateIcon(SaveIcon);
}

//ABOUT
void  MainForm::About1Click()
{
	SetStateIcon(CompileIcon);
	ShowMessageT(
	"BASIC Compiler\nfor Gabor Barany CPU\nby Andras Bognar 2010",
	"ABOUT");
}
//---------------------------------------------------------------------------

void  MainForm::Compile1Click()
{
	Button2Click();	
}
//---------------------------------------------------------------------------

void  MainForm::Emulation1Click()
{
	Button4Click();	
}
//---------------------------------------------------------------------------

void MainForm::DelEmptyLines(){
	int x;
	TStringList* templist=new TStringList();
	
	for(x=0;x<Memo1->Count();x++ ){
		templist->Add(Memo1->Strings[x]);
	}
	
	for(x=0;x<templist->Count;x++ ){
		if(templist->Strings[x].IsEmpty())
			templist->Delete(x);
	}
	Memo1->LoadText(templist);
	
	delete templist;
}

void  MainForm::Button3Click()
{
	//reload file
	if(!FileExists(INPUTfile.c_str())){
		ShowError("ERROR file does not exist!","File error");
		return;
	}
	Memo1->LoadFromFile(INPUTfile);
	loaded=1;
	DelEmptyLines();
}
//---------------------------------------------------------------------------

void  MainForm::Setup1Click()
{
	SetStateIcon(CompileIcon);
	ShowMessage("ERROR: Not yet mplemented");
}
//---------------------------------------------------------------------------

void  MainForm::Button6Click()
{
	//Start Assembler
	TStringList* ASMcodelist=new TStringList();
	
	SetDefaultFileGeneration();
	SetStateIcon(CompileIcon);
	AnsiString ASMfilename;
	char suggestbuild=0;
	if(FileExists(INPUTfile)){
		ASMfilename=ChangeFileExt(INPUTfile,"ASM");
		if(FileExists(ASMfilename)){
			//check file dates
			FILETIME ftime;
			HANDLE hFile=CreateFile(ASMfilename.String,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if(!hFile){
				ShowMessage("ERROR: file does not exists");
				return;
			}
			GetFileTime(hFile,NULL,NULL,&ftime);
			CloseHandle(hFile);
			
			AnsiString binfile=INPUTfile;
			binfile=ChangeFileExt(binfile,"BIN");
			if(!FileExists(binfile))
				binfile=INPUTfile;
			FILETIME ftime2;
			HANDLE hFile2=CreateFile(binfile.String,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
			if(!hFile){
				ShowMessage("ERROR: file does not exists");
				return;
			}
			GetFileTime(hFile2,NULL,NULL,&ftime2);
			CloseHandle(hFile2);
			
			ftime.dwLowDateTime&=0xC0000000;
			ftime2.dwLowDateTime&=0xC0000000;
			
			if(ftime2.dwHighDateTime>ftime.dwHighDateTime){
				suggestbuild=1;
			}
			if(ftime2.dwHighDateTime==ftime.dwHighDateTime){
				if(ftime2.dwLowDateTime>ftime.dwLowDateTime)
					suggestbuild=1;
			}
			if(suggestbuild==1){
				if(MessageBox(hwnd,"ASM file is not up to date\nWould you like to rebuild it?","too old ASM file",MB_YESNO)== IDYES){
					CompilerFormWin->CheckGenASM=1;
					Compile1Click();
					if(FileExists(ASMfilename)){
						ASMcodelist->LoadFromFile(ASMfilename);
					}
				}
			}
			ASMcodelist->LoadFromFile(ASMfilename);
		}else{
			if(MessageBox(hwnd,"ASM file does not exist for the project\nWould you like to build it?","missing ASM file",MB_YESNO)== IDYES){
				CompilerFormWin->CheckGenASM=1;
				Compile1Click();
				if(FileExists(ASMfilename)){
					ASMcodelist->LoadFromFile(ASMfilename);
				}
			}
		}
	}
	AsmFormWin->SpecifyAsmFile(ASMfilename,ASMcodelist);
	AsmFormWin->SuccessMsgEnabled=1;
	AsmFormWin->ShowModal();
	
	delete ASMcodelist;
}
//---------------------------------------------------------------------------

void  MainForm::Assembler1Click()
{
	Button6Click();
}
//---------------------------------------------------------------------------

void  MainForm::Button5Click()
{
	//Machine simulator
	SetStateIcon(RunIcon);
	AnsiString s,BINfilename;
	BINfilename=ChangeFileExt(INPUTfile,"BIN");
	s=ExtractFilePath(Application->ExeName)+"BaranyCPUsim.exe";
	if(!FileExists(s.c_str())){
		ShowError("ERROR CPU simulator executive does not exist!","ERROR CPU SIM");
		return;
	}
	if(!FileExists(BINfilename.c_str())){
		ShowError("ERROR BIN file does not exist!","File error");
		return;
	}
	//z=s+" "+BINfilename;
	//system(s.c_str());
	Application->ExecuteCommandLine(s);
}
//---------------------------------------------------------------------------

void  MainForm::MachineEmulator1Click()
{
	Button5Click();
}
//---------------------------------------------------------------------------

//Preprocess Commands :
//Inline Assembly
//PRINT
//un-numbered lines
int  MainForm::PreprocessCommands(TStringList* Clist){
	int x,y,ww,q,pos,pos2,res=0,p2,megvan;
	AnsiString s,z,w,u;
	u="";
	char*v;
	
	//remove special characters from REM lines
	for(x=0;x<Clist->Count;x++ ){
		s=Clist->Strings[x];
		if(pos=s.AnsiPos("REM ")){
			if((pos==1)||(s[pos-1]==' ')){
				for(y=pos+2;y<=s.Length();y++){
					if((s[y]=='"')||(s[y]==':'))
						s[y]=' ';
				}
				Clist->Strings[x]=s;
			}
		}
	}
	
	//Check for #MULTIPAGES directive
	CompilerFormWin->multipages=0;
	for(x=0;(x<Clist->Count)&&(x<5);x++ ){
		s=Clist->Strings[x];
		if(s.AnsiPos("#MULTIPAGES")==1){
			CompilerFormWin->multipages=1;
			s="REM MULTIPAGES";
			Clist->Strings[x]=s;
		}
	}
	
	//Number Unnumbered lines
	s=Clist->Strings[0];
	if(s.AnsiPos("#UNNUMBERED")==1 ){
		Clist->Strings[0]="5 REM UNNUMBERED";
		for(x=1;x<Clist->Count;x++ ){
			s=Clist->Strings[x];
			if(s.IsEmpty())continue;
			if(s.AnsiPos("ASM")==1){
				z.Sprintf("%d",(x)*10);
				Clist->Strings[x]=z+" ASM";
				x++;
				while(x<Clist->Count){
					s=Clist->Strings[x];
					if(s.AnsiPos("END")==1)break;
					x++;
				}
				continue;
			}

			z.Sprintf("%d",x*10);
			Clist->Strings[x]=z+" "+s;
		}
		//Unnumbered JUMP commands
		//GOSUB, THEN, GOTO, ON GOTO
		Ulist=new(TStringList);		
		for(x=1;x<Clist->Count;x++ ){
			s=Clist->Strings[x];
			pos=s.AnsiPos(" @");
			if(pos && (pos==s.AnsiPos(" ")) ){
				if(!(p2=s.AnsiPos(":"))){
					continue;
				}
				z=s.SubString(1,p2-1);
				Ulist->Add(z);
				s.Delete(pos,p2-pos+1);
				if(!s.AnsiPos(" "))s=s+" REM -";
				Clist->Strings[x]=s;
			}
		}
		for(x=1;x<Clist->Count;x++ ){
			s=Clist->Strings[x];
			if(s.AnsiPos("GOSUB")||s.AnsiPos("THEN")||s.AnsiPos("GOTO")){

				while(pos=s.AnsiPos("@")){
					megvan=0;
					for(y=0;y<Ulist->Count;y++ ){
						z=Ulist->Strings[y];
						p2=z.AnsiPos(" ");
						z.Delete(1,p2);
						if(pos=s.AnsiPos(z)){
							v=&s.String[pos-1+strlen(z.String)];
							if((*v!=' ')&&(*v!=0))
								continue;
							w=Ulist->Strings[y];
							w=w.SubString(1,p2-1);
							s.Delete(pos,z.Length() );
							s.Insert(w,pos);
							Clist->Strings[x]=s;
							megvan=1;
							break;
						}
					}
					if(!megvan){
						ShowMessage(u+"ERROR: "+s);
						return x;
					}
				}
			}
		}
		//Clist->SaveToFile("ASMatom.txt");
		Ulist->Clear();
		delete Ulist;

	}
	
	//Handle SID DATA lines
	for(x=0;x<Clist->Count;x++){
		s=Clist->Strings[x];
		if(ww=s.Pos(" SDAT ")){
			s[ww+1]='D';s[ww+2]='A';s[ww+3]='T';s[ww+4]='A';
			ww+=6;
			while((s[ww]!=' ')&&(ww<s.Length()))ww++;
			
			u=s.SubString(1,ww-1);
			s.Delete(1,ww-1);
			
			for(y=0;y<SIDMUSICSCALENUM;y++){
				for(q=0;q<strlen(s.String)-2;q++){
					v=strstr(s.String,SIDmusical[y].note);
					if(!v)continue;
					if((SIDmusical[y].note[2]=='$')&&(*(v+2)!='$'))continue;
					if((SIDmusical[y].note[2]!='$')&&(*(v+2)=='$'))continue;

					strcpy(v,v+strlen(SIDmusical[y].note));
					sprintf(z.String,"%d",SIDmusical[y].value);
					strcpy(w.String,v);
					strcpy(v,z.String);
					strcpy(v+strlen(z.String),w.String);
				}
			}
			s=u+s;
			Clist->Strings[x]=s;
		}
		
	}
	u="";

	//Inline Strings
	//PRINT , DIM , STRCPY , STRCMP , STRPOS
	ww=1;
	for(x=0;x<Clist->Count;x++ ){
		s=Clist->Strings[x];
		if( (s.AnsiPos("STRCPY")) || (s.AnsiPos("STRCMP")) || (s.AnsiPos("STRPOS")) ){
			if(s[s.Length()]!='"')
				continue;
			pos2=0;
			for(pos=1;pos<s.Length();pos++){
				if(s[pos]=='"'){
					if(!pos2){
						pos2=pos;
					}else{
						ShowMessage(u+"ERROR: Another String or nested Strings are not allowed\n"+s);
						return x;
					}
				}
			}
			if(!pos2){
				ShowMessage(u+"ERROR: String is not closed\n"+s);
				return x;
			}
			z=s;
			z.Delete(1,pos2-1);		//string constant
			s=s.SubString(1,pos2-1);//remainder command
			
			pos=s.Pos(" ");
			u=s.SubString(1,pos);
			s.Delete(1,pos);
			
			sprintf(w.String,"TMP%dSTR$",ww++);
			u=u+"DIM "+w+"[]="+z+":"+s+w;
			Clist->Strings[x]=u;
			u="";
		}
		
		//Look for string containing commands
		if( (s.AnsiPos("DIM")) || (s.AnsiPos("PRINT")) ){
			if(pos=s.AnsiPos("\"")){
				s[pos]='\'';
			}else continue;
			if(pos2=s.AnsiPos("\"")){
				s[pos2]='\'';
			}
			if( pos && !pos2 ){
				ShowMessage(u+"ERROR in string constant\n"+s);
				return x;
			}
			if(s.AnsiPos("\"")){
				ShowMessage(u+"ERROR: Another String or nested Strings are not allowed\n"+s);
				return x;
			}
			for(pos=1;pos<=s.Length();pos++){
				if(s[pos]==':'){
					if(pos==pos2+1)
						continue;
					else
						s[pos]=2;
				}
			}
			while(pos=s.AnsiPos("\\n")){
				s.Delete(pos,1);
				s[pos]=10;
			}
			Clist->Strings[x]=s;
		}
	}

	//Look for 'ASM'
	int inasm=0,e,elso;

	for(x=0;x<Clist->Count;x++ ){
		s=Clist->Strings[x];
		if(s.AnsiPos("ASM")){
			inasm=1;
			if(InlineASM==NULL)InlineASM=new(TStringList);
			InlineASM->Clear();
			break;
		}
	}

	if(inasm)for(x=0;x<Clist->Count;x++ ){
		s=Clist->Strings[x];
		e=s.AnsiPos(" ");
		s.Delete(1,e);
		if(s.AnsiPos("ASM")==1){
			elso=1;
			while(x<Clist->Count){
				s=Clist->Strings[x];
				InlineASM->Add(s);
				if(!elso)Clist->Strings[x]="";else elso=0;
				if(s.AnsiPos("END")==1)break;
				x++;
			}

		}
	}
	
//	Clist->SaveToFile("atom.txt");
//	InlineASM->SaveToFile("bumm.txt");

	int num=Clist->Count;
	for(x=0;x<num;x++){
		if(Clist->Strings[x].IsEmpty()){
			Clist->Delete(x);
			x--;
		}
		num=Clist->Count;
	}

	return 0;
}


void  MainForm::FormDestroy()
{
	if(InlineASM)delete InlineASM;
	InlineASM=NULL;	
}
//---------------------------------------------------------------------------

void  MainForm::InsertInlineASM(TStringList* ASM){
	TStringList* list=ASM;

	if(InlineASM==NULL)return;

	//list=new(TStringList);
	//list->LoadFromFile(ASM);
	
	int x,y,pos;
	AnsiString s,z;

	for(x=0;x<list->Count;x++ ){
		s=list->Strings[x];
		if(s.AnsiPos("ASM")){
			pos=s.AnsiPos(" ");
			if(s.AnsiPos("ASM")!=pos+1)continue;
			s=s.SubString(1,pos-1);
			if(s[1]!='@')continue;
			s.Delete(1,1);
			for(y=0;y<InlineASM->Count;y++ ){
				z=InlineASM->Strings[y];
				if(z.AnsiPos(s)==1){
					y++;
					z=InlineASM->Strings[y];
					while(y<InlineASM->Count){
						z=InlineASM->Strings[y];
						if(z.AnsiPos("END")==1)break;
						list->Insert((long)x,z);
						x++;y++;
					}
					if(z.AnsiPos("END")!=1){
						ShowMessage("ERROR Inline ASM");
						return;
					}else break;
				}
			}
		}
	}

	for(x=0;x<list->Count;x++ ){
		s=list->Strings[x];
		if(s.IsEmpty() )continue;
		if(s[1]=='@')s="";
		list->Strings[x]=s;
	}

	//list->SaveToFile(ASM);
	//list->Clear();
	//delete list;
}

void  MainForm::DisplayFailedLine(TStringList* BasicOutpLst,TStringList* ASMsource,int failedLine,int type){
	TStringList*Orig=new TStringList();
	int x,line,sline;
	AnsiString s,z;
	char* str;
	for(x=0;x<Memo1->Count();x++){
		Orig->Add(Memo1->Strings[x]);
	}
	
	//Number Unnumbered lines
	s=Orig->Strings[0];
	if(s.AnsiPos("#UNNUMBERED")==1 ){
		Orig->Strings[0]="5 REM UNNUMBERED";
		for(x=1;x<Orig->Count;x++ ){
			s=Orig->Strings[x];
			if(s.IsEmpty())continue;
			if(s.AnsiPos("ASM")){
				z.Sprintf("%d",(x)*10);
				Orig->Strings[x]=z+" ASM";
				x++;
				while(x<Orig->Count){
					s=Orig->Strings[x];
					if(s.AnsiPos("END"))break;
					x++;
				}
				continue;
			}

			z.Sprintf("%d",x*10);
			Orig->Strings[x]=z+" "+s;
		}
	}
	
	if(type==BASICerror){
		s=BasicOutpLst->Strings[failedLine];
		sscanf(s.String,"%d",&line);
		failedLine=0;
		for(x=0;x<Orig->Count;x++ ){
			z=Orig->Strings[x];
			sscanf(z.String,"%d",&sline);
			if(line==sline){
				failedLine=x;
				break;
			}
		}
	}
	
	if(type==ASMerror){
		int basicnum=-1;
		int ASMbasicnum=-1;
		if(ASMsource){
			s=ASMsource->Strings[failedLine];
			for(x=failedLine;x>=0;x--){
				z=ASMsource->Strings[x];
				str=z.String;
				if((str[0]=='L')&&(str[1]=='N')&&(str[2]=='_')&&(str[strlen(str)-1]==':')){
					z.Delete(1,3);
					z.Delete(z.Length(),1);
					basicnum=z.ToInt();
					ASMbasicnum=x;
					break;
				}
			}
			if(basicnum==-1){
				ShowMessage("ERROR: ASM module returned invalid error code");
				failedLine=0;
			}else{
				sline=-1;
				for(x=0;x<Orig->Count;x++ ){
					z=Orig->Strings[x];
					sscanf(z.String,"%d",&line);
					if(line==basicnum){
						sline=line;
						break;
					}
				}
				if(sline==-1){
					ShowMessage("ERROR: ASM lines are incoherent to BASIC lines");
					failedLine=0;
				}else{
					failedLine=x+failedLine-ASMbasicnum;
				}
			}
		}else{
			ShowMessage("ERROR: DisplayFailedLine() ASMsource does not exist!");
		}
	}
	
	if(Memo1->Count()>failedLine)Memo1->SelectLine(failedLine);
	delete Orig;
}

void  MainForm::PostProcessAsmFile(TStringList* ASM){
	//This is the post -processing of ASM file
	//For example handle DATA-READ POINTER problem.
	
	//TStringList* list=new(TStringList);
	//list->LoadFromFile(ASM);
	TStringList* list=ASM;
	
	int van=0;
	int x;
	AnsiString s;
	for(x=0;x<list->Count;x++){
		s=list->Strings[x];
		if(s[1]=='*'){
			CompilerFormWin->SplitBySpace(s);
			if(CompilerFormWin->R1.AnsiCompare("*BASIC"))
				continue;
			van=1;
			s=CompilerFormWin->R3;
			s.Insert("_POI",9);
			s.Insert(" [",1);
			s.Insert(CompilerFormWin->R2,1);
			if(CompilerFormWin->R4[1]=='1')
				s=s+"+1]";
			else
				s=s+"]";
			list->Strings[x]=s;
		}
	}

	//if(van)list->SaveToFile(ASM);
	//delete list;
}

void MainForm::OnUserMessage(WPARAM wParam, LPARAM lParam){
	BasicEmuWin->OnUserMessage(wParam,lParam);
}

//Do the compile and download to real Machine (program downloading)
void MainForm::DoAll(){
	AnsiString s;
	SetDefaultFileGeneration();
	
	SetStateIcon(RunIcon);
	CompilerFormWin->AutomatedMode=1;
	Compile1Click();
	CompilerFormWin->AutomatedMode=0;
	if(!COMPILESUCCESS){
		return;
	}
	
	s=ExtractFilePath(Application->ExeName)+"Bprog.exe";
	if(!FileExists(s.c_str())){
		ShowError("ERROR: Program downloader does not exist!","ERROR PROGRAMMER");
		return;
	}
	s=s+" imme";
	int exitcode=Application->ExecuteCommandLine(s);
	if(exitcode==5)
		SetStateIcon(SuccessIcon);
	else
		SetStateIcon(ErrorIcon);
}

//Start programmer
void MainForm::Programmer(){
	AnsiString s;
	SetStateIcon(LoaderIcon);
	s=ExtractFilePath(Application->ExeName)+"Bprog.exe";
	if(!FileExists(s.c_str())){
		ShowError("ERROR: Program downloader does not exist!","ERROR PROGRAMMER");
		return;
	}
	Application->ExecuteCommandLine(s);
}

void MainForm::OnKeyDown(WPARAM w){
	w=w&0xFF;
	//char c=(char)w;
	if(w==120){
		DoAll();
	}
}

void MainForm::Button7Click(){
	Programmer();
}

void MainForm::Button8Click(){
	DoAll();
}

void MainForm::CheckBox1Click(){
	if(CheckBox1->Checked){
		CheckBox1->Checked=false;
		ExternalFile=0;
	}else{
		CheckBox1->Checked=true;
		ExternalFile=1;
	}
}

void MainForm::OnPaint(){
  	HDC         hdc;
	PAINTSTRUCT ps;
    hdc = BeginPaint (hwnd, &ps);
    if(!hdc)
		MessageBox(hwnd, TEXT("ERROR: BeginPaint() failed !"), TEXT("Bitmap error"), MB_APPLMODAL | MB_ICONSTOP);
	DrawIcon(hdc,30,110,DELETEICON);
	DrawIcon(hdc,30,110,SysIcon);
    EndPaint (hwnd, &ps);
}

void MainForm::SetStateIcon(HICON icon){
	SysIcon=icon;
	OnPaint();
	RECT r;
	r.left=30;
	r.top=110;
	r.right=r.left+32;
	r.bottom=r.top+32;
	InvalidateRect(hwnd,&r,FALSE);
}
