//MainForm
#ifndef MainFormH
#define MainFormH

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\EditClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\OpenFileClass.h"
#include "..\TGroupBox.h"
#include "..\MemoClass.h"
#include "..\TCheckBox.h"
#include "..\CompilerForm\SIDmusical.h"

#include "resource.h"

#include "MainFormParams.h"

enum {ASMerror,BASICerror};

class MainForm : public FormClass{
public:
	MainForm();
	~MainForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);
	
	Memo* Memo1;
	Button* Button1;
	Button* Button2;
	Button* Button3;
	Button* Button4;
	Button* Button5;
	Button* Button6;
	Button* Button7;
	Button* Button8;
	TCheckBox* CheckBox1;
	EditBox* Edit1;
	TGroupBox* GroupBox1;
	TGroupBox* GroupBox2;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;

	void  Button1Click();
	void  Button2Click();
	void  Button3Click();
	void  Button4Click();
	void  Button5Click();
	void  Button6Click();
	void  Button7Click();
	void  Button8Click();
	void  FormCreate();
	void  FormDestroy();
	void  Open1Click();
	void  Save1Click();
	void  About1Click();
	void  Compile1Click();
	void  Emulation1Click();
	void  Setup1Click();
	void  Assembler1Click();
	void  MachineEmulator1Click();
	void  SaveCurrent();
	void  OnUserMessage(WPARAM wParam, LPARAM lParam);
	void  OnKeyDown(WPARAM w);
	void  CheckBox1Click();
	void  OnPaint();
	
private:	// User declarations
	AnsiString INPUTfile;
	AnsiString DESTfile;
	int loaded;
	void  Compile();
	void DelEmptyLines();
	void SetDefaultFileGeneration();
	int  PreprocessCommands(TStringList* Clist);
	TStringList* InlineASM;
	TStringList* Ulist;	
	void  InsertInlineASM(TStringList* ASM);
	void  PostProcessAsmFile(TStringList* ASM);
	void  DisplayFailedLine(TStringList* BasicOutpLst,TStringList* ASMsource,int failedLine, int type);
	void  DoAll();
	void  Programmer();
	int COMPILESUCCESS;
	int ExternalFile;	//This is a flag: if==1->load file again, if==0->save the current editor
	void SetStateIcon(HICON icon);
	HICON SysIcon;		//System ICON to show system state
	HICON CompileIcon;
	HICON ErrorIcon;
	HICON LoaderIcon;
	HICON RunIcon;
	HICON SaveIcon;
	HICON SuccessIcon;
	HICON WriteIcon;
	HICON DELETEICON;
};

#endif
