//MainForm
#include "CompilerForm.h"
#include "CompilerFormParams.h"
#include "CMDstrings.h"

CompilerForm::CompilerForm(HWND Owner,int Resource){
	AutomatedMode=0;
	ASMoutput=NULL;
	CheckGenASM=0;
    //CreateSpecial("BASIC COMPILER",50,50,280,350,1);
	CreateDialogBox(Owner,Resource);
	STX=100;
	STY=50;
	WID=280;
	HEI=350;
	
//user code here	
	u="";
	fgenMASM=0;
	fgenASM=0;
	fgenHEX=0;
	fgenOBJ=0;
	multipages=0;
}

CompilerForm::~CompilerForm(){
//user code here

    //DestroyForm();
}

//Build up form
void CompilerForm::BuildForm(HWND hwnd,HINSTANCE hInst){
	CreateGrElem( Label, Label1 );
	CreateGrElem( Label, Label2 );
	CreateGrElem( Label, Label3 );
	CreateGrElem( TRadioButton, RadioButton1 );
	CreateGrElem( TRadioButton, RadioButton2 );
	CreateGrElem( TCheckBox, CheckBox1 );
	CreateGrElem( TCheckBox, CheckBox2 );
	CreateGrElem( TCheckBox, CheckBox3 );
	CreateGrElem( TCheckBox, CheckBox4 );
	CreateGrElem( Button, Button1 );
	CreateGrElem( Button, Button2 );
	
	RadioButton1->Checked=true;
	if(CheckGenASM){
		CheckGenASM=0;
		CheckBox2->Checked=true;
	}
	
	Label3->Caption="";
	
	FormCreate();
	
	//1=Start compilation immediately and no "Success" message
	if(AutomatedMode){
		Button1Click();
	}
}

//Destroy form
void CompilerForm::DestroyForm(){
    delete Label1;
	delete Label2;
	delete Label3;
	delete RadioButton1;
	delete RadioButton2;
	delete CheckBox1;
	delete CheckBox2;
	delete CheckBox3;
	delete CheckBox4;
	delete Button1;
	delete Button2;
	int x;
	for(x=0;x<Vcnt;x++){
		if(V[x].array){
			delete[] V[x].array;
			V[x].array=NULL;
		}
	}
}

void CompilerForm::OnCommand(WORD command){
    REGCALLBK(Button1) Button1Click();
	REGCALLBK(Button2) Button2Click();
	REGCALLBK(RadioButton1) RadioButton1Click();
	REGCALLBK(RadioButton2) RadioButton2Click();
	REGCALLBK(CheckBox1) CheckBox1Click();
	REGCALLBK(CheckBox2) CheckBox2Click();
	REGCALLBK(CheckBox3) CheckBox3Click();
	REGCALLBK(CheckBox4) CheckBox4Click();
}

//******************************************************************************
//    CALLBACK functions
//******************************************************************************
void  CompilerForm::RadioButton1Click(){
	if(RadioButton1->Checked==false){
		RadioButton1->Checked=true;
		RadioButton2->Checked=false;
	}
}

void  CompilerForm::RadioButton2Click(){
	if(RadioButton2->Checked==false){
		RadioButton2->Checked=true;
		RadioButton1->Checked=false;
	}
}

void  CompilerForm::CheckBox1Click(){
	if(CheckBox1->Checked)
		CheckBox1->Checked=false;
	else
		CheckBox1->Checked=true;
}

void  CompilerForm::CheckBox2Click(){
	if(CheckBox2->Checked)
		CheckBox2->Checked=false;
	else
		CheckBox2->Checked=true;
}

void  CompilerForm::CheckBox3Click(){
	if(CheckBox3->Checked)
		CheckBox3->Checked=false;
	else
		CheckBox3->Checked=true;
}

void  CompilerForm::CheckBox4Click(){
	if(CheckBox4->Checked)
		CheckBox4->Checked=false;
	else
		CheckBox4->Checked=true;
}

//---------------------------------------------------------------------------
void  CompilerForm::Button2Click()
{
	this->ModalResult(mrCancel);	
}
//---------------------------------------------------------------------------
void  CompilerForm::Button1Click()
{
	int res=0;
	if(RadioButton2->Checked){
		ShowMessage("ERROR Andras Bognar System is not yet implemented");
		return;
	}
	Button1->Enabled=false;
	Button2->Enabled=false;

	if(CheckBox1->Checked)fgenMASM=1;
	else fgenMASM=0;
	if(CheckBox2->Checked)fgenASM=1;
	else fgenASM=0;
	if(CheckBox3->Checked)fgenOBJ=1;
	else fgenOBJ=0;
	if(CheckBox4->Checked)fgenHEX=1;
	else fgenHEX=0;
	
	try{
		res=Compile();
	}catch(int e){
		res=0;
	}

	if(res==-1)this->ModalResult(mrCancel);
	else this->ModalResult(mrOk);
}
//---------------------------------------------------------------------------


int CompilerForm::Compile(){
	int res=0;
	SR1full=0;
	Label3->Caption="COMPILING...";

	MASMoutput=new(TStringList);	
	MASMoutput->Add("STARTCODE");
	for(commandCNTR=0;commandCNTR<CMDnum;commandCNTR++)
		ProcessCommand(&CMD[commandCNTR]);
	MASMoutput->Add("ENDCODE");
	AnsiString MasmFile=DESTfile;
	MasmFile=ChangeFileExt(MasmFile,"MASM");
	OptimalizeMasm();
	if(multipages)
		res=MasmToAsmPag();
	else
		res=MasmToAsm();
	if(fgenMASM){
		MASMoutput->SaveToFile(MasmFile);
	}
	delete MASMoutput;

	Label3->Caption="";
	return res;
}

void  CompilerForm::FormCreate()
{
	commandCNTR=0;
	Vcnt=0;
	MaxColorDepth=250;
	MaxX=34,MaxY=34;
	RandSeed();

	printnum=0;
}
//---------------------------------------------------------------------------


void  CompilerForm::SplitBySpace(AnsiString cmd){
	int x;
	int pos=0;
	char c[200];
	for(x=1;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R1.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R2.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R3.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R4.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==' ')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R5.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R6.Sprintf("%s",c);

}

void  CompilerForm::SplitByComma(AnsiString cmd){
	int x;
	int pos=0;
	char c[200];

	//change array index separator to ';' :   A[1,2]->A[1;2]
	int arrayIS=0;
	for(x=1;x<=cmd.Length();x++ ){
		if(!arrayIS){
			if(cmd[x]=='['){
				arrayIS=1;
			}
		}else{
			if(cmd[x]==']'){
				arrayIS=0;
			}else if(cmd[x]==','){
				cmd[x]=';';
			}
		}
	}
	//SPLITTING
	for(x=1;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R1.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R2.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R3.Sprintf("%s",c);

	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R4.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		if(cmd[x]==',')break;
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R5.Sprintf("%s",c);


	pos=0;
	for(;x<=cmd.Length();x++ ){
		c[pos++]=cmd[x];
	}
	x++;c[pos]=0;
	R6.Sprintf("%s",c);

	//CHANGE BACK ';' to ','
	for(x=1;x<=R1.Length();x++){
    	if(R1[x]==';')R1[x]=',';
	}
	for(x=1;x<=R2.Length();x++){
		if(R2[x]==';')R2[x]=',';
	}
	for(x=1;x<=R3.Length();x++){
		if(R3[x]==';')R3[x]=',';
	}
	for(x=1;x<=R4.Length();x++){
		if(R4[x]==';')R4[x]=',';
	}
	for(x=1;x<=R5.Length();x++){
		if(R5[x]==';')R5[x]=',';
	}
	for(x=1;x<=R6.Length();x++){
		if(R6[x]==';')R6[x]=',';
	}
}

void  CompilerForm::MakeCommandlist(){
	int num=commands->Count;
	CMDnum=num;
	CMD=new(command[num]);
	AnsiString str,tstr;
	AnsiString SubCmd;
	int P1;
	unsigned char quote;
	int w,x,y;
	command* futo=NULL;
	char c;

	for(x=0;x<num;x++){
		if(commands->Strings[x].IsEmpty()){
			commands->Delete(x);
			x--;
		}
		num=commands->Count;
	}
	num=commands->Count;

	for(x=0;x<num;x++){
		str=commands->Strings[x];
		if(str.IsEmpty())continue;
		P1=1;quote=0;

		SplitBySpace(str);
		CMD[x].commandCNTR=x;
		try {CMD[x].ord=R1.ToInt();}
		catch (Exception &exception) {
			AnsiString s; s.Sprintf("%d",x+1);
			ShowMessage(u+"ERROR in text line "+s+" - not a number");
			errorlinenum=x;
			this->ModalResult(mrOk);
			return;
		}
		str.Delete(1,R1.Length()+1);
		if((str[1]=='I')&&(str[2]=='F')){
			int thx=str.AnsiPos("THEN");
			if((str[thx+4]==0)||(str[thx+5]==0)){
				AnsiString s; s.Sprintf("%d",x+1);
				ShowMessage(u+"ERROR in text line "+s+" - invalid IF-THEN statement");
				errorlinenum=x;
				this->ModalResult(mrCancel);
				return;
			}
			str[thx+4]=':';
		}
		futo=&CMD[x];

		for(w=1;w<=str.Length();w++){
			if(str[w]=='"'){quote=!quote;continue;}
			if(quote)continue;
			if((w>1)&&(w<str.Length())){
				if((str[w-1]=='\'')&&(str[w+1]=='\''))
					continue;
			}
			if((str[w]==':')||(w==str.Length())){
				SubCmd=str.SubString(P1,w-P1+1);
				P1=w+1;
				if(str[w]==':')SubCmd.Delete(SubCmd.Length(),1);
				SplitBySpace(SubCmd);

				futo->CMDtext=R1;
				for(y=0;y<CMDliteralsNUM;y++){
					sprintf(tstr.String,"%s",CMDliterals[y]);
					if(!futo->CMDtext.AnsiCompare(tstr) ){
						futo->CMDcode=y;
						break;
					}
				}
				if(y>=CMDliteralsNUM){
					futo->CMDcode=-1;
				}
				futo->PARAM=R2;
				if(!R3.IsEmpty() )futo->PARAM=futo->PARAM+" "+R3;
				if(!R4.IsEmpty() )futo->PARAM=futo->PARAM+" "+R4;
				if(!R5.IsEmpty() )futo->PARAM=futo->PARAM+" "+R5;
				if(!R6.IsEmpty() )futo->PARAM=futo->PARAM+" "+R6;
				futo->JMPcode=-1;
				futo->runstate=0;
				futo->SubCMD=NULL;
				if(str[w]==':'){
					futo->SubCMD=new(command);
					futo->SubCMD->ord=futo->ord;
					futo=futo->SubCMD;
				}
			}
		}
	}

	//BUBBLE SORT FOR COMMANDS
	command tmp;
	int csere=1;
	while(csere){
		csere=0;
		for(x=0;x<num-1;x++){
			if(CMD[x].ord>CMD[x+1].ord ){
				csere=1;
				tmp=CMD[x];
				CMD[x]=CMD[x+1];
				CMD[x+1]=tmp;
			}
		}
	}

	//Check if same ORD NUM exists
	int lastN=CMD[0].ord;
	for(x=1;x<num;x++){
		if(CMD[x].ord==lastN){
			AnsiString s; s.Sprintf("%d",x+1);
			ShowMessage(u+"ERROR in text line "+s+" - number already exists");
			errorlinenum=x-1;
			this->ModalResult(mrOk);
			return;
		}
		lastN=CMD[x].ord;
	}

	//GOTO, FOR , ... jumping commands - preprocessing - JMPcode
	for(x=0;x<num;x++){
		futo=&CMD[x];
		while(futo){
			switch(futo->CMDcode){
				case 1:	//NEXT
					str=futo->PARAM;
					for(w=x;w>=0;w--){
						if(CMD[w].CMDcode==0){
							tstr=GetFirstVariableName(CMD[w].PARAM);
							//(str.Length()>tstr.Length())?str.Delete(tstr.Length()+1,str.Length()-tstr.Length()):tstr.Delete(str.Length()+1,tstr.Length()-str.Length());
							c=0;y=0;
							while(y<str.Length()){
								c=str.String[y];
								if( ((c>='a')&&(c<='z')) || ((c>='A')&&(c<='Z')) || ((c>='0')&&(c<='9')) || (c=='_') ){
									y++;
									continue;
								}else{
									str.String[y]=0;
									break;
								}
							}
							c=0;y=0;
							while(y<tstr.Length()){
								c=tstr.String[y];
								if( ((c>='a')&&(c<='z')) || ((c>='A')&&(c<='Z')) || ((c>='0')&&(c<='9')) || (c=='_') ){
									y++;
									continue;
								}else{
									tstr.String[y]=0;
									break;
								}
							}
							if(!str.AnsiCompare(tstr)){
								futo->JMPcode=w;
								CMD[w].JMPcode=x;
								break;
							}
						}
					}
					if(w<0){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - Unmatched NEXT ?");
						errorlinenum=x;
						this->ModalResult(mrOk);
						return;
					}
					break;
				case 11:
				case 2: //GOTO, GOSUB
					if(IsNumber(futo->PARAM)){
						w=futo->PARAM.ToInt();
						for(y=0;y<num;y++){
							if(CMD[y].ord==w){
								futo->JMPcode=y;
								break;
							}
						}
						if(y>=num){
							AnsiString s; s.Sprintf("%d",x+1);
							ShowMessage(u+"ERROR in text line "+s+" - invalid GOTO/GOSUB statement");
							errorlinenum=x;
							this->ModalResult(mrOk);
							return;
						}
					}
					break;
				case 4:	//IF
					w=futo->PARAM.AnsiPos("THEN");
					if(w==0){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - invalid IF statement");
						errorlinenum=x;
						this->ModalResult(mrOk);
						return;
					}
					str=futo->SubCMD->CMDtext;
					if(IsNumber(str)){
						w=str.ToInt();
						for(y=0;y<num;y++){
							if(CMD[y].ord==w){
								futo->JMPcode=y;
								break;
							}
						}
						if(y>=num){
							AnsiString s; s.Sprintf("%d",x+1);
							ShowMessage(u+"ERROR in text line "+s+" - invalid JUMP statement");
							errorlinenum=x;
							this->ModalResult(mrOk);
							return;
						}
					}
					break;
				case 31:	//PUTPATTERN
				case 85:	//PUTPATMIRVER
				case 86:	//PUTPATTWIST
				case 87:	//PUTPATTWISMIR
					str=futo->PARAM;
					SplitByComma(str);
					str=R1;
					if(R1[1]!='#')
						break;
					str.Delete(1,1);
					for(w=0;w<num;w++){
						if(CMD[w].CMDcode==35){
							y=CMD[w].PARAM.AnsiPos(" ");
							tstr=CMD[w].PARAM.SubString(1,y-1);
							if(!str.AnsiCompare(tstr)){
                             	futo->JMPcode=w;
								break;
							}
						}
					}
					if(w>=num){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - Unmatched READ, no maching DATA line");
						errorlinenum=x;
						this->ModalResult(mrOk);
						return;
					}
					break;
				case 42://SID
				case 43://SIDS
				case 44://SVOICE1
				case 45://SVOICE1S
				case 46://SVOICE2
				case 47://SVOICE2S
				case 48://SVOICE3
				case 49://SVOICE3S
				case 50://SFILTER
				case 51://SFILTERS
				case 53://SFREQ1S
				case 55://SPW1S
				case 61://SFREQ2S
				case 63://SPW2S
				case 69://SFREQ3S
				case 71://SPW3S
				case 17:	//READ
				case 18:	//RESTORE
					str=futo->PARAM;
					SplitByComma(str);
					str=R1;
					for(w=0;w<num;w++){
						if(CMD[w].CMDcode==35){
							y=CMD[w].PARAM.AnsiPos(" ");
							tstr=CMD[w].PARAM.SubString(1,y-1);
							if(!str.AnsiCompare(tstr)){
                             	futo->JMPcode=w;
								break;
							}
						}
					}
					if(w>=num){
						AnsiString s; s.Sprintf("%d",x+1);
						ShowMessage(u+"ERROR in text line "+s+" - Unmatched READ, no maching DATA line");
						errorlinenum=x;
						this->ModalResult(mrOk);
						return;
					}
					break;
			}
			futo=futo->SubCMD;
		}
	}
	//DATA lines preprocessing
	int vandata=0;
	for(x=0;x<num;x++){
		if(CMD[x].CMDcode==35){
			vandata=1;
		}
	}
	if(!vandata)return;


	//create DATA lines
	DATA=new(data_read[1000]);
	for(x=0;x<1000;x++){
		DATA[x].data=NULL;
		DATA[x].dpoi=0;
		DATA[x].dnum=0;
	}


	int* dt=new(int[10000]);
	int picturemode=0;
	//int tablemode=0;
	int tablecnt=0;
	int pdt=0;
	int RUN=1;
	for(x=0;x<num;x++){
		if(CMD[x].CMDcode==83){
			picturemode=1;
			tablecnt=-1;
		}
		if(CMD[x].CMDcode==84){
			//tablemode=1;
			tablecnt=-1;
		}
		if((CMD[x].CMDcode==88)||(CMD[x].CMDcode==89)){
			picturemode=0;
			//tablemode=0;
			for(y=0;y<1000;y++){
				if(DATA[y].data==NULL)break;
			}
			y--;
			for(;y>=0;y--){
				if(DATA[y].TableCnt==-1){
					break;
				}
			}
			if(y<0)y=0;
			DATA[y].TableCnt=tablecnt+1;
		}
		if(CMD[x].CMDcode==35){
			pdt=0;
			y=CMD[x].PARAM.AnsiPos(" ");
			CMD[x].PARAM.Delete(1,y);
			SplitByComma(CMD[x].PARAM);

			RUN=1;
			while(RUN){
				RUN=0;
				if( (!IsNumber(R1)) || (!R2.IsEmpty()&&!IsNumber(R2)) || (!R3.IsEmpty()&&!IsNumber(R3)) ||
					(!R4.IsEmpty()&&!IsNumber(R4)) || (!R5.IsEmpty()&&!IsNumber(R5))
				){
					AnsiString s; s.Sprintf("%d",x+1);
					ShowMessage(u+"ERROR in text line "+s+" - invalid DATA statement");
					errorlinenum=x;
					this->ModalResult(mrOk);
					return;
				}
				dt[pdt++]=R1.ToInt();
				if(IsNumber(R2))dt[pdt++]=R2.ToInt();
				if(IsNumber(R3))dt[pdt++]=R3.ToInt();
				if(IsNumber(R4))dt[pdt++]=R4.ToInt();
				if(IsNumber(R5))dt[pdt++]=R5.ToInt();
				if(IsNumber(R6))dt[pdt++]=R6.ToInt();
				else{
					if(!R6.IsEmpty()){
						SplitByComma(R6); RUN=1;
					}
				}
			}
			for(y=0;y<1000;y++){
				if(DATA[y].data==NULL)break;
			}
			if(DATA[y].data==NULL){
				DATA[y].dnum=pdt;
				DATA[y].dpoi=0;
				DATA[y].data=new(int[pdt]);
				DATA[y].PictureMode=picturemode;
				(tablecnt==-1) ? DATA[y].TableCnt=-1 : DATA[y].TableCnt=0;
				tablecnt+=pdt;
				for(w=0;w<pdt;w++){
					DATA[y].data[w]=dt[w];
				}
			}else{
				AnsiString s; s.Sprintf("%d",x+1);
				ShowMessage(u+"ERROR in text line "+s+" - too much DATA");
				errorlinenum=x;
				this->ModalResult(mrOk);
				return;
			}
			CMD[x].JMPcode=y;

		}

	}
	delete[] dt;
}

void  CompilerForm::DestroyCommandlist(){
	int x;

	if(DATA){
		for(x=0;x<1000;x++){
			if(DATA[x].data)delete[] DATA[x].data;
			DATA[x].data=NULL;
			DATA[x].dpoi=0;
			DATA[x].dnum=0;
		}
		delete[] DATA;
	}
	delete[] CMD;
}

//put SR1 to variable memory 
void  CompilerForm::PutVariable(AnsiString name){
	int x;
	char c;
	//check syntax
	c=name[1];
	if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || (c=='$')  ) ){
		ErrorMSG(u+"invalid variable name: '"+name+"'");return;
	}

	AnsiString prename,PX,PY;
	prename=SplitArrayVariableName(name,PX,PY);
	int X=0,Y=0;
	if(PX.IsEmpty())X=-1;
	if(PY.IsEmpty())Y=-1;

	for(x=1;x<=prename.Length();x++){
		c=prename[x];
		if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9')) || (c=='$') ) ){
			ErrorMSG(u+"invalid variable name: '"+prename+"'");return;
		}
	}

	//Search at first
	int megvan=0;
	for(x=0;x<Vcnt;x++){
		if(!V[x].name.AnsiCompare(prename) ){
			megvan =1;
			break;
		}
	}
	//create it
	if(!megvan){
		if((X==-1)&&(Y==-1)){
        	x=Vcnt;
			V[Vcnt].name=prename;
			V[Vcnt].type=1;
			V[Vcnt].value=0;
			V[Vcnt].dimX=-1;
			V[Vcnt].dimY=-1;
			Vcnt++;if(Vcnt>=5000){
				ShowMessage("FATAL: SYSTEM ERROR 12");return;
			}
		}else{
			ErrorMSG("invalid variable name");
			return;
		}
	}

	//Lookup
	switch(V[x].type){
		case 1:
			if((X!=-1)||(Y!=-1)){
				ErrorMSG("misplaced brackets[]");return;
			}
			MASMoutput->Add(u+"PUTVAR "+prename);
			break;
		case 2:
			if((X<0)||(Y!=-1)){
				ErrorMSG("misplaced brackets[]");return;
			}
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(PX);
			MASMoutput->Add("STOREINDEXX");
			MASMoutput->Add("POPSR1");
			if(V[x].array)
				MASMoutput->Add(u+"MP_PUTSTRING "+prename);
			else
				MASMoutput->Add(u+"PUTARRAYD1 "+prename);
			break;
		case 3:
			if((X<0)||(Y<0)){
				ErrorMSG("out-addressing");return;
			}
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(PX);
			MASMoutput->Add("STOREINDEXX");
			EvaluateExpression(PY);
			MASMoutput->Add("STOREINDEXY");
			MASMoutput->Add("POPSR1");
			MASMoutput->Add(u+"PUTARRAYD2 "+prename);
			break;
	}
}

//get variable from variable memory and put it to SR2
void  CompilerForm::GetVariable(AnsiString name){
	int x;
	AnsiString prename,PX,PY;
	prename=SplitArrayVariableName(name,PX,PY);
	int X=0,Y=0;
	if(PX.IsEmpty())X=-1;
	if(PY.IsEmpty())Y=-1;

	for(x=0;x<Vcnt;x++){
		if(!V[x].name.AnsiCompare(prename) ){
			switch(V[x].type){
				case 1:
					if((X!=-1)||(Y!=-1)){
						ErrorMSG("misplaced brackets[]");return;
					}
					MASMoutput->Add(u+"GETVAR "+prename);
					return;
					break;
				case 2:
					if((X<0)||(Y!=-1)){
						ErrorMSG("misplaced brackets[]");return;
					}
					if(SR1full){
						MASMoutput->Add("PUSHSR1");
						EvaluateExpression(PX);
						MASMoutput->Add("STOREINDEXX");
						if(V[x].array)
							MASMoutput->Add(u+"MP_GETSTRING "+prename);
						else
							MASMoutput->Add(u+"GETARRAYD1 "+prename);
						MASMoutput->Add("POPSR1");
					}else{
						EvaluateExpression(PX);
						MASMoutput->Add("STOREINDEXX");
						if(V[x].array)
							MASMoutput->Add(u+"MP_GETSTRING "+prename);
						else
							MASMoutput->Add(u+"GETARRAYD1 "+prename);
						MASMoutput->Add("MOVSR1SR2");
						SR1full=1;
					}
					return ;
					break;
				case 3:
					if((X<0)||(Y<0)){
						ErrorMSG("out-addressing");return;
					}
					if(SR1full){
						MASMoutput->Add("PUSHSR1");
						EvaluateExpression(PX);
						MASMoutput->Add("STOREINDEXX");
						EvaluateExpression(PY);
						MASMoutput->Add("STOREINDEXY");
						MASMoutput->Add(u+"GETARRAYD2 "+prename);
						MASMoutput->Add("POPSR1");
					}else{
						EvaluateExpression(PX);
						MASMoutput->Add("STOREINDEXX");
						EvaluateExpression(PY);
						MASMoutput->Add("STOREINDEXY");
						MASMoutput->Add(u+"GETARRAYD2 "+prename);
						MASMoutput->Add("MOVSR1SR2");
						SR1full=1;
					}
					return;
					break;
			}
		}
	}
	ErrorMSG("invalid variable");return;
}



AnsiString  CompilerForm::GetFirstVariableName(AnsiString line){
	AnsiString ret="";
	int x;
	char c;
	StringDollar=0;

	if(line.IsEmpty())return "";

	for(x=1;x<=line.Length();x++){
		c=line[x];
		if( !( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9'))) ){
			if(c=='$'){
				StringDollar=x;
				continue;
			}
			break;
		}
	}
	if(StringDollar){
		if((line[StringDollar+1]!='[')&&(line[StringDollar+1]!=0)){
			ErrorMSG("invalid string expression");return ret;
		}
	}
	if(c!='['){
		ret=line.SubString(1,x-1);
		return ret;
	}
	int bracketlev=1;
	x++;
	for(;x<=line.Length();x++){
		if(!bracketlev)break;
		c=line[x];
		if(c=='[')bracketlev++;
		if(c==']')bracketlev--;
	}
	if(bracketlev){
		ErrorMSG("invalid expression");return ret;
	}
	ret=line.SubString(1,x-1);

	return ret;
}

void  CompilerForm::EvaluateExpression(AnsiString expr){
	if(expr.IsEmpty()){ErrorMSG("invalid expression");return;}
	int x,w;
	int pos,spos;	
	int len=expr.Length();
	int brl[1000];
	int brr[1000];
	int lastbrl;
	//negative number is in brackets- quick check
	for(x=0;x<expr.Length();x++){
		if(expr.String[x]=='-'){
			if(x==0){
				ErrorMSG("invalid expression:\n negative number must be in brackets(1)");
				return;
			}
			char c=expr.String[x-1];
			if(!((c==']')||(c=='(')||(c==')')||(c=='$')||(c=='\'')||((c>='A')&&(c<='Z'))||((c>='a')&&(c<='z'))||((c>='0')&&(c<='9')))){
				ErrorMSG("invalid expression:\n negative number must be in brackets(2)");
				return;
			}
		}
	}
	//check brackets
	for(x=0;x<1000;x++){
		brl[x]=0;
		brr[x]=0;
	}
	for(x=1;x<=len;x++){
		if((expr[x]=='(')||(expr[x]=='[')){
			brl[x]=-1;
		}
		if((expr[x]==')')||(expr[x]==']')){
			pos=x;
			while((brl[pos]!=-1)&&(pos>=1))pos--;
			if(pos<1){
				ErrorMSG("expression sintax: brackets ()");return;
			}
			brl[pos]=x; 	brr[x]=pos;
		}
	}
	for(x=1;x<=len;x++){
		if((brl[x]==-1)||(brl[x]==-1)){
			ErrorMSG("expression sintax: brackets ()");return;
		}
	}

	//Put all arrays into brackets
	char c;
	for(x=1;x<=len;x++){
		if(expr[x]=='['){
			if((brl[x])>=expr.Length())
				expr=expr+")";
			else
				expr.Insert(")",brl[x]+1);
			pos=x-1;
			c=expr[pos];
			while( (pos>=1) && (((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9')) || (c=='$') ) ){
				c=expr[pos--];
			}
			if(!pos)pos++;
			else pos+=2;
			expr.Insert("(",pos);
			len+=2;

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}
			x++;

		}
	}

	//Put * and / operations into brackets
	for(x=1;x<=len;x++){
		if((expr[x]=='*')||(expr[x]=='/')){
			//check lower
			pos=x-1;
			if(pos<1){
				ErrorMSG("expression sintax");return;
			}
			if(expr[pos]==')'){
				expr.Insert("(",brr[pos] );
				lastbrl=brr[pos];
				len++;x++;
			}else{
				while((pos>=1)&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos--;
				}
				pos++;
				expr.Insert("(",pos);
				lastbrl=pos;
				len++;x++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if(w==lastbrl)continue;
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

			//check higher
			pos=x+1;
			if(pos>len){
				ErrorMSG("expression sintax");return;
			}
			if(expr[pos]=='('){
				expr.Insert(")",brl[pos] );
				len++;
			}else{
				while((pos<=len)&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos++;
				}
				if(pos==len)expr=expr+")";
				else expr.Insert(")",pos);
				len++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

		}
	}

	//Put RELATIONS  < , > , = , <= , >= , <>  into brackets
	for(x=1;x<=len;x++){
		if((expr[x]=='<')||(expr[x]=='>')||(expr[x]=='=')||(expr[x]=='\1')||(expr[x]=='\2')||(expr[x]=='#') ){
			//check lower
			pos=x-1;
			if(pos<1){
				ErrorMSG("expression sintax");return;
			}
			if(expr[pos]==')'){
				expr.Insert("(",brr[pos] );
				lastbrl=brr[pos];
				len++;x++;
			}else{
				while((pos>=1)
				/*
				(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				*/
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos--;
				}
				pos++;
				expr.Insert("(",pos);
				lastbrl=pos;
				len++;x++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if(w==lastbrl)continue;
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

			//check higher
			pos=x+1;
			if(pos>len){
				ErrorMSG("expression sintax");return;
			}
			if(expr[pos]=='('){
				expr.Insert(")",brl[pos] );
				len++;
			}else{
				while((pos<=len)
				/*
				&&(expr[pos]!='*')&&(expr[pos]!='/')&&(expr[pos]!='+')&&(expr[pos]!='-')
				&&(expr[pos]!='[')&&(expr[pos]!=']')&&(expr[pos]!=',')
				*/
				&&(expr[pos]!='#')&&(expr[pos]!='>')&&(expr[pos]!='<')&&(expr[pos]!='=')&&(expr[pos]!='!')
				&&(expr[pos]!='\1')&&(expr[pos]!='\2')&&(expr[pos]!='&')&&(expr[pos]!='|') ){
					pos++;
				}
				if(pos==len)expr=expr+")";
				else expr.Insert(")",pos);
				len++;
			}

			//re-order brl, brr
			for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
			for(w=1;w<=len;w++){
				if((expr[w]=='(')||(expr[w]=='[')){brl[w]=-1;}
				if((expr[w]==')')||(expr[w]==']')){
					spos=w;
					while((brl[spos]!=-1)&&(spos>=1))spos--;
					brl[spos]=w; 	brr[w]=spos;
				}
			}

		}
	}

	SR1full=0;
	BracketRecursive(expr);
}

//Solve brackets
void  CompilerForm::BracketRecursive(AnsiString expr){
	char* brl=new(char[1000]);
	char* brr=new(char[1000]);
	int len=expr.Length();
	int w,spos;
	int evalpos;
	int oper;//operator

	//register brackets
	for(w=0;w<1000;w++){brl[w]=0;brr[w]=0;}
	for(w=1;w<=len;w++){
		if(expr[w]=='('){brl[w]=-1;}
		if(expr[w]==')'){
			spos=w;
			while((brl[spos]!=-1)&&(spos>=1))spos--;
			brl[spos]=w; 	brr[w]=spos;
		}
	}


	//EVALUATE
	
	evalpos=1;
	oper=0;//1-addition 2-substraction 3-multiplication 4-division
	//MASMoutput->Add("MVISR1 0");
	char c;
	//evaluate
	while(evalpos<=len){
		c=expr[evalpos];

		//Embedded brackets
		if(c=='('){
			if(SR1full){
				MASMoutput->Add("PUSHSR1");
				SR1full=0;
				BracketRecursive(expr.SubString(evalpos+1,brl[evalpos]-evalpos-1));
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add("POPSR1");
				SR1full=1;				
			}else{
				BracketRecursive(expr.SubString(evalpos+1,brl[evalpos]-evalpos-1));
				SR1full=1;
			}
			evalpos=brl[evalpos]+1;

		//Variable
		}else if( ((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || (c=='$') ){
			AnsiString substr=expr;
			substr.Delete(1,evalpos-1);
			substr=GetFirstVariableName(substr);
			GetVariable(substr);
			if(!SR1full){
				MASMoutput->Add("MOVSR1SR2");
				SR1full=1;
			}
			evalpos+=substr.Length();

		//Number
		}else if( (c>='0')&&(c<='9') ){
			int subpos=evalpos;
			AnsiString substr;
			while((subpos<=len)&&  (((expr[subpos]>='0')&&(expr[subpos]<='9'))||(expr[subpos]=='x')||((expr[subpos]>='A')&&(expr[subpos]<='F')))  ){
				subpos++;
			}
			substr=expr.SubString(evalpos,subpos-evalpos);
			if(SR1full)MASMoutput->Add(u+"MVISR2 "+substr);
			else{MASMoutput->Add(u+"MVISR1 "+substr); SR1full=1;}
			evalpos=subpos;
			
		//character constant
		}else if(c=='\''){
			if(expr[evalpos+2]!='\''){
				ErrorMSG("expression sintax: \ninvalid character constant");return;
			}
			AnsiString substr;
			c=expr[evalpos+1];
			sprintf(substr.String,"%d",c);
			if(SR1full)MASMoutput->Add(u+"MVISR2 "+substr);
			else{MASMoutput->Add(u+"MVISR1 "+substr); SR1full=1;}
			evalpos+=3;

		//negative sign
		}else if(c=='-'){
			oper=2;
			evalpos++;
			MASMoutput->Add("MVISR1 0");
			SR1full=1;
			continue;

		//negotation operator
		}else if(c=='!'){
			evalpos++;
			if(expr[evalpos]!='('){ErrorMSG("expression sintax");return;}
			BracketRecursive(expr.SubString(evalpos+1,brl[evalpos]-evalpos-1));
			evalpos=brl[evalpos]+1;
			MASMoutput->Add("NEGOTATE");

		//ERROR
		}else{
			ErrorMSG("expression sintax");return;
		}

		//operation
		//1-addition 2-substraction 3-multiplication 4-division
		switch(oper){
			case 0:
				break;
			case 1:
				MASMoutput->Add("ADDSR");SR1full=1;
				break;
			case 2:
				MASMoutput->Add("SUBSR");SR1full=1;
				break;
			case 3:
				MASMoutput->Add("MULSR");SR1full=1;
				break;
			case 4:
				MASMoutput->Add("DIVSR");SR1full=1;
				break;
			case 5:
				MASMoutput->Add("ANDSR");SR1full=1;
				break;
			case 6:
				MASMoutput->Add("ORSR");SR1full=1;
				break;
			case 7:
				MASMoutput->Add("SMALLER");SR1full=1;
				break;
			case 8:
				MASMoutput->Add("BIGGER");SR1full=1;
				break;
			case 9:
				MASMoutput->Add("EQUAL");SR1full=1;
				break;
			case 10:
				MASMoutput->Add("NOTEQUAL");SR1full=1;
				break;
			case 11:
				MASMoutput->Add("SMALLEQ");SR1full=1;
				break;
			case 12:
				MASMoutput->Add("BIGEQ");SR1full=1;
				break;
		}

		//evaluate operator
		if(evalpos<=len){
			c=expr[evalpos];
			switch(c){
				case '+':
					oper=1;
					break;
				case '-':
					oper=2;
					break;
				case '*':
					oper=3;
					break;
				case '/':
					oper=4;
					break;
				case '&':
					oper=5;
					break;
				case '|':
					oper=6;
					break;
				case '<':
					oper=7;
					break;
				case '>':
					oper=8;
					break;
				case '=':
					oper=9;
					break;
				case '#':
					oper=10;
					break;
				case '\1':
					oper=11;
					break;
				case '\2':
					oper=12;
					break;
				default:
					ErrorMSG("expression sintax");return;
					break;
			}

			if(evalpos>len){
				ErrorMSG("expression sintax");return;
			}
		}

		evalpos++;
	}

	delete brl;
	delete brr;
}


AnsiString   CompilerForm::SplitArrayVariableName(AnsiString name, AnsiString &X, AnsiString &Y){
	char c;
	int x;
	AnsiString ret;
	AnsiString indexSTR;
	//int pos;

	X=""; Y="";

	for(x=1;x<=name.Length();x++){
    	c=name[x];
		if( !(((c>='A')&&(c<='Z')) || ((c>='a')&&(c<='z')) || ((c>='0')&&(c<='9'))) ){
			if(c=='$')continue;
			break;
		}
	}
	ret=name.SubString(1,x-1);
	indexSTR=name.Delete(1,x-1);
	if(indexSTR.IsEmpty()){
    	return ret;
	}
	if((indexSTR[1]!='[')||(indexSTR[indexSTR.Length()]!=']')){
		ErrorMSG("expression sintax");return "";
	}
	indexSTR.Delete(1,1);
	indexSTR.Delete(indexSTR.Length(),1);

	int bracketlev=0;
	int stored=0;
	for(x=1;x<=indexSTR.Length();x++){
		c=indexSTR[x];
		switch(c){
			case '[':
				bracketlev++;
				break;
			case ']':
				bracketlev--;
				break;
			case ',':
				if(!bracketlev){
					X=indexSTR.SubString(1,x-1);
					Y=indexSTR.Delete(1,x);
					stored=1;
				}
				break;
		}
		if(stored)break;
	}
	if(!stored){
		X=indexSTR;
		Y="";
	}
	if(bracketlev){
		ErrorMSG("expression sintax");return "";
	}

	return ret;

}

//Execute Command
int ACTord=-1;
void  CompilerForm::ProcessCommand(command* COMMAND){
	int x,y;
	AnsiString s,name,varname,expression;
	AnsiString PX,PY;
	int px,py;//,step;
	int subresult,subresult2;

	s.Sprintf("%d",COMMAND->ord);
	if(ACTord!=COMMAND->ord)MASMoutput->Add(u+"LN_"+s+":");
	ACTord=COMMAND->ord;

	switch(COMMAND->CMDcode){
		case 8:		//LET
			COMMAND->CMDtext=COMMAND->PARAM;
		case -1:	//empty command ("LET") or unknown
			name=GetFirstVariableName(COMMAND->CMDtext );
			expression=COMMAND->CMDtext;
			expression.Delete(1,name.Length()+1);
			EvaluateExpression(expression);
			PutVariable(name);
			break;
		case 0:		//FOR
			SplitBySpace(COMMAND->PARAM);
			if(COMMAND->JMPcode==-1){ErrorMSG("FOR invalid: NEXT is missing");return;}
			if(R2.AnsiCompare("TO") ){ErrorMSG("FOR invalid: TO is missing");return;}

			expression=R1;
			varname=name=GetFirstVariableName(expression);
			expression.Delete(1,name.Length()+1);
			EvaluateExpression(expression);
			PutVariable(name);
			s.Sprintf("%d",COMMAND->ord);
			MASMoutput->Add(u+"FORINIT LN_FORINIT_"+s);
			MASMoutput->Add(u+"LN_FORNEXT_"+s+":");

			if(!R4.AnsiCompare("STEP")){
				EvaluateExpression(R5);
			}else{
				MASMoutput->Add("MVISR1 1");
			}
			MASMoutput->Add("FORSTEPINDICATOR");
			GetVariable(varname);
			MASMoutput->Add("ADDSR");
			PutVariable(name);

			EvaluateExpression(R3);	//Evaluate "TO" Expression
			GetVariable(varname);
			MASMoutput->Add(u+"FORNEXTLOGIC LN_NEXTEND_"+s);
			MASMoutput->Add(u+"LN_FORINIT_"+s+":");
			break;
		case 1:		//NEXT
			if(COMMAND->JMPcode==-1){ErrorMSG("invalid NEXT ");return;}
			s.Sprintf("%d",CMD[COMMAND->JMPcode].ord);
			MASMoutput->Add(u+"GOTOLINE LN_FORNEXT_"+s );
			MASMoutput->Add(u+"LN_NEXTEND_"+s+":" );
			break;
		case 2:		//GOTO
			if(COMMAND->JMPcode==-1){
				ErrorMSG("invalid GOTO statement");return;
			}else
				MASMoutput->Add(u+"GOTOLINE LN_"+COMMAND->PARAM);
			break;
		case 3:		//DIM
			s="";
			name=COMMAND->PARAM;
			x=name.Pos("=");
			if(x){
				s=name.SubString(x+2,name.Length()-x-2);
				name.Delete(x,name.Length()-x+1);
			}
			
			name=GetFirstVariableName(COMMAND->PARAM);
			for(x=1;x<name.Length();x++)if(name[x]=='[')break;
			expression=name.SubString(x,name.Length()-x+1);
			name.Delete(x,name.Length()-x+1);
			if((expression[1]!='[')||(expression[expression.Length()]!=']')){
				ErrorMSG(" ");return;
			}
			expression.Delete(1,1);
			expression.Delete(expression.Length(),1);

			for(x=0;x<Vcnt;x++){
				if(!V[x].name.AnsiCompare(name) ){
					ErrorMSG("variable name is alreday existing");return;
				}
			}

			SplitByComma(expression);
			V[Vcnt].name=name;

			if(R1.IsEmpty()){
				if(StringDollar){
					V[Vcnt].type=2;
					px=V[Vcnt].dimX=s.Length()+1;
					V[Vcnt].dimY=-1;
					V[Vcnt].array=new(int[px]);
					for(x=0;x<px;x++)V[Vcnt].array[x]=0;
					for(x=0;(x<px)&&(x<s.Length());x++)
						V[Vcnt].array[x]=s.String[x];
				}else{
					ErrorMSG("");return;
				}
			}else if(R2.IsEmpty()){
				V[Vcnt].type=2;
				try {px=R1.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");return;
				}
				V[Vcnt].array=NULL;
				V[Vcnt].dimX=px;
				V[Vcnt].dimY=-1;
				if(StringDollar){
					if((s.Length()+1)>px){
						ErrorMSG("ERROR String INIT: String can not fit");
						return;
					}
					if(px<5)px=5;
					V[Vcnt].array=new(int[px]);
					for(x=0;x<px;x++)V[Vcnt].array[x]=0;
					for(x=0;(x<px)&&(x<s.Length());x++)
						V[Vcnt].array[x]=s.String[x];
				}
			}else{
				V[Vcnt].type=3;
				try {px=R1.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");return;
				}
				try {py=R2.ToInt();}
				catch (Exception &exception) {
					ErrorMSG("argument is invalid");return;
				}
				V[Vcnt].array=NULL;
				V[Vcnt].dimX=px;
				V[Vcnt].dimY=py;
			}

			Vcnt++;if(Vcnt>=5000){
				ShowMessage("FATAL: SYSTEM ERROR 12");return;
			}
			break;
		case 4:		//IF
			px=COMMAND->PARAM.AnsiPos("THEN");
			expression=COMMAND->PARAM.SubString(1,px-2);
			EvaluateBooleanExpression(expression);
			s.Sprintf("%d",COMMAND->ord);
			MASMoutput->Add(u+"IFTHEN LN_IFTHEN_"+s);

			if(COMMAND->JMPcode!=-1){
				name.Sprintf("%d",CMD[COMMAND->JMPcode].ord);
				MASMoutput->Add(u+"GOTOLINE LN_"+name );
			}else{
				if(COMMAND->SubCMD==NULL){
					ErrorMSG("IF branch is missing");return;
				}
				ProcessCommand(COMMAND->SubCMD);
			}
			MASMoutput->Add(u+"LN_IFTHEN_"+s+":");
			return;	//return to not process subcommads again
			break;
		case 5:		//PLOT
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("PLOT");
			break;
		case 6:		//REM
        	return;
			break;
		case 7:		//CLS
			MASMoutput->Add("CLRSCR");
			break;
		case 9:		//END
		case 10:	//STOP
			MASMoutput->Add("ENDCODE");
			break;
		case 11:	//GOSUB
			if(COMMAND->JMPcode==-1){
				ErrorMSG("invalid GOSUB statement");return;
			}
			s.Sprintf("LN_GOSUB_%d",COMMAND->ord);
			MASMoutput->Add(u+"MVISR1 "+s);
			MASMoutput->Add("PUSHSR1");
			
			if(multipages){
				MASMoutput->Add(u+"MP_LOADLABPAG "+s);
				MASMoutput->Add("PUSHSR1");
			}
			
			MASMoutput->Add(u+"GOTOLINE LN_"+COMMAND->PARAM );
			MASMoutput->Add(s+":");
			break;
		case 12:	//RETURN
			if(multipages){
				MASMoutput->Add("POPSR1");
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add("POPSR1");
				MASMoutput->Add("MP_GRETURN");
			}else{
				MASMoutput->Add("POPSR1");
				MASMoutput->Add("GRETURN");			
			}
			break;
		case 13:	//POP
			MASMoutput->Add("POPSR1");
			break;
		case 14:	//ON GOTO
			s=COMMAND->PARAM;
			SplitBySpace(s);
			EvaluateExpression(R1);
			if(R2.AnsiCompare("GOTO")){
				ErrorMSG("ON GOTO syntax error");return;
			}
			s.Delete(1,R1.Length()+R2.Length()+2);
			SplitByComma(s);
			if((!IsNumber(R1)&&!R1.IsEmpty())||(!IsNumber(R2)&&!R2.IsEmpty())||(!IsNumber(R3)&&!R3.IsEmpty())||
			(!IsNumber(R4)&&!R4.IsEmpty())||(!IsNumber(R5)&&!R5.IsEmpty())||(!IsNumber(R6)&&!R6.IsEmpty())){
				ErrorMSG("ON GOTO syntax error: invalid number");return;
			}
			s.Sprintf("LN_ONGOTO_%d",COMMAND->ord);
			MASMoutput->Add(u+"ONGOTO "+s);
			MASMoutput->Add(s+":");
			if(!R1.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R1);
			if(!R2.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R2);
			if(!R3.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R3);
			if(!R4.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R4);
			if(!R5.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R5);
			if(!R6.IsEmpty())MASMoutput->Add(u+"GOTOLINE LN_"+R6);
			break;
		case 15:	//PEEK
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
            MASMoutput->Add("PEEK");
			PutVariable(name);
			break;
		case 16:	//POKE
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("POKE");
			break;
		case 17:	//READ
			SplitByComma(COMMAND->PARAM);
			name=R2;
			y=COMMAND->JMPcode;
			y=CMD[y].JMPcode;
			s.Sprintf("%d",y);
			MASMoutput->Add(u+"READ DATALINE_"+s);
			PutVariable(name);
			break;
		case 18:	//RESTORE
			y=COMMAND->JMPcode;
			y=CMD[y].JMPcode;
			s.Sprintf("%d",y);
			MASMoutput->Add(u+"RESTORE DATALINE_"+s);
			break;
		case 35:	//DATA
			break;
		case 19:	//RND
			name=COMMAND->PARAM;
			MASMoutput->Add("RNG");
			PutVariable(name);
			break;
		case 20:	//SOUND
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SOUND");
			break;
		case 21:	//COLOR
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("COLOR");
			break;
		case 22:	//PUTPIXEL
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R3);
			MASMoutput->Add("COLOR");
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("PLOT");
			break;
		case 23:	//GETPIXEL
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PUTPIXEL");
			name=R1;
			PutVariable(name);
			break;
		case 24:	//POSITION
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("POSITION");
			break;
		case 25:	//DRAWTO
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("DRAWTO");
			break;
		case 26:	//GETMAXX
			name=COMMAND->PARAM;
			MASMoutput->Add("GETMAXX");
			PutVariable(name);
			break;
		case 27:	//GETMAXY
			name=COMMAND->PARAM;
			MASMoutput->Add("GETMAXY");
			PutVariable(name);
			break;
		case 28:	//GETMAXCOLORDEPTH
			name=COMMAND->PARAM;
			MASMoutput->Add("GETMAXCOLORDEPTH");
			PutVariable(name);
			break;
		case 29:	//VERSHIFTGRLINE
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			if((R2[1]!='\'')||(R2[3]!='\'')||(R2.Length()!=3)){
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			if(R2[2]=='U'){
				MASMoutput->Add("MVISR2 1");
				MASMoutput->Add("VERSHIFTGRLINE");
			}else if(R2[2]=='D'){
				MASMoutput->Add("MVISR2 2");
				MASMoutput->Add("VERSHIFTGRLINE");
			}else{
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			break;
		case 30:	//HORSHIFTGRLINE
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			if((R2[1]!='\'')||(R2[3]!='\'')||(R2.Length()!=3)){
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			if(R2[2]=='L'){
				MASMoutput->Add("MVISR2 1");
				MASMoutput->Add("HORSHIFTGRLINE");
			}else if(R2[2]=='R'){
				MASMoutput->Add("MVISR2 2");
				MASMoutput->Add("HORSHIFTGRLINE");
            }else{
				ErrorMSG("LINE SHIFT: invalid direction descriptor");return;
			}
			break;
		case 31:	//PUTPATTERN
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R4);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R5);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			if(name[1]=='#'){
				y=COMMAND->JMPcode;
				y=CMD[y].JMPcode;
				s.Sprintf("%d",y);
				MASMoutput->Add(u+"PUTPATTERN DATALINE_"+s);
			}else
				MASMoutput->Add(u+"PUTPATTERN "+name);
			break;
		case 32:	//GETPATTERN
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R4);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R5);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			MASMoutput->Add(u+"GETPATTERN "+name);
			break;
		case 33:	//KEYBINPUT
			name=COMMAND->PARAM;
			MASMoutput->Add("KEYBINPUT");
			PutVariable(name);
			break;
		case 34:	//WAITKEY
			name=COMMAND->PARAM;
			MASMoutput->Add("WAITKEY");
			PutVariable(name);
			break;
		case 36:	//DELAY
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("DELAY");
			break;
		case 37:  	//#TEST
			EvaluateBooleanExpression(COMMAND->PARAM);
			MASMoutput->Add("DEBUGTEST");
			break;
		case 38:	//#BREAK;
			MASMoutput->Add("DEBUGBREAK");
			break;
		case 39:	//PRINT
			if(COMMAND->PARAM[1]=='\''){
				MASMoutput->Add(u+"PRINT "+COMMAND->PARAM);
			}else{
				if(x=COMMAND->PARAM.Pos("$")){
					MASMoutput->Add(u+"STRPRINT "+COMMAND->PARAM);
				}else{
					EvaluateBooleanExpression(COMMAND->PARAM);
					MASMoutput->Add("NUMPRINT");
				}
			}
			break;
		case 40:	//GOTOXY
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("GOTOXY");
			break;
		case 41:	//ASM
			s.Sprintf("@%d",COMMAND->ord);
			MASMoutput->Add(s+" ASM");
			break;
		case 42:	//SID
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SID DATALINE_"+s);
			break;
		case 43:	//SIDS
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SIDS DATALINE_"+s);
			break;
		case 44:	//SVOICE1
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE1 DATALINE_"+s);
			break;
		case 45:	//SVOICE1S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE1S DATALINE_"+s);
			break;
		case 46:	//SVOICE2
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE2 DATALINE_"+s);
			break;
		case 47:	//SVOICE2S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE2S DATALINE_"+s);
			break;
		case 48:	//SVOICE3
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE3 DATALINE_"+s);
			break;
		case 49:	//SVOICE3S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SVOICE3S DATALINE_"+s);
			break;
		case 50:	//SFILTER
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SFILTER DATALINE_"+s);
			break;
		case 51:	//SFILTERS
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SFILTERS DATALINE_"+s);
			break;
		case 52:	//SFREQ1
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SFREQ1");
			break;
		case 53:	//SFREQ1S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SFREQ1S DATALINE_"+s);			
			break;
		case 54:	//SPW1
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SPW1");
			break;
		case 55:	//SPW1S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SPW1S DATALINE_"+s);
			break;
		case 56:	//SCONTR1
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SCONTR1");
			break;
		case 57:	//SADSR1
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SADSR1");
			break;
		case 58:	//SGATE1
			MASMoutput->Add("SGATE1");
			break;
		case 59:	//SRELEASE1
			MASMoutput->Add("SRELEASE1");
			break;
		case 60:	//SFREQ2
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SFREQ2");
			break;
		case 61:	//SFREQ2S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SFREQ2S DATALINE_"+s);			
			break;
		case 62:	//SPW2
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SPW2");
			break;
		case 63:	//SPW2S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SPW2S DATALINE_"+s);
			break;
		case 64:	//SCONTR2
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SCONTR2");
			break;
		case 65:	//SADSR2
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SADSR2");
			break;
		case 66:	//SGATE2
			MASMoutput->Add("SGATE2");
			break;
		case 67:	//SRELEASE2
			MASMoutput->Add("SRELEASE2");
			break;
		case 68:	//SFREQ3
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SFREQ3");
			break;
		case 69:	//SFREQ3S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SFREQ3S DATALINE_"+s);
			break;
		case 70:	//SPW3
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SPW3");
			break;
		case 71:	//SPW3S
			s.Sprintf("%d",CMD[COMMAND->JMPcode].JMPcode);
			MASMoutput->Add(u+"SPW3S DATALINE_"+s);
			break;
		case 72:	//SCONTR3
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SCONTR3");
			break;
		case 73:	//SADSR3
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SADSR3");
			break;
		case 74:	//SGATE3
			MASMoutput->Add("SGATE3");
			break;
		case 75:	//SRELEASE3
			MASMoutput->Add("SRELEASE3");
			break;
		case 76:	//SFC
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SFC");
			break;
		case 77:	//SRESFILT
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SRESFILT");
			break;
		case 78:	//SVOL
			EvaluateExpression(COMMAND->PARAM);
			MASMoutput->Add("SVOL");
			break;
		case 79:	//SPOTX
			name=COMMAND->PARAM;
			MASMoutput->Add("SPOTX");
			PutVariable(name);
			break;
		case 80:	//SPOTY
			name=COMMAND->PARAM;
			MASMoutput->Add("SPOTY");
			PutVariable(name);
			break;
		case 81:	//SRND
			name=COMMAND->PARAM;
			MASMoutput->Add("SRND");
			PutVariable(name);
			break;
		case 82:	//SENV3
			name=COMMAND->PARAM;
			MASMoutput->Add("SENV3");
			PutVariable(name);
			break;
		case 83:	//PICTURE
			break;
		case 84:	//TABLE
			break;
		case 85:	//PUTPATMIRVER
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R4);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R5);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			if(name[1]=='#'){
				y=COMMAND->JMPcode;
				y=CMD[y].JMPcode;
				s.Sprintf("%d",y);
				MASMoutput->Add(u+"PUTPATMIRVER DATALINE_"+s);
			}else
				MASMoutput->Add(u+"PUTPATMIRVER "+name);
			break;
		case 86:	//PUTPATTWIST
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R4);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R5);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			if(name[1]=='#'){
				y=COMMAND->JMPcode;
				y=CMD[y].JMPcode;
				s.Sprintf("%d",y);
				MASMoutput->Add(u+"PUTPATTWIST DATALINE_"+s);
			}else
				MASMoutput->Add(u+"PUTPATTWIST "+name);
			break;
		case 87:	//PUTPATTWISMIR
			SplitByComma(COMMAND->PARAM);
			name=R1;
			EvaluateExpression(R2);
			ComputeOptR3();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R4);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R5);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			if(name[1]=='#'){
				y=COMMAND->JMPcode;
				y=CMD[y].JMPcode;
				s.Sprintf("%d",y);
				MASMoutput->Add(u+"PUTPATTWISMIR DATALINE_"+s);
			}else
				MASMoutput->Add(u+"PUTPATTWISMIR "+name);
			break;
		case 88:	//ENDPICTURE
			break;
		case 89:	//ENDTABLE
			break;
		case 90:	//DELPATTERN
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R1);
			ComputeOptR2();
			MASMoutput->Add("PATTERNCSTR");
			EvaluateExpression(R3);
			MASMoutput->Add("PUSHSR1");
			EvaluateExpression(R4);
			MASMoutput->Add("MOVSR2SR1");
			MASMoutput->Add("POPSR1");
			MASMoutput->Add(u+"DELPATTERN "+name);
			break;
		case 91:	//INPUT
			x=BasicStrLen(COMMAND->PARAM);
			if(x==-1){
				ErrorMSG("Invalid String variable in INPUT");return;
			}
			sprintf(s.String,"MVISR1 %d",x);
			MASMoutput->Add(s);
			MASMoutput->Add(u+"INPUT "+COMMAND->PARAM);
			break;
		case 92:	//STRCPY
			SplitByComma(COMMAND->PARAM);
			if((R1[1]!='#')&&(R2[1]!='#')&&R3.IsEmpty()){
				MASMoutput->Add(u+"GETSTRPOI2_P1 "+R1);
				MASMoutput->Add(u+"GETSTRPOI3_P2 "+R2);
			}else if((R1[1]=='#')&&(R2[1]=='#')&&(R3[1]!='#')&&R4.IsEmpty()){
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("PAGEREG1");
				R1.Delete(1,1);
				EvaluateExpression(R1);
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add(u+"GETSTRPOI3_P2 "+R3);
			}else if((R1[1]!='#')&&(R2[1]=='#')&&(R3[1]=='#')&&R4.IsEmpty()){
				R3.Delete(1,1);
				EvaluateExpression(R3);
				MASMoutput->Add("PAGEREG2");
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("MOVHLSR1");
				MASMoutput->Add(u+"GETSTRPOI2_P1 "+R1);
			}else if((R1[1]=='#')&&(R2[1]=='#')&&(R3[1]=='#')&&(R4[1]=='#')&&R5.IsEmpty()){
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("PAGEREG1");
				R4.Delete(1,1);
				EvaluateExpression(R4);
				MASMoutput->Add("PAGEREG2");
				R1.Delete(1,1);
				EvaluateExpression(R1);
				MASMoutput->Add("SWAPSR1");
				R3.Delete(1,1);
				EvaluateExpression(R3);
				MASMoutput->Add("MOVHLSR1");
				MASMoutput->Add("SWAPBKSR1");
				MASMoutput->Add("MOVSR2SR1");
			}else{
				ErrorMSG("Invalid arguments: STRCPY");
				return;
			}
			MASMoutput->Add("STRCPY");
			break;
		case 93:	//STRCMP
			SplitByComma(COMMAND->PARAM);
			if((R1[1]!='#')&&(R2[1]!='#')&&(R3[1]!='#')&&R4.IsEmpty()){
				MASMoutput->Add(u+"GETSTRPOI2_P1 "+R2);
				MASMoutput->Add(u+"STRCMP "+R3);
			}else if((R1[1]!='#')&&(R2[1]=='#')&&(R3[1]=='#')&&(R4[1]!='#')&&R5.IsEmpty()){
				R3.Delete(1,1);
				EvaluateExpression(R3);
				MASMoutput->Add("PAGEREG1");
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add(u+"STRCMP "+R4);
			}else{
				ErrorMSG("Invalid arguments: STRCMP");
				return;
			}
			PutVariable(R1);
			break;
		case 94:	//STRPOS
			SplitByComma(COMMAND->PARAM);
			if((R1[1]!='#')&&(R2[1]!='#')&&(R3[1]!='#')&&R4.IsEmpty()){
				MASMoutput->Add(u+"GETSTRPOI2_P1 "+R2);
				MASMoutput->Add(u+"STRPOS "+R3);
			}else if((R1[1]!='#')&&(R2[1]=='#')&&(R3[1]=='#')&&(R4[1]!='#')&&R5.IsEmpty()){
				R3.Delete(1,1);
				EvaluateExpression(R3);
				MASMoutput->Add("PAGEREG1");
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add(u+"STRPOS "+R4);
			}else{
				ErrorMSG("Invalid arguments: STRPOS");
				return;
			}
			PutVariable(R1);
			break;
		case 95:	//STRCAT
			SplitByComma(COMMAND->PARAM);
			if((R1[1]!='#')&&(R2[1]!='#')&&R3.IsEmpty()){
				MASMoutput->Add(u+"GETSTRPOI2_P1 "+R1);
				MASMoutput->Add(u+"STRCAT "+R2);
			}else if((R1[1]=='#')&&(R2[1]=='#')&&(R3[1]!='#')&&R4.IsEmpty()){
				R2.Delete(1,1);
				EvaluateExpression(R2);
				MASMoutput->Add("PAGEREG1");
				R1.Delete(1,1);
				EvaluateExpression(R1);
				MASMoutput->Add("MOVSR2SR1");
				MASMoutput->Add(u+"STRCAT "+R3);
			}else{
				ErrorMSG("Invalid arguments: STRCAT");
				return;
			}
			break;
		case 96:	//GETSTRPOI
			SplitByComma(COMMAND->PARAM);
			if((R1[1]=='#')&&(R2[1]=='#')&&(R3[1]!='#')&&R4.IsEmpty()){
				R1.Delete(1,1);
				R2.Delete(1,1);
				MASMoutput->Add(u+"GETSTRPOI1_P1 "+R3);
				PutVariable(R1);
				MASMoutput->Add(u+"GETPAGE "+R3);
				PutVariable(R2);
			}else{
				ErrorMSG("Invalid arguments: GETSTRPOI");return;
			}
			break;
		case 97:	//STRLEN
			SplitByComma(COMMAND->PARAM);
			MASMoutput->Add(u+"STRLEN "+R2);
			PutVariable(R1);
			break;
		case 98:	//RADIX
			R1=COMMAND->PARAM;
			if(!strcmp(R1.String,"DEC")){
				MASMoutput->Add("RADIXDEC");
			}else if(!strcmp(R1.String,"HEX")){
				MASMoutput->Add("RADIXHEX");
			}else{
				ErrorMSG("ERROR: invalid RADIX");
				return;
			}
			break;
		case 99:	//STRTONUM
			SplitByComma(COMMAND->PARAM);
			MASMoutput->Add(u+"STRTONUM "+R2);
			PutVariable(R1);
			break;
		case 100:	//NUMTOSTR
			SplitByComma(COMMAND->PARAM);
			EvaluateExpression(R2);
			MASMoutput->Add(u+"NUMTOSTR "+R1);
			break;
		case 101:	//GETACTXY
			SplitByComma(COMMAND->PARAM);
			MASMoutput->Add(u+"GETACTX "+R1);
			MASMoutput->Add(u+"GETACTY "+R2);
			break;
		case 102:	//LED
			SplitBySpace(COMMAND->PARAM);
			if(!IsNumber(R1)){
				ErrorMSG("ERROR: invalid argument of LED, number expected");
				return;
			}
			if( (!((R1[1]>='1')&&(R1[1]<='8'))) || (R1.Length()!=1) ){
				ErrorMSG("ERROR: invalid argument of LED, number must be 1-8");
				return;
			}
			switch(R1[1]){
				case '1':
					R3="0x01";
					break;
				case '2':
					R3="0x02";
					break;
				case '3':
					R3="0x04";
					break;
				case '4':
					R3="0x08";
					break;
				case '5':
					R3="0x10";
					break;
				case '6':
					R3="0x20";
					break;
				case '7':
					R3="0x40";
					break;
				case '8':
					R3="0x80";
					break;
			}
			if(!strcmp(R2.String,"ON")){
				MASMoutput->Add(u+"LEDON "+R3);
			}else if(!strcmp(R2.String,"OFF")){
				MASMoutput->Add(u+"LEDOFF "+R3);
			}else{
				ErrorMSG("ERROR: invalid argument of LED (ON/OFF)");
				return;
			}
			break;
		case 103:	//LIGHTS
			if(!strcmp(COMMAND->PARAM.String,"ON")){
				MASMoutput->Add("LIGHTSON");
			}else if(!strcmp(COMMAND->PARAM.String,"OFF")){
				MASMoutput->Add("LIGHTSOFF");
			}else{
				ErrorMSG("ERROR: invalid argument of LIGHTS (ON/OFF)");
				return;
			}
			break;
		default:
			s.Sprintf("%d",COMMAND->CMDcode);
			ShowMessage(u+"SYSTEM FATAL: Unknown command code: "+s);
			return;
			break;
	}

	//Process subcommand ':'
	if(COMMAND->SubCMD)	ProcessCommand(COMMAND->SubCMD);
	
}


//ERROR AT LINE - compiling error message  
void  CompilerForm::ErrorMSG(AnsiString msg){
	AnsiString c,t;
	t.Sprintf("%d",CMD[commandCNTR].ord);
	c=commands->Strings[ commandCNTR ];
//	run=0;
	errorlinenum=commandCNTR;
	ShowMessage(u+"ERROR AT LINE "+ t+" - "+msg+"\n"+c);
	throw 100;
	this->ModalResult(mrOk);
}


int   CompilerForm::IsNumber(AnsiString str){
	int x;
	if(str.IsEmpty())return 0;
	if((str[1]=='0')&&(str[2]=='x')){
		for(x=3;x<=str.Length();x++){
			if((str[x]>='0')&&(str[x]<='9'))continue;
			if((str[x]>='A')&&(str[x]<='F'))continue;
			else return 0;
		}
		return 1;
	}
	for(x=1;x<=str.Length();x++){
		if((str[x]>='0')&&(str[x]<='9'))continue;
		else return 0;
	}
	return 1;
}

void  CompilerForm::EvaluateBooleanExpression(AnsiString expr){
	int pos,len;
	char c;
	//substitue
	while(pos=expr.AnsiPos("AND") ){
		expr[pos]='&';
		expr.Delete(pos+1,2);
	}
	while(pos=expr.AnsiPos("OR") ){
		expr[pos]='|';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos("NOT") ){
		expr[pos]='!';
		expr.Delete(pos+1,2);
	}
	while(pos=expr.AnsiPos("<>") ){
		expr[pos]='#';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos("<=") ){
		expr[pos]='\1';
		expr.Delete(pos+1,1);
	}
	while(pos=expr.AnsiPos(">=") ){
		expr[pos]='\2';
		expr.Delete(pos+1,1);
	}

	//delete spaces
	len=expr.Length();
	for(pos=1;pos<=len;pos++){
		c=expr[pos];
		if((c=='&')||(c=='|')||(c=='!')||(c=='>')||(c=='<')||(c=='=')){
			if((pos>1)&&(expr[pos-1]==' ')){expr.Delete(pos-1,1);pos--;}
			if((pos<len)&&(expr[pos+1]==' '))expr.Delete(pos+1,1);
			if((pos+1<len)&&(expr[pos+2]==' '))expr.Delete(pos+2,1);
		}
		len=expr.Length();
	}
	//syntax check
	len=expr.Length();
	for(pos=1;pos<=len;pos++){
		c=expr[pos];
		if((c=='&')||(c=='|')){
			if(expr[pos-1]!=')') {ErrorMSG("Boolean Expression syntax");return;}
			if(expr[pos+1]!='!'){
				if(expr[pos+1]!='('){ErrorMSG("Boolean Expression syntax");return;}
			}else if(expr[pos+2]!='('){ErrorMSG("Boolean Expression syntax");return;}
		}
		if((c=='!')&&(expr[pos+1])!='('){ErrorMSG("Boolean Expression syntax");return;}
		//)
	}

	return EvaluateExpression(expr);

}

//initialize random seeds (1.st and 2.st seeds)
void  CompilerForm::RandSeed(){
/* initialize random seed: */
  srand ( time(NULL) );
}

int   CompilerForm::RandomNumber(int randmax){
  /* generate secret number: */
  return(rand() % randmax);
}

//Optimalize compute expression: optimalized computation
void CompilerForm::ComputeOptR2(){
	if(!IsNumber(R2)){
		MASMoutput->Add("PUSHSR1");
		EvaluateExpression(R2);
		MASMoutput->Add("MOVSR2SR1");
		MASMoutput->Add("POPSR1");
	}else{
		MASMoutput->Add(u+"MVISR2 "+R2);
	}
}

//Optimalize compute expression: optimalized computation
void CompilerForm::ComputeOptR3(){
	if(!IsNumber(R3)){
		MASMoutput->Add("PUSHSR1");
		EvaluateExpression(R3);
		MASMoutput->Add("MOVSR2SR1");
		MASMoutput->Add("POPSR1");
	}else{
		MASMoutput->Add(u+"MVISR2 "+R3);
	}
}

//Code Optimalization in MASM code
void CompilerForm::OptimalizeMasm(){
	int x,y;
	AnsiString s,z;
	for(x=1;x<MASMoutput->Count-1;x++){
		s=MASMoutput->Strings[x];
		//PUSHSR1: 10el elrbb: nem lehet : PUSHSR1, gotoline, gosub, return, gomodule
		if(s.Pos("PUSHSR1")){
			for(y=x+1;y<x+12;y++){
				if(y>=MASMoutput->Count)break;
				z=MASMoutput->Strings[y];
				if(z.Pos("PUSHSR1"))break;
				if(z.Pos("DEBUGBREAK"))break;
				if(z.Pos("GOTOLINE"))break;
				if(z.Pos("FORINIT"))break;
				if(z.Pos("FORSTEPINDICATOR"))break;
				if(z.Pos("FORNEXTLOGIC"))break;
				if(z.Pos("IFTHEN"))break;
				if(z.Pos("GRETURN"))break;
				if(z.Pos("ONGOTO"))break;
				if(z.Pos("GOMODULE"))break;
				if(z.Pos("POPSR1")){
					s="SWAPSR1";
					z="SWAPBKSR1";
					MASMoutput->Strings[x]=s;
					MASMoutput->Strings[y]=z;
					break;
				}
			}
		}
		if(s.Pos("MOVSR1SR2")){
			z=MASMoutput->Strings[x-1];
			if(z.Pos("GETVAR")){
				SplitBySpace(z);
				s=u+"GETVARSR1 "+R2;
				MASMoutput->Strings[x-1]=s;
				s="NONE";
				MASMoutput->Strings[x]=s;
			}
		}
		if(s.Pos("MOVSR2SR1")){
			z=MASMoutput->Strings[x-1];
			if(z.Pos("ADDSR")){
				s="ADDTOSR2";
				MASMoutput->Strings[x-1]=s;
				s="NONE";
				MASMoutput->Strings[x]=s;
			}
		}
		if(s.Pos("PUTVAR")){
			z=MASMoutput->Strings[x-1];
			if(z.Pos("MVISR1")){
				SplitBySpace(s);
				s=u+"PUTVARIM "+R2;	//Internal macro, MACRO_BG does not contain that
				SplitBySpace(z);
				s=s+" "+R2;
				MASMoutput->Strings[x-1]=s;
				s="NONE";
				MASMoutput->Strings[x]=s;
			}
		}
		if(s.Pos("MVISR2")){
			z=MASMoutput->Strings[x-1];
			if(z.Pos("MOVSR1SR2")){
				z=MASMoutput->Strings[x+1];
				if(	z.Pos("ADDSR")||
					z.Pos("MULSR")||
					z.Pos("ANDSR")||
					z.Pos("ORSR")||
					z.Pos("EQUAL")||
					z.Pos("NOTEQUAL")
					){
						SplitBySpace(s);
						z=u+"MVISR1 "+R2;
						MASMoutput->Strings[x]=z;
						z="NONE";
						MASMoutput->Strings[x-1]=z;
					}
			}
		}

	}
}

//BARANY GABOR ASSEMBLY CODE
//Convert MASM to ASM
int	CompilerForm::MasmToAsm(){
	AnsiString s,Mname,num,numstr;
	int x,y,z,d1,d2;
	int RNGmode=0;
	s=ExtractFilePath(Application->ExeName)+"MACRO_BG.LIB";
	if(!FileExists(s)){
		ShowMessage("ERROR: MACRO_BG.LIB does not exists !");
		return -1;
	}
	TStringList* Macro=new(TStringList);
	//ASMoutput=new(TStringList);
	if(!ASMoutput){
		ShowMessage("ERROR: internal error, ASMoutput==NULL !");
		return -1;
	}

	Macro->Clear();
	Macro->LoadFromFile(s);
	ASMoutput->Clear();
	ASMoutput->Add(";CODE");
	ASMoutput->Add("");		

	AnsiString param;
	int pos;

	//BASIC MACROS
	for(x=0;x<MASMoutput->Count;x++){
		s=MASMoutput->Strings[x];
		if(s.AnsiPos("NONE")==1){//do nothing: optimalization deleted a line here
			continue;
		}
		if(s.AnsiPos("LN_")==1){//basic line number
			ASMoutput->Add(s);
			continue;
		}
		if(s.AnsiPos("@")==1){//Inline assembly
			ASMoutput->Add(s);
			continue;
		}
		if(s.AnsiPos("RNG")==1){
			RNGmode=1;
		}
		if(s.AnsiPos("PUTVARIM")==1){//Internal macro, MACRO_BG does not contain that
			SplitBySpace(s);
			//R2=variname, R3=imme data
			ASMoutput->Add(";PUTVARIM");
			ASMoutput->Add(u+"MVI A,[HIGH "+R3+"]");
			ASMoutput->Add(u+"STA ["+R2+"]");
			ASMoutput->Add(u+"MVI A,[LOW "+R3+"]");
			ASMoutput->Add(u+"STA ["+R2+"+1]");
			continue;
		}
		//if(s.AnsiPos("ASM")==1){}
		if(s.AnsiPos("PRINT")==1){
			s.Delete(1,6);
			num=ConvertString(s);
			if(num.IsEmpty()){
				ShowMessage("ERROR in PRINT");return -1;
			}
			s=u+"PRINT "+num;
		}

		SplitBySpace(s);
		Mname=R1;
		param=R2;
		for(y=0;y<Macro->Count;y++){
			s=Macro->Strings[y];
			if((s.AnsiPos("#MACRO"))==1){
				SplitBySpace(s);
				if(!R2.AnsiCompare(Mname)){
					y++;
					if(!R3.AnsiCompare("PARAM")){
						if(param.IsEmpty()){
							ShowMessage(u+"ERROR: parameter definition in MACRO "+s);
							return -1;
						}
					}else{
						if(!param.IsEmpty()){
							ShowMessage(u+"ERROR: parameter definition in MACRO "+s);
							return -1;
						}
					}
					for(;y<Macro->Count;y++){
						s=Macro->Strings[y];
						if((s.AnsiPos("#ENDMACRO"))==1){
							break;
						}
						if(pos=s.AnsiPos("PARAM")){
							s.Delete(pos,5);
							s.Insert(param,pos);
						}
						if(pos=s.AnsiPos("%%")){
							s.Delete(pos,2);
							R5.Sprintf("%d",x);
							s.Insert(R5,pos);
						}
						ASMoutput->Add(s);
					}
					break;
				}
			}
		}
		if(y>=Macro->Count){
			ShowMessage("ERROR internal error, macro not found");return -1;
		}
	}
	
	//VARIABLES
	ASMoutput->Add(";-----------------------");
	ASMoutput->Add(";Variables");

	int Hb,Lb;
	for(x=0;x<Vcnt;x++){
		switch(V[x].type){
			case 1:
				ASMoutput->Add(V[x].name+":");
				ASMoutput->Add("DB 0x00,0x00");
				break;
			case 2:
				if(V[x].array==NULL){
					s.Sprintf("%d",V[x].dimX*2);
					ASMoutput->Add(u+"ENSLEN "+s);
					ASMoutput->Add(V[x].name+":");
					for(y=0;y<V[x].dimX;y++){
						ASMoutput->Add("DB 0x00,0x00");
					}
				}else{
					s.Sprintf("%d",V[x].dimX);
					ASMoutput->Add(u+"ENSLEN "+s);
					ASMoutput->Add(V[x].name+":");
					for(y=0;y<V[x].dimX;y++){
						s.Sprintf("DB 0x%X",V[x].array[y]);
						ASMoutput->Add(s);
					}
				}
				break;
			case 3:
				s.Sprintf("%d",V[x].dimX*V[x].dimY*2+2);
				ASMoutput->Add(u+"ENSLEN "+s);
				ASMoutput->Add(V[x].name+"_sizeX:");
				Hb= (V[x].dimX&0xFF00) >> 8;
				Lb=  V[x].dimX&0xFF;
				sprintf(s.String,"DB 0x%X,0x%X", Hb,Lb);
				ASMoutput->Add(s);
				ASMoutput->Add(V[x].name+":");
				for(y=0;y<V[x].dimX*V[x].dimY;y++){
					ASMoutput->Add("DB 0x00,0x00");
				}
				break;
		}
	}

	//READ-DATA lines
	int Dinited=0;
	for(x=0;x<1000;x++){
		if(DATA==NULL)break;
		if(DATA[x].data==NULL)break;
		Dinited=1;
		s.Sprintf("%d",x);
		ASMoutput->Add(u+"DATALINE_POI_"+s+": DB 0x00,0x00");
	}
	if(Dinited){
		ASMoutput->Add("#PROC ZERODATA");
		ASMoutput->Add("XOR A");
		for(x=0;x<1000;x++){
			if(DATA==NULL)break;
			if(DATA[x].data==NULL)break;
			s.Sprintf("%d",x);
			ASMoutput->Add(u+"STA [DATALINE_POI_"+s+"]");
			ASMoutput->Add(u+"STA [DATALINE_POI_"+s+"+1]");			
		}
		ASMoutput->Add("RET");
		ASMoutput->Add("#END");
	}else{
		ASMoutput->Add("#PROC ZERODATA");
		ASMoutput->Add("NOP");
		ASMoutput->Add("RET");
		ASMoutput->Add("#END");
	}
	for(x=0;x<1000;x++){
		if(DATA==NULL)break;
		if(DATA[x].data==NULL)break;
		
		if(DATA[x].PictureMode){
			if(DATA[x].TableCnt){
				s.Sprintf("%d",DATA[x].TableCnt);
				ASMoutput->Add(u+"ENSLEN "+s);
			}
		}else{
			if(DATA[x].TableCnt){
				s.Sprintf("%d",DATA[x].TableCnt*2);
				ASMoutput->Add(u+"ENSLEN "+s);
			}else{
				s.Sprintf("%d",DATA[x].dnum*2);
				ASMoutput->Add(u+"ENSLEN "+s);
			}
		}
		s.Sprintf("%d",x);
		ASMoutput->Add(u+"DATALINE_"+s+":");
		
		for(y=0;y<DATA[x].dnum;y++){
			d1=(DATA[x].data[y]&0xFF00)>>8;
			d2=DATA[x].data[y]&0xFF;
			(DATA[x].PictureMode) ? sprintf(s.String,"DB 0x%X",d2) : sprintf(s.String,"DB 0x%X,0x%X",d1,d2);
			ASMoutput->Add(s);
		}
	}

	//Random Number Generator table
	if(RNGmode){
		ASMoutput->Add("");
		ASMoutput->Add("ENSLEN 1030");
		ASMoutput->Add("RNGTABLTE:");
		for(y=0;y<103;y++){
			numstr="DB ";
			for(z=0;z<10;z++){
				d1=RandomNumber(256);
				d2=d1&0xFF;
				num.Sprintf("0x%X",d2);
				if(z<9)num=num+",";
				numstr=numstr+num;
			}
			ASMoutput->Add(numstr);
		}
	}else{
		ASMoutput->Add("");
		ASMoutput->Add("RNGTABLTE: DB 0x00");
	}

	//ROUTINES AND STACK - at the end of memory
	//Stack ~110 byte provided
	ASMoutput->Add(";ROUTINES");
	sprintf(s.String,"ENSLEN %d",ROUTINESLIBSIZE);
	ASMoutput->Add(s);
	//ASMoutput->Add("ENSLEN 8630");	//Itt kell vltoztatni ha a FIX ROUTINES kdmret nvekszik
	for(y=Macro->Count-1;y>=0;y--){
		s=Macro->Strings[y];
		if((s.AnsiPos("#ENDMACRO"))==1){
			break;
		}
	}
	y++;
	for(;y<Macro->Count;y++){
		s=Macro->Strings[y];
		ASMoutput->Add(s);
	}
	
	delete Macro;
	//delete ASMoutput;
	return 0;
}

//Convert MASM to ASM 
//Paged version
int	CompilerForm::MasmToAsmPag(){
	AnsiString s,Mname,num,numstr;
	int x,y,z,d1,d2;
	int RNGmode=0;
	s=ExtractFilePath(Application->ExeName)+"MACRO_BG.LIB";
	if(!FileExists(s)){
		ShowMessage("ERROR: MACRO_BG.LIB does not exists !");
		return -1;
	}
	TStringList* Macro=new(TStringList);
	if(!ASMoutput){
		ShowMessage("ERROR: internal error, ASMoutput==NULL !");
		return -1;
	}

	Macro->Clear();
	Macro->LoadFromFile(s);
	//Change some macros to multipaged version macro
	for(x=0;x<MASMoutput->Count;x++){
		s=MASMoutput->Strings[x];
		if(s.String[0]!='S'){
			if(
				(s.AnsiPos("PUTARRAYD1")==1)||
				(s.AnsiPos("PUTARRAYD2")==1)||
				(s.AnsiPos("GETARRAYD1")==1)||
				(s.AnsiPos("GETARRAYD2")==1)||
				(s.AnsiPos("GRETURN")==1)||
				(s.AnsiPos("READ")==1)
			){
				u="";
				s=u+"MP_"+s;
				MASMoutput->Strings[x]=s;
			}
		}else{
			if(
				(s.AnsiPos("SID")==1)||
				(s.AnsiPos("SIDS")==1)||
				(s.AnsiPos("SVOICE1")==1)||
				(s.AnsiPos("SVOICE1S")==1)||
				(s.AnsiPos("SVOICE2")==1)||
				(s.AnsiPos("SVOICE2S")==1)||
				(s.AnsiPos("SVOICE3")==1)||
				(s.AnsiPos("SVOICE3S")==1)||
				(s.AnsiPos("SFILTER")==1)||
				(s.AnsiPos("SFILTERS")==1)||
				(s.AnsiPos("SFREQ1S")==1)||
				(s.AnsiPos("SPW1S")==1)||
				(s.AnsiPos("SFREQ2S")==1)||
				(s.AnsiPos("SPW2S")==1)||
				(s.AnsiPos("SFREQ3S")==1)||
				(s.AnsiPos("SPW3S")==1)
			){
				u="";
				s=u+"MP_"+s;
				MASMoutput->Strings[x]=s;
			}
		}
	}
	
	ASMoutput->Clear();
	ASMoutput->Add(";CODE");
	ASMoutput->Add("MPAGES");
	ASMoutput->Add("");		

	AnsiString param;
	int pos;

	//BASIC MACROS
	for(x=0;x<MASMoutput->Count;x++){
		s=MASMoutput->Strings[x];
		if(s.AnsiPos("NONE")==1){//do nothing: optimalization deleted a line here
			continue;
		}
		if(s.AnsiPos("LN_")==1){//basic line number
			ASMoutput->Add(s);
			continue;
		}
		if(s.AnsiPos("@")==1){//Inline assembly
			ASMoutput->Add(s);
			continue;
		}
		if(s.AnsiPos("RNG")==1){
			RNGmode=1;
		}
		if(s.AnsiPos("PUTVARIM")==1){//Internal macro, MACRO_BG does not contain that
			SplitBySpace(s);
			//R2=variname, R3=imme data
			ASMoutput->Add(";PUTVARIM");
			ASMoutput->Add(u+"MVI A,[HIGH "+R3+"]");
			ASMoutput->Add(u+"STA ["+R2+"]");
			ASMoutput->Add(u+"MVI A,[LOW "+R3+"]");
			ASMoutput->Add(u+"STA ["+R2+"+1]");
			continue;
		}
		//if(s.AnsiPos("ASM")==1){}
		if(s.AnsiPos("PRINT")==1){
			s.Delete(1,6);
			num=ConvertString(s);
			if(num.IsEmpty()){
				ShowMessage("ERROR in PRINT");return -1;
			}
			s=u+"PRINT "+num;
		}

		SplitBySpace(s);
		Mname=R1;
		param=R2;
		for(y=0;y<Macro->Count;y++){
			s=Macro->Strings[y];
			if((s.AnsiPos("#MACRO"))==1){
				SplitBySpace(s);
				if(!R2.AnsiCompare(Mname)){
					y++;
					if(!R3.AnsiCompare("PARAM")){
						if(param.IsEmpty()){ShowMessage(u+"ERROR: parameter definition in MACRO "+s);return -1;}
					}else{
						if(!param.IsEmpty()){ShowMessage(u+"ERROR: parameter definition in MACRO "+s);return -1;}
					}
					for(;y<Macro->Count;y++){
						s=Macro->Strings[y];
						if((s.AnsiPos("#ENDMACRO"))==1){
							break;
						}
						if(pos=s.AnsiPos("PARAM")){
							s.Delete(pos,5);
							s.Insert(param,pos);
						}
						if(pos=s.AnsiPos("%%")){
							s.Delete(pos,2);
							R5.Sprintf("%d",x);
							s.Insert(R5,pos);
						}
						ASMoutput->Add(s);
					}
					break;
				}
			}
		}
		if(y>=Macro->Count){
			ShowMessage("ERROR internal error, macro not found");return -1;
		}
	}
	
	//VARIABLES
	ASMoutput->Add(";-----------------------");
	ASMoutput->Add(";Variables 1D,2D");
	ASMoutput->Add("RELOC");

	int Hb,Lb;
	for(x=0;x<Vcnt;x++){
		switch(V[x].type){
			case 2:
				if(V[x].array==NULL){
					s.Sprintf("%d",V[x].dimX*2);
					ASMoutput->Add(u+"ENSLEN "+s);
					ASMoutput->Add(V[x].name+":");
					for(y=0;y<V[x].dimX;y++){
						ASMoutput->Add("DB 0x00,0x00");
					}
				}else{
					s.Sprintf("%d",V[x].dimX);
					ASMoutput->Add(u+"ENSLEN "+s);
					ASMoutput->Add(V[x].name+":");
					for(y=0;y<V[x].dimX;y++){
						s.Sprintf("DB 0x%X",V[x].array[y]);
						ASMoutput->Add(s);
					}
				}
				break;
			case 3:
				s.Sprintf("%d",V[x].dimX*V[x].dimY*2);
				ASMoutput->Add(u+"ENSLEN "+s);
				ASMoutput->Add(V[x].name+":");
				for(y=0;y<V[x].dimX*V[x].dimY;y++){
					ASMoutput->Add("DB 0x00,0x00");
				}
				break;
			default:
				break;
		}
	}

	//READ-DATA lines
	for(x=0;x<1000;x++){
		if(DATA==NULL)break;
		if(DATA[x].data==NULL)break;
		
		if(DATA[x].PictureMode){
			if(DATA[x].TableCnt){
				s.Sprintf("%d",DATA[x].TableCnt);
				ASMoutput->Add(u+"ENSLEN "+s);
			}
		}else{
			if(DATA[x].TableCnt){
				s.Sprintf("%d",DATA[x].TableCnt*2);
				ASMoutput->Add(u+"ENSLEN "+s);
			}else{
				s.Sprintf("%d",DATA[x].dnum*2);
				ASMoutput->Add(u+"ENSLEN "+s);
			}
		}
		s.Sprintf("%d",x);
		ASMoutput->Add(u+"DATALINE_"+s+":");

		for(y=0;y<DATA[x].dnum;y++){
			d1=(DATA[x].data[y]&0xFF00)>>8;
			d2=DATA[x].data[y]&0xFF;
			(DATA[x].PictureMode) ? sprintf(s.String,"DB 0x%X",d2) : sprintf(s.String,"DB 0x%X,0x%X",d1,d2);
			ASMoutput->Add(s);
		}
	}

	//Random Number Generator table
	if(RNGmode){
		ASMoutput->Add("");
		ASMoutput->Add("ENSLEN 1030");
		ASMoutput->Add("RNGTABLTE:");
		for(y=0;y<103;y++){
			numstr="DB ";
			for(z=0;z<10;z++){
				d1=RandomNumber(256);
				d2=d1&0xFF;
				num.Sprintf("0x%X",d2);
				if(z<9)num=num+",";
				numstr=numstr+num;
			}
			ASMoutput->Add(numstr);
		}
	}else{
		ASMoutput->Add("");
		ASMoutput->Add("RNGTABLTE: DB 0x00");
	}
	
	//fixed page content
	ASMoutput->Add(";These datas are to fixed page");
	ASMoutput->Add("FIXPAG");
	ASMoutput->Add(";Variables: single variables");
	
	for(x=0;x<Vcnt;x++){
		if(V[x].type==1){
			ASMoutput->Add(V[x].name+":");
			ASMoutput->Add("DB 0x00,0x00");
		}
		if(V[x].type==3){
			ASMoutput->Add(V[x].name+"_sizeX:");
			Hb= (V[x].dimX&0xFF00) >> 8;
			Lb=  V[x].dimX&0xFF;
			sprintf(s.String,"DB 0x%X,0x%X", Hb,Lb);
			ASMoutput->Add(s);
		}
	}
	
	//DATALINE_POI_ and PROC ZERODATA
	int Dinited=0;
	for(x=0;x<1000;x++){
		if(DATA==NULL)break;
		if(DATA[x].data==NULL)break;
		Dinited=1;
		s.Sprintf("%d",x);
		ASMoutput->Add(u+"DATALINE_POI_"+s+": DB 0x00,0x00");
	}
	if(Dinited){
		ASMoutput->Add("#PROC ZERODATA");
		ASMoutput->Add("XOR A");
		for(x=0;x<1000;x++){
			if(DATA==NULL)break;
			if(DATA[x].data==NULL)break;
			s.Sprintf("%d",x);
			ASMoutput->Add(u+"STA [DATALINE_POI_"+s+"]");
			ASMoutput->Add(u+"STA [DATALINE_POI_"+s+"+1]");			
		}
		ASMoutput->Add("RET");
		ASMoutput->Add("#END");
	}else{
		ASMoutput->Add("#PROC ZERODATA");
		ASMoutput->Add("NOP");
		ASMoutput->Add("RET");
		ASMoutput->Add("#END");
	}
	
	//Place of JUMP tables. Must be equal to ROUTINES ORG !
	sprintf(s.String,"JMPTAB 0x%X",65536-ROUTINESLIBSIZE);
	ASMoutput->Add(s);
	//ASMoutput->Add("JMPTAB 0xDE40");			//Itt kell vltoztatni ha a FIX ROUTINES kdmret nvekszik
	
	//ROUTINES AND STACK - at the end of memory
	//Stack ~110 byte provided
	ASMoutput->Add(";ROUTINES");
	sprintf(s.String,"ORG 0x%X",65536-ROUTINESLIBSIZE);
	ASMoutput->Add(s);
	//ASMoutput->Add("ORG 0xDE40");				//Itt kell vltoztatni ha a FIX ROUTINES kdmret nvekszik
	for(y=Macro->Count-1;y>=0;y--){
		s=Macro->Strings[y];
		if((s.AnsiPos("#ENDMACRO"))==1){
			break;
		}
	}
	y++;
	for(;y<Macro->Count;y++){
		s=Macro->Strings[y];
		ASMoutput->Add(s);
	}
	
	delete Macro;
	//delete ASMoutput;
	return 0;
}

void  CompilerForm::OnKeyDown(WPARAM w)
{
	char Key=(char)w;
	if(Key==13){
		Button1Click();    	
	}
	if(w==VK_ESCAPE){
		ModalResult(mrCancel);
	}
}
//---------------------------------------------------------------------------

AnsiString  CompilerForm::ConvertString(AnsiString s){
	AnsiString res="",z,g,m;
	int x;
	printnum++;
	s.Delete(1,1);
	s.Delete(s.Length(),1);

	z.Sprintf("%d",printnum);
	ASMoutput->Add(u+"JMP printatugr"+z);
	
	g.Sprintf("%d",s.Length()+5);
	m="";
	m=m+"ENSLEN "+g;
	ASMoutput->Add(m);

	res=u+"PSTRING"+z;
	ASMoutput->Add(res+":");
	
	for(x=1;x<=s.Length();x++ ){
		if(s[x]==39)
			break;
		g.Sprintf("%X",s[x]);
		if(g.Length()>2 )g.Delete(1,g.Length()-2);
		ASMoutput->Add(u+"DB 0x"+g);
	}

	ASMoutput->Add("DB 0x00");
	ASMoutput->Add(u+"printatugr"+z+":");

	return res;
}

void  CompilerForm::setASMsource(TStringList*ASMsource){
	ASMoutput=ASMsource;
}

int  CompilerForm::BasicStrLen(AnsiString name){
	int x;
	for(x=0;x<Vcnt;x++){
		if((V[x].type==2)&&(V[x].array)){
			if(!strcmp(V[x].name.String,name.String))
				return V[x].dimX;
		}
	}
	return -1;
}
