//MainForm
#ifndef CompilerFormH
#define CompilerFormH

#include "..\FormClass.h"
#include "..\ButtonClass.h"
#include "..\AnsiString.h"
#include "..\hinstance.h"
#include "..\TRadioButton.h"
#include "..\LabelClass.h"
#include "..\TCheckBox.h"
#include "..\TStringListClass.h"

//#include "resource.h"
#include "CMDtypes.h"

//************************************************
// Ha a ROUTINES ASM kdmret n (vagy az op.rsz.)
// akkor a kdban itt kell megvltoztatni a 
// ROUTINES knyvtr mrett
// Ez a terlet magbvan foglalja a STACK-ot 
// STACK = 110 byte
//************************************************
#define ROUTINESLIBSIZE 13280

class CompilerForm : public FormClass{
public:
	CompilerForm(HWND Owner,int Resource);
	~CompilerForm();
	void BuildForm(HWND hwnd,HINSTANCE hInst);
	void DestroyForm();
	void OnCommand(WORD command);

	Label* Label1;
	Label* Label2;
	Label* Label3;
	TRadioButton* RadioButton1;
	TRadioButton* RadioButton2;
	TCheckBox* CheckBox1;
	TCheckBox* CheckBox2;
	TCheckBox* CheckBox3;
	TCheckBox* CheckBox4;
	Button* Button1;
	Button* Button2;
	
	void  Button2Click();
	void  Button1Click();
	void  FormCreate();
	void  OnKeyDown(WPARAM w);
	void  RadioButton1Click();
	void  RadioButton2Click();
	void  CheckBox1Click();
	void  CheckBox2Click();
	void  CheckBox3Click();
	void  CheckBox4Click();
	
	//1=Start compilation immediately and no "Success" message
	int AutomatedMode;
	
private:	// User declarations
	int Compile();
	TStringList* MASMoutput;
	TStringList* ASMoutput;
	TStringList* BINoutput;

	int commandCNTR;
	command* CMD;
	int CMDnum;
	variable V[5000];
	int Vcnt;

	data_read* DATA;	//maximum 1000 DATA commands
public:
	void  SplitBySpace(AnsiString cmd);
	void  SplitByComma(AnsiString cmd);
	AnsiString R1;//Command splitted parts
	AnsiString R2;
	AnsiString R3;
	AnsiString R4;
	AnsiString R5;
	AnsiString R6;
private:
	AnsiString  GetFirstVariableName(AnsiString line);

	void  PutVariable(AnsiString name);
	void  GetVariable(AnsiString name);
	AnsiString   SplitArrayVariableName(AnsiString name, AnsiString &X, AnsiString &Y);
	void  EvaluateExpression(AnsiString expr);
	void  EvaluateBooleanExpression(AnsiString expr);
	void  BracketRecursive(AnsiString expr);

	void  ProcessCommand(command* COMMAND);
	void  ErrorMSG(AnsiString msg);

	int   IsNumber(AnsiString str);
	void  RandSeed();
	int   RandomNumber(int randmax);
	int MaxColorDepth;
	int MaxX,MaxY;
	void  DrawTo(int x,int y);
	void  VerShiftGrLine(int line,char dir);
	void  HorShiftGrLine(int line,char dir);
	void  PutPattern(AnsiString name,int x,int y,int px,int py);
	void  GetPattern(AnsiString name,int x,int y,int px,int py);
	void  UpdateScr();	
	int   KeybInput();
	int   WaitKey();

	void  OptimalizeMasm();
	void  ComputeOptR2();
	void  ComputeOptR3();
	
	int   MasmToAsm();
	int   MasmToAsmPag();

	char SR1full;

	AnsiString 	ConvertString(AnsiString s);
	int printnum;
	int StringDollar;
	
	AnsiString u;
	
	int BasicStrLen(AnsiString name);

public:		// User declarations
	AnsiString DESTfile;	//binary destination file name
	//AnsiString AsmFile;
	TStringList* commands;
	int errorlinenum;
	void  MakeCommandlist();
	void  DestroyCommandlist();
	
	void setASMsource(TStringList*ASMsource);

	//enable generate files:
	char fgenMASM;
	char fgenASM;
	char fgenHEX;
	char fgenOBJ;
	
	//Check defaultly fgenASM
	char CheckGenASM;
	
	//multipages
	char multipages;
};

#endif
