//Barany CPU downloader
#include "BaranyDwnld.h"

BaranyDwnld::BaranyDwnld(){
//	ftHandle=NULL;
	strcpy(PortSelected,"Com1");
}

BaranyDwnld::~BaranyDwnld(){
//	if(ftHandle)Close();
}

//***********************************************************
//     FT I/O
//***********************************************************

int BaranyDwnld::Open(){
#ifdef LOGFTIO
	Log=fopen("FTlog.log","wb");
#endif
	
#ifndef DEBUG_NO_HW_ACCESS
	char errormsg[100];
	//COM port open
	m_hCom = CreateFile(PortSelected, 
		GENERIC_READ | GENERIC_WRITE,
		0, // exclusive access
		NULL, // no security
		OPEN_EXISTING,
		FILE_FLAG_OVERLAPPED, // overlapped I/O
		NULL); // null template 
		
	if(m_hCom==INVALID_HANDLE_VALUE){
		strcpy(errormsg,"ERROR: COM PORT opening failed: ");
		strcat(errormsg,PortSelected);
		ShowError(errormsg,"COM error");
		return 0;
	}
	
	if (!SetCommMask(m_hCom,EV_RXCHAR/*|EV_TXEMPTY*/)){
		ShowError("ERROR: SetCommMask failed","COM error");
		return 0;
	}
	
	m_bPortReady = SetupComm(m_hCom, 128, 128); // set buffer sizes
	if(!m_bPortReady){
		ShowError("ERROR: SetupComm failed","COM error");
		return 0;
	}
	m_bPortReady = GetCommState(m_hCom, &m_dcb);
	if(!m_bPortReady){
		ShowError("ERROR: GetCommState failed","COM error");
		return 0;
	}
	
	m_dcb.BaudRate = 57600;
	m_dcb.ByteSize = 8;
	m_dcb.Parity = NOPARITY;
	m_dcb.StopBits = ONESTOPBIT;
	m_dcb.fAbortOnError = false;
	m_bPortReady = SetCommState(m_hCom, &m_dcb);
	if(!m_bPortReady){
		ShowError("ERROR: SetCommState failed","COM error");
		return 0;
	}
	
	m_bPortReady = GetCommTimeouts (m_hCom, &m_CommTimeouts);
	if(!m_bPortReady){
		ShowError("ERROR: GetCommTimeouts failed","COM error");
		return 0;
	}

	m_CommTimeouts.ReadIntervalTimeout = MAXDWORD; //50;
	m_CommTimeouts.ReadTotalTimeoutConstant = 0; //50;
	m_CommTimeouts.ReadTotalTimeoutMultiplier = 0; //10;
	m_CommTimeouts.WriteTotalTimeoutConstant = 0; //50;
	m_CommTimeouts.WriteTotalTimeoutMultiplier = 0; //10;
	m_bPortReady = SetCommTimeouts (m_hCom, &m_CommTimeouts);
	if(!m_bPortReady){
		ShowError("ERROR: SetCommTimeouts failed","COM error");
		return 0;
	}

	return 1;
#endif

#ifdef DEBUG_HW_EMU
	EmuState=0;
	return 1;
#endif

/*
	ftStatus = FT_Open(0,&ftHandle); 
	if (ftStatus != FT_OK) {
		ShowError("ERROR: FTDI opening failed (6)","FTDI error");
		return 0;
	}
	
	ftStatus = FT_SetBaudRate(ftHandle, 57600);
	if (ftStatus != FT_OK) {
		ShowError("ERROR: setting baud failed (7)","FTDI error");
		Close();
		return 0;		
	}
	
	ftStatus = FT_SetDataCharacteristics(ftHandle, FT_BITS_8, FT_STOP_BITS_1, FT_PARITY_NONE);
	if (ftStatus != FT_OK) {
		ShowError("ERROR: setting FTDI failed (8)","FTDI error");
		Close();
		return 0;		
	}
	
	ftStatus = FT_SetTimeouts(ftHandle, 5000, 1000); 
	if (ftStatus != FT_OK) {
		ShowError("ERROR: setting FTDI failed (9)","FTDI error");
		Close();
		return 0;		
	}
	
	ftStatus = FT_SetFlowControl(ftHandle, FT_FLOW_NONE, 0, 0);
	if (ftStatus != FT_OK) {
		ShowError("ERROR: setting FTDI failed (10)","FTDI error");
		Close();
		return 0;		
	}
	return 1;
	
*/
}

void BaranyDwnld::Close(){	
#ifdef LOGFTIO
	fclose(Log);
#endif

#ifndef DEBUG_NO_HW_ACCESS
	CloseHandle(m_hCom);
#endif

/*
	if(!ftHandle)return;
	FT_Close(ftHandle);
	ftHandle=NULL;
*/
}

int BaranyDwnld::Write(char*buf,int len){
#ifdef LOGFTIO
	int lx;
	for(lx=0;lx<len;lx++)
		fputc(buf[lx],Log);
#endif
	
#ifndef DEBUG_NO_HW_ACCESS
	OVERLAPPED ov;
	memset(&ov,0,sizeof(ov));
	ov.hEvent = CreateEvent( 0,true,0,0);
	DWORD errcode;
	
	bWriteRC = WriteFile(m_hCom,buf,len,&iBytesWritten,&ov);
	if(bReadRC==false){
		errcode=GetLastError();
		if(errcode==ERROR_IO_PENDING){
			WaitForSingleObject(ov.hEvent ,INFINITE);
		}else{
			char errstr[200];
			sprintf(errstr,"ERROR: COM PORT writing failed with: %d",errcode);
			ShowError(errstr,"COM error");
			return 0;
		}
	}
	
	CloseHandle(ov.hEvent);
	
	return 1;//iBytesWritten;	
#endif

#ifdef DEBUG_HW_EMU
	if(strstr(buf,"Reset"))
		EmuState=1;
	else if(strstr(buf,"ProgStart"))
		EmuState=2;
	else if(strstr(buf,"Set"))
		EmuState=4;
	else if(strstr(buf,"ResSet"))
		EmuState=5;
	else EmuState=3;
#endif

/*
	if(!ftHandle)return 0;
	
	DWORD BytesWritten;
	ftStatus = FT_Write(ftHandle, buf, len, &BytesWritten); 
	if (ftStatus != FT_OK) {
		ShowError("ERROR: FTDI write failed (11)","FTDI error");
		return 0;		
	}

	if (BytesWritten>=len) {
		return len;
	}else{
		ShowError("ERROR: FTDI write failed (len) (12)","FTDI error"); 
		return 0;
	}
	return len;
*/
}

int BaranyDwnld::Read(char*buf){
#ifndef DEBUG_NO_HW_ACCESS
	DWORD dwEventMask=0;
	OVERLAPPED ov;
	memset(&ov,0,sizeof(ov));
	ov.hEvent = CreateEvent( 0,true,0,0);
	DWORD dwWait;
	
	bReadRC = WaitCommEvent(m_hCom,&dwEventMask, &ov) ;
	if (!bReadRC){
		char errstr[200];
		DWORD errcode;
		errcode=GetLastError();
		if(errcode!=ERROR_IO_PENDING){
			sprintf(errstr,"ERROR: WaitCommEvent failed with: %d",errcode);
			ShowError(errstr,"COM error");
			return 0;
		}
	}
	//dwWait = WaitForMultipleObjects (1,&(ov.hEvent),FALSE,1000);
	dwWait = WaitForSingleObject(ov.hEvent,5000);	//modified from 1000 to 5000 !
	switch ( dwWait ){
		case WAIT_OBJECT_0:
			
			//TEST if which event occured
			DWORD dwMask;
			if (GetCommMask(m_hCom,&dwMask)){
				if ( dwMask == EV_TXEMPTY ){
					//ShowMessage("EV_TXEMPTY event occured");
					ResetEvent ( ov.hEvent );
					break;
				}
				/*
				if ( dwMask == EV_RXCHAR ){
					ShowMessage("EV_RXCHAR event occured");
					ResetEvent ( ov.hEvent );
					break;
				}
				*/
			}else{
				ShowError("ERROR: GetCommMask failed","COM error");
				return 0;
			}
			
			OVERLAPPED ovRead;
			memset(&ovRead,0,sizeof(ovRead));
			ovRead.hEvent = CreateEvent( 0,true,0,0);

			ResetEvent(ovRead.hEvent);
			bReadRC=ReadFile(m_hCom,buf,1024,&iBytesRead,&ovRead);
			if (!bReadRC ) {
				ShowError("ERROR: COM reading failed","COM error");
				return 0;
			}

			CloseHandle(ovRead.hEvent );
			ResetEvent ( ov.hEvent );
			
			break;
		case WAIT_TIMEOUT:
			ShowError("ERROR: reading timeout","COM error");
			return 0;
			break;
		case WAIT_FAILED:
			ShowError("ERROR: reading wait failed","COM error");
			return 0;
			break;
	}
	
	CloseHandle(ov.hEvent );
	return iBytesRead;
#endif

#ifdef DEBUG_HW_EMU
//HW emulation states:
//0-undefined
//1-Reset
//2-ProgStart
//3-data sent
//4-Set:
//5-ResSet
	switch(EmuState){
		case 0:
			iBytesRead=0;
			break;
		case 1:
			iBytesRead=12;
			strcpy(buf,"SAMUBARI2010");
			break;
		case 2:
			iBytesRead=5;
			strcpy(buf,"ACK:8");
			break;
		case 4:
			iBytesRead=5;
			strcpy(buf,"ACK:8");
			break;
		case 5:
			iBytesRead=5;
			strcpy(buf,"ACK:8");
			break;
		default:
			iBytesRead=6;
			strcpy(buf,"ACK:10");
			break;
	}
#endif
	
#ifdef LOGFTIO
	int lx;
	for(lx=0;lx<iBytesRead;lx++)
		fputc(buf[lx],Log);
	return iBytesRead;
#endif
	
/*
	if(!ftHandle)return 0;
		
	DWORD TxBytes; 
	DWORD RxBytes;
	DWORD EventDWord;
	DWORD BytesWritten;
	HANDLE hEvent;
	DWORD EventMask;
	hEvent = CreateEvent(NULL,false,false,"");
	EventMask = FT_EVENT_RXCHAR;
	ftStatus = FT_SetEventNotification(ftHandle,EventMask,hEvent);
	WaitForSingleObject(hEvent,5000);
	
	FT_GetStatus(ftHandle,&RxBytes,&TxBytes,&EventDWord);
	if (RxBytes > 0) {
		ftStatus = FT_Read(ftHandle,buf,1024,&BytesWritten); 
		if (ftStatus == FT_OK) {
			
			#ifdef LOGFTIO
			int lx;
			for(lx=0;lx<RxBytes;lx++)
				fputc(buf[lx],Log);
			char str[100];
			sprintf(str,"Ennyi karakter jtt:%dDARAB");
			ShowMessage(str);
			#endif
			
			return RxBytes;
		} else {
			ShowError("ERROR: FTDI reading failed (13)","FTDI error"); 
			return 0;
		}
	}else{
		ShowError("ERROR: FTDI reading timeout (14)","FTDI error"); 
		return 0;
	}
*/
}
//***********************************************************
//      Commands
//***********************************************************
int BaranyDwnld::Connect(){
	int res;
	char buf[20];
	int x;
	for(x=0;x<20;x++)buf[x]=0;
	res=Write("Reset",5);
	if(!res){
		ShowError("ERROR: Connection failed, writing error","Programmer error");
		return 0;
	}
	
	res=Read(buf);
	if(!res){
		ShowError("ERROR: Connection failed, reading failed","Programmer error");
		return 0;
	}
	if((res>=0)&&(res<20))buf[res]=0;
	
	if((res<12)||(strcmp(buf,"SAMUBARI2010"))){
		ShowError("ERROR: Programmer does not connect (15)","Programmer error");
		return 0;
	}
	
	return 1;
}

int BaranyDwnld::Disconnect(){
	int res;
	char buf[20];
	int x;
	
	//Set : DMA stop
	for(x=0;x<20;x++)buf[x]=0;
	strcpy(buf,"Set:");
	buf[7]=0;	//DMA enable
	buf[8]=7;	//CLK source
	res=Write(buf,9);
	if(!res){
		ShowError("ERROR: Programmer disconnecting error (20)","Programmer error");
		return 0;
	}
	
	res=Read(buf);
	if(!res){
		ShowError("ERROR: Programmer disconnecting error (21)","Programmer error");
		return 0;
	}
	buf[3]=0;
	
	if((res<3)||(strcmp(buf,"ACK"))){
		ShowError("ERROR: Programmer disconnecting error (22)","Programmer error");
		return 0;
	}

	//ResSet
	for(x=0;x<20;x++)buf[x]=0;
	res=Write("ResSet",6);
	if(!res)return 0;
	
	res=Read(buf);
	if(!res)return 0;
	buf[3]=0;
	
	if((res<3)||(strcmp(buf,"ACK"))){
		ShowError("ERROR: Programmer disconnecting error (16)","Programmer error");
		return 0;
	}
	
	return 1;
}

int BaranyDwnld::Program80byteIn(char* data,unsigned long addr){
	int res;
	char buf[20];
	strcpy(buf,"ProgStart");
	buf[9]=addr&0xFF;
	buf[10]=(addr>>8)&0xFF;
	res=Write(buf,11);
	if(!res)return 0;
	
	res=Read(buf);
	if(!res)return 0;
	buf[3]=0;
	
	if((res<3)||(strcmp(buf,"ACK"))){
		ShowError("ERROR: Programming: ACK lost (17)","Programmer error");
		return 0;
	}
	
	res=Write(data,80);
	if(!res)return 0;
	
	res=Read(buf);
	if(!res)return 0;
	buf[3]=0;
	
	if((res<3)||(strcmp(buf,"ACK"))){
		ShowError("ERROR: Programming: ACK lost (18)","Programmer error");
		return 0;
	}
	
}

int BaranyDwnld::Program(AnsiString fname, int mode){
	char buf[80];
	unsigned long addr=0;
	int x;
	
	QWORD Nbytes=FileSize(fname.String)/((mode==1)?1:14);
	if(Nbytes==0){
		ShowError("ERROR: File seems to be NULL sized","Programmer error");
		return 0;
	}
	
	f=fopen(fname.String,"rb");
	
	if(Nbytes<=65536){
		while(!feof(f)){
			for(x=0;x<80;x++){
				buf[x]=(mode==1)?fgetc(f):GetHex();
				if(feof(f))
					break;
			}
			Program80byteIn(buf,addr);
			addr+=80;
			ShowStatus(addr*100/Nbytes);
		}
	}else{
		if(Nbytes>1081344){
			ShowError("ERROR: File too big, unable to download","Programmer error");
			return 0;
		}
		if(mode!=1){
			ShowError("ERROR: Can not download Hex file in Paged mode","Programmer error");
			return 0;
		}
		
		QWORD PageData = Nbytes-32768;
		QWORD Programmed=0;
		int page;
		int cx,z;
		int CX,Z;
		long CPUaddr=0;
		//lapok kiirsa
		for(page=0;page<32;page++){
			if(PageData&0x80000000)break;
			//lapvlts
			buf[0]=page;
			Program80byteIn(buf,0xC007);
			//laptrdels ciklusok szmitsa
			if(PageData>=32768){
				CX=409;
				Z=48;
			}else{
				CX=PageData/80;
				Z=PageData%80;
			}
			PageData-=32768;
			//lap kiirsa
			CPUaddr=0;
			for(cx=0;cx<CX;cx++){
				for(z=0;z<80;z++){
					buf[z]=fgetc(f);
				}
				Program80byteIn(buf,CPUaddr);
				CPUaddr+=80;
				Programmed+=80;
				ShowStatus(Programmed*100/Nbytes);
			}
			for(z=0;z<Z;z++){
				buf[z]=fgetc(f);
			}
			Program80byteIn(buf,CPUaddr);
		}
		//fix lap kiirsa
		//vigyzat !! az utols maradk 48 byte-ot nem irja ki ! -> EZ A STACK helye!
		CPUaddr=32768;
		for(cx=0;cx<409;cx++){
			for(z=0;z<80;z++){
				buf[z]=fgetc(f);
			}
			Program80byteIn(buf,CPUaddr);
			CPUaddr+=80;
			Programmed+=80;
			ShowStatus(Programmed*100/Nbytes);
		}
		//lapvlts vissza 0-s lapra
		buf[0]=0;
		Program80byteIn(buf,0xC007);
	}
	
	fclose(f);
	return 1;
}

char BaranyDwnld::GetHex(){
	int x;
	char H,L;
	for(x=0;x<10;x++)fgetc(f);
	H=fgetc(f);
	L=fgetc(f);
	while(!feof(f)){
		if(fgetc(f)==13)break;
	}
	fgetc(f);
	return HEX(H)*16+HEX(L);
}

char BaranyDwnld::HEX(char hex){
	switch(hex){
	case '0':
		return 0;
	case '1':
		return 1;
	case '2':
		return 2;
	case '3':
		return 3;
	case '4':
		return 4;
	case '5':
		return 5;
	case '6':
		return 6;
	case '7':
		return 7;
	case '8':
		return 8;
	case '9':
		return 9;
	case 'A':
		return 10;
	case 'B':
		return 11;
	case 'C':
		return 12;
	case 'D':
		return 13;
	case 'E':
		return 14;
	case 'F':
		return 15;
	}
	return 0;
}
