//Barany CPU downloader
#ifndef BaranyDwnldH
#define BaranyDwnldH
#include "..\AnsiString.h"

/*
#ifdef DEBUG
#include "FTD2XXsimu.h"
#else
#include "FTD2XX.H"
#endif
*/

//DEBUGGING switches: Switch on all 3 if you want HW emulation and Logging
//RELEASE: Switch all OFF
//Logging all FT I/O communication
//#define LOGFTIO
//Disable Real HW access , (only logging)
//#define DEBUG_NO_HW_ACCESS
//Enable HW emulation
//#define DEBUG_HW_EMU


#ifdef DEBUG_HW_EMU
//HW emulation states:
//0-undefined
//1-Reset
//2-ProgStart
//3-data sent
//4-Set:
//5-ResSet
static int EmuState=0;
#endif

#ifdef LOGFTIO
static FILE*Log;	
#endif

class BaranyDwnld{
public:
	BaranyDwnld();
	~BaranyDwnld();
/*
	FT_HANDLE ftHandle; 
	FT_STATUS ftStatus;
*/
	
	//FT I/O
	int Open();
	void Close();
	int Write(char*buf,int len);
	int Read(char*buf);
	//Commands
	int Connect();
	int Disconnect();
	int Program(AnsiString fname, int mode);
	int Program80byteIn(char* data,unsigned long addr);
	char GetHex();
	char HEX(char hex);

	char PortSelected[10];
	
	void ShowStatus(int x);
	
private:
	FILE*f;
	
	//COM tartozkai
	BOOL     m_bPortReady;
	HANDLE   m_hCom;
	DCB      m_dcb;
	COMMTIMEOUTS m_CommTimeouts;
	BOOL     bWriteRC;
	BOOL     bReadRC;
	DWORD	 iBytesWritten;
	DWORD	 iBytesRead;

};

#endif
