//LIBrary for simulate FTDI chip driver and Barany program downloader

#include <windows.h>
#include <stdio.h>

typedef PVOID	FT_HANDLE;
typedef ULONG	FT_STATUS;
FILE*g;

enum {
    FT_OK,
    FT_INVALID,
};

enum {
	NoCMD,
    ResetCMD,
    ResSetCMD,
	ProgStartCMD
};

static int state=NoCMD;

FT_STATUS FT_Open(int deviceNumber,FT_HANDLE *pHandle){
	*pHandle=(FT_HANDLE)100;
	return FT_OK;
}

FT_STATUS FT_Close(FT_HANDLE ftHandle){
	return FT_OK;
}

FT_STATUS FT_Read(FT_HANDLE ftHandle,LPVOID lpBuffer,DWORD nBufferSize,LPDWORD lpBytesReturned){
	if(state==ResetCMD){
		strcpy((char*)lpBuffer,"SAMUBARI2010");
		*lpBytesReturned=12;
	}else{
		strcpy((char*)lpBuffer,"ACK: ");
		*lpBytesReturned=5;
	}
	state=NoCMD;

	return FT_OK;
}

FT_STATUS FT_Write(FT_HANDLE ftHandle,LPVOID lpBuffer,DWORD nBufferSize,LPDWORD lpBytesWritten){
	char* buf=(char*)lpBuffer;
	
	//MessageBox(NULL,lpBuffer,"MESSAGE",0);
	//MessageBox(NULL,buf,"MESSAGE",0);
	
	if((buf[0]=='R')&&(buf[1]=='e')&&(buf[2]=='s')&&(buf[3]=='e')&&(buf[4]=='t'))
		state=ResetCMD;

	if((buf[0]=='R')&&(buf[1]=='e')&&(buf[2]=='s')&&(buf[3]=='S')&&(buf[4]=='e')&&(buf[5]=='t'))
		state=ResSetCMD;
	
	if((buf[0]=='P')&&(buf[1]=='r')&&(buf[2]=='o')&&(buf[3]=='g')
		&&(buf[4]=='S')&&(buf[5]=='t')&&(buf[6]=='a')&&(buf[7]=='r')&&(buf[8]=='t'))
		state=ProgStartCMD;
	
	if(state==ResetCMD)
		g=fopen("DwnldSimu.binary","w");
	else
		g=fopen("DwnldSimu.binary","a");
	
	int x;
	for(x=0;x<nBufferSize;x++)
		fputc(buf[x],g);
	fclose(g);
	
	*lpBytesWritten=nBufferSize;
	return FT_OK;
}

FT_STATUS FT_SetBaudRate(FT_HANDLE ftHandle,ULONG BaudRate){
	return FT_OK;
}

FT_STATUS FT_SetDataCharacteristics(FT_HANDLE ftHandle,UCHAR WordLength,UCHAR StopBits,UCHAR Parity){
	return FT_OK;
}

FT_STATUS FT_SetTimeouts(FT_HANDLE ftHandle,ULONG ReadTimeout,ULONG WriteTimeout){
	return FT_OK;
}

FT_STATUS FT_SetFlowControl(FT_HANDLE ftHandle,USHORT FlowControl,UCHAR XonChar,UCHAR XoffChar){
	return FT_OK;
}

FT_STATUS FT_GetStatus(FT_HANDLE ftHandle,DWORD *dwRxBytes,DWORD *dwTxBytes,DWORD *dwEventDWord){
	if(state==ResetCMD){
		*dwRxBytes=12;
	}else{
		*dwRxBytes=5;
	}
	return FT_OK;
}

FT_STATUS FT_SetEventNotification(FT_HANDLE ftHandle,DWORD Mask,PVOID Param){
	SetEvent((HANDLE)Param);
	return FT_OK;
}
