//EditBox Class

#include "EditClass.h"
#include "Windowsx.h"

extern int IDord;


EditBox::EditBox(HWND hwnd,HINSTANCE hinst,char* Caption,int* Size):
Text(this, &EditBox::GetText, &EditBox::SetText, &EditBox::GetRefText)
{
    EditBoxHwnd =
    CreateWindowEx(/*WS_EX_DLGMODALFRAME |*/ WS_EX_CLIENTEDGE,
                   "EDIT",
                   Caption,
                   WS_CHILD | WS_VISIBLE | ES_LEFT,
                   Size[0],Size[1],Size[2],Size[3],
                   hwnd,(HMENU)IDord,hinst,0);


    ID=IDord++;
	hFont=NULL;
	
	EditProcAddr = (WNDPROC)GetWindowLong(EditBoxHwnd, GWL_WNDPROC);
	SetWindowLong(EditBoxHwnd, GWL_WNDPROC, reinterpret_cast<LONG_PTR>(&EditBox::StatWndProc));
}

EditBox::~EditBox(){
	//if(hFont)DeleteObject(hFont);
}

void EditBox::SetText(const AnsiString & str){
    Edit_SetText(EditBoxHwnd,str.String);
    TextStr=str;
}

const AnsiString & EditBox::GetText() const{
    char * text=(char*)TextStr.String;
    Edit_GetText(EditBoxHwnd,text,254);
    return TextStr;
}

AnsiString & EditBox::GetRefText(){
    return TextStr;
}

void EditBox::Clear(){
    Edit_SetText(EditBoxHwnd,"");
}

void EditBox::ReadOnly(bool RO){
	Edit_SetReadOnly(EditBoxHwnd,RO);
}

void EditBox::SetDefFont(){
	hFont = CreateFont(-11,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_OUTLINE_PRECIS,
                CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, VARIABLE_PITCH,TEXT("Tahoma"));
	SendMessage(EditBoxHwnd,WM_SETFONT ,(WPARAM)hFont,true);
}

HWND EditBox::Handle(){
	return EditBoxHwnd;
}
