//TStringLongIntList Class
#include "TStringLongIntList.h"

TStringLongIntList::TStringLongIntList(){
	Root=NULL;
	Tail=NULL;
	Act=NULL;
	ActIndex=0;
	Strings.Own=this;
	Ints.Own=this;
	Longs.Own=this;
	Count=0;
}

TStringLongIntList::~TStringLongIntList(){
	Clear();
}

bool TStringLongIntList::LoadFromFile(char* fname){
	FILE*f;
	Clear();
	if(!( f=fopen(fname,"rb"))){
		ShowError("ERROR: File open error!", "TStringLongIntList::LoadFromFile");
		return false;
	}
	char c;
	char str[AnsiStringMAXLEN];
	int strp=0;
	while(!feof(f)){
		c=fgetc(f);
		if((c==10)||(c==13)){
			c=fgetc(f);
			str[strp]=0;
			strp=0;
			Add(str);
			continue;
		}
		if(feof(f)){
			str[strp]=0;
			Add(str);
		}
		str[strp++]=c;
		if(strp>=AnsiStringMAXLEN-2){
			str[strp]=0;
			strp=0;
			Add(str);
		}
	}
	fclose(f);
	
	return true;
}

bool TStringLongIntList::LoadFromFile(AnsiString& fname){
	return LoadFromFile(fname.String);
}

bool TStringLongIntList::SaveToFile(char* fname){
	FILE*f;
	if(!( f=fopen(fname,"wb"))){
		ShowError("ERROR: File open error!", "TStringLongIntList::SaveToFile");
		return false;
	}
	TextIntElem* p;
	int strp;
	for(p=Root;p!=NULL;p=p->FW){
		strp=0;
		while((strp<AnsiStringMAXLEN)&&(p->Element.String[strp])){
			fputc(p->Element.String[strp],f);
			strp++;
		}
		fputc(13,f);
		fputc(10,f);
	}
	fclose(f);
	
	Act=Root;
	ActIndex=0;
	return true;	
}

bool TStringLongIntList::SaveToFile(AnsiString& fname){
	return SaveToFile(fname.String);
}

void TStringLongIntList::Insert(long i, char* str){
	if((Count==0)||(i>=Count)){
		ShowError("ERROR: index exceeds bound", "TStringLongIntList::Insert");
		return;	
	}
	if(Count>COUNTMAX-1){
		ShowError("ERROR: list too long", "TStringLongIntList::Add");
		return;		
	}
	TextIntElem* p=GetElemByIndex(i);
	TextIntElem* N=new TextIntElem();
	N->Element=str;
	N->IntElem=0;
	N->LongElem=0;
	
	if(!p->BK){
		N->BK=NULL;
		N->FW=Root;
		Root->BK=N;
		Root=N;
		Act=N;
		ActIndex=0;
		Count++;
	}else{
		N->FW=p;
		N->BK=p->BK;
		p->BK->FW=N;
		p->BK=N;
		Act=N;
		ActIndex=i;
		Count++;
	}
}

void TStringLongIntList::Insert(long index, AnsiString str){
	Insert(index,str.String);
}

void TStringLongIntList::Insert(unsigned index, AnsiString str){
	Insert((long)index,str.String);
}

void TStringLongIntList::Insert(unsigned i, char* str){
	Insert((long)i,str);
}

void TStringLongIntList::Clear(){
	TextIntElem* p;
	TextIntElem* q;
	for(p=Root;p!=NULL;p=q){
		q=p->FW;
		delete p;
	}
	Root=NULL;
	Tail=NULL;
	Act=NULL;
	ActIndex=0;
	Count=0;
}

void TStringLongIntList::Delete(unsigned i){
	Delete((long)i);
}

void TStringLongIntList::Delete(int i){
	Delete((long)i);
}

void TStringLongIntList::Delete(long i){
	if((Count==0)||(i>=Count)){
		ShowError("ERROR: index exceeds bound", "TStringLongIntList::Delete");
		return;	
	}
	TextIntElem* p=GetElemByIndex(i);
	if((!p->FW)&&(!p->BK)){
		Root=NULL;
		Tail=NULL;
		Act=NULL;
		ActIndex=0;
		Count=0;
	}else if(!p->FW){
		Tail=p->BK;
		Tail->FW=NULL;
		Act=Tail;
		Count--;
		ActIndex=Count-1;
	}else if(!p->BK){
		Root=p->FW;
		Root->BK=NULL;
		Act=Root;
		ActIndex=0;
		Count--;
	}else{
		p->BK->FW=p->FW;
		p->FW->BK=p->BK;
		Act=p->FW;
		ActIndex=i;
		Count--;
	}

	delete p;
}

void TStringLongIntList::Add(AnsiString str,int Int,long Long){
	Add(str.String,Int,Long);
}

void TStringLongIntList::Add(char* str,int Int,long Long){
	if(Count>COUNTMAX){
		ShowError("ERROR: list too long", "TStringLongIntList::Add");
		return;		
	}
	if(!Root){
		Root=new TextIntElem();
		if(!Root){
			ShowError("ERROR: new()", "TStringLongIntList::Add");
			return;
		}
		Tail=Root;
		Act=Root;
		ActIndex=0;
		Count=1;
		Root->Element=str;
		Root->IntElem=Int;
		Root->LongElem=Long;
		Root->FW=NULL;
		Root->BK=NULL;
	}else{
		Tail->FW=new TextIntElem();
		if(!Tail->FW){
			ShowError("ERROR: new()", "TStringLongIntList::Add");
			return;
		}
		Tail->FW->BK=Tail;
		Tail=Tail->FW;
		Act=Tail;
		ActIndex++;
		Count++;
		Tail->Element=str;
		Tail->IntElem=Int;
		Tail->LongElem=Long;
		Tail->FW=NULL;
	}
}


void TStringLongIntList::Add(AnsiString str){
	Add(str.String,0,0);
}

void TStringLongIntList::Add(char* str){
	Add(str,0,0);
}

TextIntElem* TStringLongIntList::GetElemByIndex(long i){
	if((Count==0)||(i>=Count)){
		ShowError("ERROR: index exceeds bound", "TStringLongIntList::GetElemByIndex");
		return NULL;	
	}
	long t1,t2,t3,t4,s;
	TextIntElem* fp;
	t1=i;
	t2=Count-1-i;
	t3=i-ActIndex;
	t4=t3;if(t4<0)t4=(-1)*t4;
	if((t1<=t2)&&(t1<=t4)){
		fp=Root;
		for(s=0;s<t1;s++){
			fp=fp->FW;
		}
	}else if((t2<=t1)&&(t2<=t4)){
		fp=Tail;
		for(s=0;s<t2;s++){
			fp=fp->BK;
		}
	}else{
		fp=Act;
		if(t3<0){
			for(s=0;s<t4;s++)
				fp=fp->BK;
		}
		if(t3>0){
			for(s=0;s<t4;s++)
				fp=fp->FW;
		}
	}
	
	Act=fp;
	ActIndex=i;
	return fp;
}

AnsiString& StringIntElem::operator[] (long i){
	TextIntElem* tmp=Own->GetElemByIndex(i);
	return tmp->Element;
}

AnsiString& StringIntElem::operator[] (unsigned i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->Element;
}

AnsiString& StringIntElem::operator[] (int i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->Element;
}

int& IntElem::operator[] (long i){
	TextIntElem* tmp=Own->GetElemByIndex(i);
	return tmp->IntElem;
}

int& IntElem::operator[] (unsigned i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->IntElem;
}

int& IntElem::operator[] (int i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->IntElem;
}

long& LongElem::operator[] (long i){
	TextIntElem* tmp=Own->GetElemByIndex(i);
	return tmp->LongElem;
}

long& LongElem::operator[] (unsigned i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->LongElem;
}

long& LongElem::operator[] (int i){
	TextIntElem* tmp=Own->GetElemByIndex((long)i);
	return tmp->LongElem;
}
